﻿using UnityEngine;

namespace Mod
{
    public class guraguranomi : MonoBehaviour
    {

        private GameObject hand;

        private GameObject handGlow;

        public void Awake()
        {
            hand = gameObject;

            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, -0.09f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("image/vibration ball.png", 13);
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(255f, 140f, 0f, 0.0001f);
            handSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= 5f)
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
                ModAPI.CreateParticleEffect("Vapor", new Vector2(hand.transform.position.x, hand.transform.position.y + 0.1f));

            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 22;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= 22f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(5f, 5f, 5f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 0.0099f, 0.0099f, 0.0099f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);
            }
        }
    }
}
