using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
  public class Mod
  {

      public static void Main()
        {
      CategoryBuilder.Create("One Piece pack", "Things about one piece", ModAPI.LoadSprite("category.png"));

      ModAPI.Register(
          new Modification()
              {
         OriginalItem = ModAPI.FindSpawnable("Human"),
         NameOverride = "Normal marine",
         NameToOrderByOverride = "Z1",
         DescriptionOverride = "Normal marine,He is a new navy and likes cabbage and Sauerkraut.",
         CategoryOverride = ModAPI.FindCategory("One Piece pack"),
         ThumbnailOverride = ModAPI.LoadSprite("image/Normal marinethumbnail.png"),
         AfterSpawn = (Instance) =>
         {

         var skin = ModAPI.LoadTexture("image/Normal marine.png");
         var flesh = ModAPI.LoadTexture("Flesh.png");
         var bone = ModAPI.LoadTexture("Bone.png");
         var head = Instance.transform.Find("Head");
         var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
         var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
         var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
         var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
         var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
         var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
         var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
         var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
         var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
         var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
         var upper = Instance.transform.Find("Body").Find("UpperBody");
         var middle = Instance.transform.Find("Body").Find("MiddleBody");
         var Lower = Instance.transform.Find("Body").Find("LowerBody");


         upper.transform.localScale = new Vector3(1.2f, 1.2f);
         middle.transform.localScale = new Vector3(1.1f, 1.2f);
         head.transform.localScale = new Vector3(0.9f, 0.9f);
         arm3.transform.localScale = new Vector3(1.18f, 1.2f);
         arm4.transform.localScale = new Vector3(1.18f, 1.2f);
         arm1.transform.localScale = new Vector3(1.18f, 1.2f);
         arm2.transform.localScale = new Vector3(1.18f, 1.2f);
         leg3.transform.localScale = new Vector3(1.19f, 1.2f);
         leg4.transform.localScale = new Vector3(1.19f, 1.2f);
         leg1.transform.localScale = new Vector3(1.19f, 1.2f);
         leg2.transform.localScale = new Vector3(1.19f, 1.2f);
         foot1.transform.localScale = new Vector3(1.19f, 1.2f);
         foot2.transform.localScale = new Vector3(1.19f, 1.2f);

         head.transform.localPosition = new Vector3(0.01f, 0.73f);
         arm3.transform.localPosition = new Vector3(0f, -0.15f);
         arm4.transform.localPosition = new Vector3(0f, -0.15f);
         arm1.transform.localPosition = new Vector3(0f, -0.60f);
         arm2.transform.localPosition = new Vector3(0f, -0.60f);
         leg3.transform.localPosition = new Vector3(0f, -0.46f);
         leg4.transform.localPosition = new Vector3(0f, -0.46f);
         leg1.transform.localPosition = new Vector3(0f, -0.96f);
         leg2.transform.localPosition = new Vector3(0f, -0.96f);
         foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
         foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

         var person = Instance.GetComponent<PersonBehaviour>();
         person.SetBodyTextures(skin, flesh, bone, 1);
         foreach (var body in person.Limbs)
          {
              body.BaseStrength *= 1f;
              body.Health *= 20f;
              body.BreakingThreshold *= 1f;
              body.transform.root.localScale *= 1f;

              head.transform.localScale = new Vector3(0.9f, 0.9f);

          //Marinehat
            var ca = new GameObject("Marinehat");
            ca.transform.SetParent(Instance.transform.Find("Head"));
            ca.transform.localPosition = new Vector3(0, 0f);
            ca.transform.localScale = new Vector3(1f, 1f);
            var caSprite = ca.AddComponent<SpriteRenderer>();
            caSprite.sprite = ModAPI.LoadSprite("image/Marinehat.png");
            ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
            ca.AddComponent<UseEventTrigger>().Action = () => {
            caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                              };




                              }
                          }
                      }
      );



      ModAPI.Register(
          new Modification()
              {
         OriginalItem = ModAPI.FindSpawnable("Human"),
         NameOverride = "Normal pirate",
         NameToOrderByOverride = "Z1",
         DescriptionOverride = "Normal pirate,He likes steaks with dripping blood.",
         CategoryOverride = ModAPI.FindCategory("One Piece pack"),
         ThumbnailOverride = ModAPI.LoadSprite("image/Normal piratethumbnail.png"),
         AfterSpawn = (Instance) =>
         {

         var skin = ModAPI.LoadTexture("image/Normal pirate.png");
         var flesh = ModAPI.LoadTexture("Flesh.png");
         var bone = ModAPI.LoadTexture("Bone.png");
         var head = Instance.transform.Find("Head");
         var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
         var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
         var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
         var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
         var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
         var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
         var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
         var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
         var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
         var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
         var upper = Instance.transform.Find("Body").Find("UpperBody");
         var middle = Instance.transform.Find("Body").Find("MiddleBody");
         var Lower = Instance.transform.Find("Body").Find("LowerBody");


         upper.transform.localScale = new Vector3(1.2f, 1.2f);
         middle.transform.localScale = new Vector3(1.1f, 1.2f);
         head.transform.localScale = new Vector3(0.9f, 0.9f);
         arm3.transform.localScale = new Vector3(1.18f, 1.2f);
         arm4.transform.localScale = new Vector3(1.18f, 1.2f);
         arm1.transform.localScale = new Vector3(1.18f, 1.2f);
         arm2.transform.localScale = new Vector3(1.18f, 1.2f);
         leg3.transform.localScale = new Vector3(1.19f, 1.2f);
         leg4.transform.localScale = new Vector3(1.19f, 1.2f);
         leg1.transform.localScale = new Vector3(1.19f, 1.2f);
         leg2.transform.localScale = new Vector3(1.19f, 1.2f);
         foot1.transform.localScale = new Vector3(1.19f, 1.2f);
         foot2.transform.localScale = new Vector3(1.19f, 1.2f);

         head.transform.localPosition = new Vector3(0.01f, 0.73f);
         arm3.transform.localPosition = new Vector3(0f, -0.15f);
         arm4.transform.localPosition = new Vector3(0f, -0.15f);
         arm1.transform.localPosition = new Vector3(0f, -0.60f);
         arm2.transform.localPosition = new Vector3(0f, -0.60f);
         leg3.transform.localPosition = new Vector3(0f, -0.46f);
         leg4.transform.localPosition = new Vector3(0f, -0.46f);
         leg1.transform.localPosition = new Vector3(0f, -0.96f);
         leg2.transform.localPosition = new Vector3(0f, -0.96f);
         foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
         foot2.transform.localPosition = new Vector3(0.068f, -1.25f);


         var person = Instance.GetComponent<PersonBehaviour>();
         person.SetBodyTextures(skin, flesh, bone, 1);
         foreach (var body in person.Limbs)
          {
              body.BaseStrength *= 1f;
              body.Health *= 20f;
              body.BreakingThreshold *= 1f;
              body.transform.root.localScale *= 1f;

          //
            var ca = new GameObject("Edward Newgate old1");
            ca.transform.SetParent(Instance.transform.Find("Head"));
            ca.transform.localPosition = new Vector3(0, 0f);
            ca.transform.localScale = new Vector3(1f, 1f);
            var caSprite = ca.AddComponent<SpriteRenderer>();
            caSprite.sprite = ModAPI.LoadSprite("image/Edward Newgate old1.png");
            ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
            ca.AddComponent<UseEventTrigger>().Action = () => {
            caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                              };

                              }
                          }
                      }
                  );

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = ""+"\n <color=red>Monkey D. Luffy Ryuo ver",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = ""+"\n <color=white>This form can be used Ryuo, and Haoshoku Haki can be Infusion into the body,This provides tremendous power.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Monkey D. Luffy Ryuo verthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Monkey D. Luffy Ryuo ver.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.2f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<ryuohaoshokuluffy>();
   arm2.gameObject.AddComponent<ryuohaoshokuluffy>();
   arm1.gameObject.AddComponent<Releaseryuo>();
   arm2.gameObject.AddComponent<Releaseryuo>();
   leg1.gameObject.AddComponent<ryuo>();
   leg2.gameObject.AddComponent<ryuo>();



   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 0.2f;
        body.Health *= 1000f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1f;
        body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
        body.gameObject.AddComponent<strongrege>();
        body.gameObject.AddComponent<luffyrege>();
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });


        //hat and cape
         var backpack = new GameObject("hat and cape");
         backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
         backpack.transform.localPosition = new Vector3(0, 0f);
         backpack.transform.localScale = new Vector3(1f, 1f);
         var backpackSprite = backpack.AddComponent<SpriteRenderer>();
         backpackSprite.sprite = ModAPI.LoadSprite("image/hat and cape.png");
         backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
         backpack.AddComponent<UseEventTrigger>().Action = () => {
         backpackSprite.sprite = ModAPI.LoadSprite("none.png");
        };

        var ornamentobject = new GameObject("Luffyhair.png");
        ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
        ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
        ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
        ornamentobject.transform.localScale = new Vector3(1f, 1f);
        var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
        ornamentsprite.sprite = ModAPI.LoadSprite("image/Luffyhair.png",2f);
        ornamentsprite.sortingLayerName = "Middle";



      person.SetBodyTextures(skin, flesh, bone, 1);
      person.SetBruiseColor(000, 000, 000);
      person.SetSecondBruiseColor(000, 000, 0000);
      person.SetThirdBruiseColor(000, 000, 000);
      person.SetBloodColour(000, 000, 000);
      person.SetRottenColour(000, 000, 000);




                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = ""+"\n <color=red>Luffy gear 4 Boundman",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = ""+"\n <color=white>One of the techniques of luffy, this greatly increased the elasticity, tension, and hardness of rubber,This form was created in order to combat the many powerful and large animals on Rusukaina.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Luffy gear 4 Boundmanthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Luffy gear 4 Boundman.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(2.1f, 1.2f);
   middle.transform.localScale = new Vector3(2.1f, 1.2f);
   Lower.transform.localScale = new Vector3(2.1f, 1.2f);

   arm3.transform.localScale = new Vector3(2.3f, 1.51f);
   arm4.transform.localScale = new Vector3(2.3f, 1.51f);
   arm1.transform.localScale = new Vector3(2.3f, 1.51f);
   arm2.transform.localScale = new Vector3(2.3f, 1.51f);
   leg3.transform.localScale = new Vector3(1.2f, 1f);
   leg4.transform.localScale = new Vector3(1.2f, 1f);
   head.transform.localScale = new Vector3(0.8f, 0.8f);


   head.transform.localPosition = new Vector3(0f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.72f);
   arm2.transform.localPosition = new Vector3(0f, -0.72f);

   head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<ryuohaoshokuluffy>();
   arm2.gameObject.AddComponent<ryuohaoshokuluffy>();
   leg1.gameObject.AddComponent<ryuo>();
   leg2.gameObject.AddComponent<ryuo>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 1.4f;
        body.Health *= 100000f;
        body.BreakingThreshold *= 100f;
        body.transform.root.localScale *= 1.03f;
        body.IsAndroid = true;
        body.gameObject.AddComponent<luffyrege>();
        body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
        body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[]
      {
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                  };


        //Boundmansteam
         var backpack = new GameObject("Boundmansteam");
         backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
         backpack.transform.localPosition = new Vector3(0, 0f);
         backpack.transform.localScale = new Vector3(0.7f, 1f);
         var backpackSprite = backpack.AddComponent<SpriteRenderer>();
         backpackSprite.sprite = ModAPI.LoadSprite("image/Boundmansteam.png");
         backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
         backpack.AddComponent<UseEventTrigger>().Action = () => {
         backpackSprite.sprite = ModAPI.LoadSprite("none.png");
        };

        var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


        ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";



         var ornamentobject = new GameObject("Boundmanhair.png");
         ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
         ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
         ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
         ornamentobject.transform.localScale = new Vector3(1f, 1f);
         var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
         ornamentsprite.sprite = ModAPI.LoadSprite("image/Boundmanhair.png",2f);
         ornamentsprite.sortingLayerName = "Middle";


         person.SetBruiseColor(153, 000, 000);
         person.SetSecondBruiseColor(153, 000, 000);
         person.SetThirdBruiseColor(051, 000, 000);
         person.SetBloodColour(255, 000, 000);
         person.SetRottenColour(102, 000, 000);

                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = ""+"\n <color=red>Luffy gear 4 snakeman",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = ""+"\n <color=white>One of the techniques of luffy, this greatly increased the elasticity, tension, and hardness of rubber,The physical ability increases exponentially,and it is a speed-optimized form.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Luffy gear 4 snakemanthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Luffy gear 4 snakeman.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.5f, 1.2f);
   middle.transform.localScale = new Vector3(1.4f, 1.2f);
   Lower.transform.localScale = new Vector3(1.3f, 1.2f);
   head.transform.localScale = new Vector3(0.8f, 0.8f);
   arm3.transform.localScale = new Vector3(1.4f, 1.2f);
   arm4.transform.localScale = new Vector3(1.4f, 1.2f);
   arm1.transform.localScale = new Vector3(1.4f, 1.2f);
   arm2.transform.localScale = new Vector3(1.4f, 1.2f);
   leg3.transform.localScale = new Vector3(1.2f, 1f);
   leg4.transform.localScale = new Vector3(1.2f, 1f);


   head.transform.localPosition = new Vector3(0.01f, 0.71f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);

   AudioClip Repulsor = ModAPI.LoadSound("sssa.mp3");
   AudioClip beam2 = ModAPI.LoadSound("sssa.mp3");

   head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<ryuohaoshokuluffy>();
   arm2.gameObject.AddComponent<ryuohaoshokuluffy>();
   leg1.gameObject.AddComponent<ryuo>();
   leg2.gameObject.AddComponent<ryuo>();
   arm1.gameObject.AddComponent<python1>();
   arm2.gameObject.AddComponent<python1>();

   foreach (var Limbs in person.Limbs)
   {;

       if (Limbs.GetComponent<GripBehaviour>())
       {
           Limbs.gameObject.AddComponent<UseEventTrigger>().Action = () =>
           {


               AudioSource audio = Limbs.gameObject.AddComponent<AudioSource>();
               audio.spatialBlend = 1;
               audio.PlayOneShot(Repulsor);
           };
       }
   }



   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 0.6f;
        body.Health *= 100000f;
        body.BreakingThreshold *= 100f;
        body.transform.root.localScale *= 1.02f;
        body.IsAndroid = true;
        body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
        body.gameObject.AddComponent<luffyrege>();


        body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[]
      {
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                    ModAPI.LoadSound("Sound/gear 4 sound.mp3"),
                                  };


        //snakeman steam
         var backpack = new GameObject("snakeman steam");
         backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
         backpack.transform.localPosition = new Vector3(0, 0f);
         backpack.transform.localScale = new Vector3(0.9f, 1f);
         var backpackSprite = backpack.AddComponent<SpriteRenderer>();
         backpackSprite.sprite = ModAPI.LoadSprite("image/snakeman steam.png");
         backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
         backpack.AddComponent<UseEventTrigger>().Action = () => {
         backpackSprite.sprite = ModAPI.LoadSprite("none.png");
        };

        var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


        ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";



         var ornamentobject = new GameObject("Snakemanhair.png");
         ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
         ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
         ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
         ornamentobject.transform.localScale = new Vector3(1f, 1f);
         var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
         ornamentsprite.sprite = ModAPI.LoadSprite("image/Snakemanhair.png",1.5f);
         ornamentsprite.sortingLayerName = "Middle";


         person.SetBruiseColor(153, 000, 000);
         person.SetSecondBruiseColor(153, 000, 000);
         person.SetThirdBruiseColor(051, 000, 000);
         person.SetBloodColour(255, 000, 000);
         person.SetRottenColour(102, 000, 000);

                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = ""+"\n <color=green>Roronoa Zoro Haoshoku ver",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = ""+"\n <color=white>This form can be used Ryuo, and Haoshoku Haki can be Infusion into the body,This provides tremendous power.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Roronoa Zoro Haoshoku verthumbnial.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Roronoa Zoro Haoshoku ver.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.2f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();



   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 0.2f;
        body.Health *= 1000f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1f;
        body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
        body.gameObject.AddComponent<strongrege>();
        body.gameObject.AddComponent<luffyrege>();
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });


        var ca = new GameObject("zorohat");
        ca.transform.SetParent(Instance.transform.Find("Head"));
        ca.transform.localPosition = new Vector3(0, 0f);
        ca.transform.localScale = new Vector3(1f, 1f);
        var caSprite = ca.AddComponent<SpriteRenderer>();
        caSprite.sprite = ModAPI.LoadSprite("image/zorohat.png");
        ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        ca.AddComponent<UseEventTrigger>().Action = () => {
        caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                           };

        //zoroSwords
         var backpack = new GameObject("zoroSwords");
         backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
         backpack.transform.localPosition = new Vector3(0, 0f);
         backpack.transform.localScale = new Vector3(1f, 1f);
         var backpackSprite = backpack.AddComponent<SpriteRenderer>();
         backpackSprite.sprite = ModAPI.LoadSprite("image/zoroSwords.png");
         backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
         backpack.AddComponent<UseEventTrigger>().Action = () => {
         backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                                  };

      person.SetBodyTextures(skin, flesh, bone, 1);
      person.SetBruiseColor(000, 000, 000);
      person.SetSecondBruiseColor(000, 000, 0000);
      person.SetThirdBruiseColor(000, 000, 000);
      person.SetBloodColour(000, 000, 000);
      person.SetRottenColour(000, 000, 000);


                        }
                    }
                }
);



ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Nami",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Cat Burglar, Nami is the navigator of the Straw Hat Pirates. She is the third member of the crew and the second to join, doing so during the Orange Town Arc.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/namithumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Nami.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");
   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   leg3.transform.localScale = new Vector3(1.12f, 1.2f);
   leg4.transform.localScale = new Vector3(1.12f, 1.2f);
   leg1.transform.localScale = new Vector3(1.12f, 1.2f);
   leg2.transform.localScale = new Vector3(1.12f, 1.2f);
   foot1.transform.localScale = new Vector3(1.12f, 1.2f);
   foot2.transform.localScale = new Vector3(1.12f, 1.2f);

   head.transform.localScale = new Vector3(0.8f, 0.8f);

   head.transform.localPosition = new Vector3(0.01f, 0.69f);

   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.064f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.064f, -1.25f);

   head.transform.localScale = new Vector3(0.8f, 0.8f);

   var person = Instance.GetComponent<PersonBehaviour>();
   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 1f;
        body.Health *= 1000f;
        body.BreakingThreshold *= 1f;
        body.transform.root.localScale *= 1f;

        var bodyuper = Instance.transform.Find("Body").Find("UpperBody");
        bodyuper.localPosition = new Vector3(0.0f, 0.4f);

        Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("image/namibreast.png");
        Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadTexture("image/Fleshbreast.png"));
        Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadTexture("image/Bonebreast.png"));

    //namihair
      var ca = new GameObject("namihair");
      ca.transform.SetParent(Instance.transform.Find("Head"));
      ca.transform.localPosition = new Vector3(0, 0f);
      ca.transform.localScale = new Vector3(1f, 1f);
      var caSprite = ca.AddComponent<SpriteRenderer>();
      caSprite.sprite = ModAPI.LoadSprite("image/namihair.png");
      ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
      ca.AddComponent<UseEventTrigger>().Action = () => {
      caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                        };

                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Usopp",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "God Usopp is the sniper of the Straw Hat Pirates. He is the fourth member of the crew and the third to join.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Usoppthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Usopp.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");
   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.2f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

   var person = Instance.GetComponent<PersonBehaviour>();
   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 1f;
        body.Health *= 100f;
        body.BreakingThreshold *= 1f;
        body.transform.root.localScale *= 1f;


    //Usopp item
    var ca = new GameObject("Usopp item.png");
    ca.transform.SetParent(Instance.transform.Find("Head"));
    ca.transform.localPosition = new Vector3(0, 0f);
    ca.transform.localScale = new Vector3(1f, 1f);
    var caSprite = ca.AddComponent<SpriteRenderer>();
    caSprite.sprite = ModAPI.LoadSprite("image/Usopp item.png");
    ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
    ca.AddComponent<UseEventTrigger>().Action = () => {
    caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                      };

                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Sanji",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Black Leg Sanji born as Vinsmoke Sanji is the cook of the Straw Hat Pirates. He is the fifth member of the crew and the fourth to join, doing so at the end of the Baratie Arc.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Sanjithumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Sanji.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");
   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.2f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();

   var person = Instance.GetComponent<PersonBehaviour>();
   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 0.3f;
        body.Health *= 100f;
        body.BreakingThreshold *= 1f;
        body.transform.root.localScale *= 1f;
        body.IsAndroid = true;
        body.gameObject.AddComponent<strongrege>();
        body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
        body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[]
      {
                                    ModAPI.LoadSound("Sound/a1.wav"),
                                    ModAPI.LoadSound("Sound/a2.wav"),
                                    ModAPI.LoadSound("Sound/a3.wav"),
                                    ModAPI.LoadSound("Sound/a4.wav"),
                                    ModAPI.LoadSound("Sound/a5.wav"),
                                    ModAPI.LoadSound("Sound/a6.wav"),
                                    ModAPI.LoadSound("Sound/a1.wav"),
                                    ModAPI.LoadSound("Sound/a2.wav"),
                                    ModAPI.LoadSound("Sound/a3.wav"),
                                  };
                        }
                    }
                }
);



ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Tony Tony Chopper",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Tony Tony Chopper, also known as Cotton Candy Lover, Chopper is the doctor of the Straw Hat Pirates. He is the sixth member of the crew and the fifth to join, doing so at the end of the Drum Island Arc.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Tony Tony Chopperthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Tony Tony Chopper.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");
   var head = Instance.transform.Find("Head");

   head.transform.localScale = new Vector3(1.2f, 1.2f);
   head.transform.localPosition = new Vector3(0.001f, 0.75f);


   var person = Instance.GetComponent<PersonBehaviour>();
   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 1f;
        body.Health *= 10f;
        body.BreakingThreshold *= 1f;
        body.transform.root.localScale *= 0.98f;

        //Tony Tony Chopperhat
          var ca = new GameObject("Tony Tony Chopperhat");
          ca.transform.SetParent(Instance.transform.Find("Head"));
          ca.transform.localPosition = new Vector3(0, 0f);
          ca.transform.localScale = new Vector3(1f, 1f);
          var caSprite = ca.AddComponent<SpriteRenderer>();
          caSprite.sprite = ModAPI.LoadSprite("image/Tony Tony Chopperhat.png");
          ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
          ca.AddComponent<UseEventTrigger>().Action = () => {
          caSprite.sprite = ModAPI.LoadSprite("none.png");
        };

        //Tony Tony Chopperbag
         var backpack = new GameObject("Tony Tony Chopperbag");
         backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
         backpack.transform.localPosition = new Vector3(0, 0f);
         backpack.transform.localScale = new Vector3(1f, 1f);
         var backpackSprite = backpack.AddComponent<SpriteRenderer>();
         backpackSprite.sprite = ModAPI.LoadSprite("image/Tony Tony Chopperbag.png");
         backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
         backpack.AddComponent<UseEventTrigger>().Action = () => {
         backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                                };



                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Android"),
   NameOverride = "Chopper monster point",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "This form can be powerful.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/ChopperM.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Chopper monster point.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.4f, 1.2f);
   middle.transform.localScale = new Vector3(1.3f, 1.2f);
   Lower.transform.localScale = new Vector3(1.2f, 1f);
   arm3.transform.localScale = new Vector3(1.14f, 1.1f);
   arm4.transform.localScale = new Vector3(1.14f, 1.1f);
   arm1.transform.localScale = new Vector3(1.14f, 1.1f);
   arm2.transform.localScale = new Vector3(1.14f, 1.1f);
   leg3.transform.localScale = new Vector3(1.2f, 1f);
   leg4.transform.localScale = new Vector3(1.2f, 1f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.02f, 0.73f);

   arm3.transform.localPosition = new Vector3(0f, -0.12f);
   arm4.transform.localPosition = new Vector3(0f, -0.12f);
   arm1.transform.localPosition = new Vector3(0f, -0.54f);
   arm2.transform.localPosition = new Vector3(0f, -0.54f);

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 25f;
        body.Health *= 100f;
        body.BreakingThreshold *= 100f;
        body.transform.root.localScale *= 1.07f;
        body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
        body.gameObject.AddComponent<strongrege>();
        body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[]
      {
                                    ModAPI.LoadSound("Sound/a1.wav"),
                                    ModAPI.LoadSound("Sound/a2.wav"),
                                    ModAPI.LoadSound("Sound/a3.wav"),
                                    ModAPI.LoadSound("Sound/a4.wav"),
                                    ModAPI.LoadSound("Sound/a5.wav"),
                                    ModAPI.LoadSound("Sound/a6.wav"),
                                    ModAPI.LoadSound("Sound/a1.wav"),
                                    ModAPI.LoadSound("Sound/a2.wav"),
                                    ModAPI.LoadSound("Sound/a3.wav"),
                                  };



    //Cmphat
      var ca = new GameObject("Cmphat");
      ca.transform.SetParent(Instance.transform.Find("Head"));
      ca.transform.localPosition = new Vector3(0, 0f);
      ca.transform.localScale = new Vector3(1f, 1f);
      var caSprite = ca.AddComponent<SpriteRenderer>();
      caSprite.sprite = ModAPI.LoadSprite("image/Cmphat.png");
      ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ca.AddComponent<UseEventTrigger>().Action = () => {
      caSprite.sprite = ModAPI.LoadSprite("none.png");
    };

    var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
    var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


    ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
    ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";


                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Nico Robin",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Nico Robin, also known by her epithet Devil Child and the Light of the Revolution, is the archaeologist of the Straw Hat Pirates. She is the seventh member of the crew and the sixth to join.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Nico Robinthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Nico Robin.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   leg3.transform.localScale = new Vector3(1.12f, 1.2f);
   leg4.transform.localScale = new Vector3(1.12f, 1.2f);
   leg1.transform.localScale = new Vector3(1.12f, 1.2f);
   leg2.transform.localScale = new Vector3(1.12f, 1.2f);
   foot1.transform.localScale = new Vector3(1.12f, 1.2f);
   foot2.transform.localScale = new Vector3(1.12f, 1.2f);

   head.transform.localScale = new Vector3(0.8f, 0.8f);

   head.transform.localPosition = new Vector3(0.01f, 0.69f);

   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.064f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.064f, -1.25f);

   head.transform.localScale = new Vector3(0.8f, 0.8f);


   var person = Instance.GetComponent<PersonBehaviour>();
   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 1f;
        body.Health *= 1000f;
        body.BreakingThreshold *= 1f;
        body.transform.root.localScale *= 1f;

        var bodyuper = Instance.transform.Find("Body").Find("UpperBody");
        bodyuper.localPosition = new Vector3(0.0f, 0.4f);

        Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("image/robinbreast.png");
        Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadTexture("image/Fleshbreast.png"));
        Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadTexture("image/Bonebreast.png"));

        var ornamentobject = new GameObject("robinhair2.png");
        ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
        ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
        ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
        ornamentobject.transform.localScale = new Vector3(1f, 1f);
        var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
        ornamentsprite.sprite = ModAPI.LoadSprite("image/robinhair2.png",2f);
        ornamentsprite.sortingLayerName = "Middle";

    //robinhair
      var ca = new GameObject("robinhair");
      ca.transform.SetParent(Instance.transform.Find("Head"));
      ca.transform.localPosition = new Vector3(0, 0f);
      ca.transform.localScale = new Vector3(1f, 1f);
      var caSprite = ca.AddComponent<SpriteRenderer>();
      caSprite.sprite = ModAPI.LoadSprite("image/robinhair.png");
      ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
      ca.AddComponent<UseEventTrigger>().Action = () => {
      caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                        };

                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Android"),
   NameOverride = "Franky",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Iron Man, Franky is the shipwright of the Straw Hat Pirates. He is the crew's eighth member and the seventh to join, doing so at the end of the Post-Enies Lobby Arc.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Frankythumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Franky.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");
   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.5f, 1.2f);
   middle.transform.localScale = new Vector3(1.4f, 1.2f);
   Lower.transform.localScale = new Vector3(1.3f, 1.2f);
   arm3.transform.localScale = new Vector3(1.7f, 1.25f);
   arm4.transform.localScale = new Vector3(1.7f, 1.25f);
   arm1.transform.localScale = new Vector3(1.7f, 1.3f);
   arm2.transform.localScale = new Vector3(1.7f, 1.3f);
   leg3.transform.localScale = new Vector3(1.3f, 1f);
   leg4.transform.localScale = new Vector3(1.3f, 1f);

   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);

   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.61f);
   arm2.transform.localPosition = new Vector3(0f, -0.61f);

   var person = Instance.GetComponent<PersonBehaviour>();
   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 2f;
        body.Health *= 100f;
        body.BreakingThreshold *= 1f;
        body.transform.root.localScale *= 1.01f;



                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Brook",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Soul King Brook, is the musician of the Straw Hat Pirates, and one of their two swordsmen. He is the ninth member of the crew and the eighth to join doing so at the end of the Thriller Bark Arc.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Brookthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Brook.png");
   var flesh = ModAPI.LoadTexture("image/Brook.png");
   var bone = ModAPI.LoadTexture("Bone.png");
   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.2f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.12f, 1.2f);
   leg4.transform.localScale = new Vector3(1.12f, 1.2f);
   leg1.transform.localScale = new Vector3(1.12f, 1.2f);
   leg2.transform.localScale = new Vector3(1.12f, 1.2f);
   foot1.transform.localScale = new Vector3(1.12f, 1.2f);
   foot2.transform.localScale = new Vector3(1.12f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.064f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.064f, -1.25f);

   var person = Instance.GetComponent<PersonBehaviour>();
   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 0.8f;
        body.Health *= 100f;
        body.BreakingThreshold *= 1f;
        body.transform.root.localScale *= 1.01f;
        body.IsAndroid = true;
        body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
        body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[]
      {
                                    ModAPI.LoadSound("Sound/a1.wav"),
                                    ModAPI.LoadSound("Sound/a2.wav"),
                                    ModAPI.LoadSound("Sound/a3.wav"),
                                    ModAPI.LoadSound("Sound/a4.wav"),
                                    ModAPI.LoadSound("Sound/a5.wav"),
                                    ModAPI.LoadSound("Sound/a6.wav"),
                                    ModAPI.LoadSound("Sound/a1.wav"),
                                    ModAPI.LoadSound("Sound/a2.wav"),
                                    ModAPI.LoadSound("Sound/a3.wav"),
                                  };

        //Brookitem
          var ca = new GameObject("Brookitem.png");
          ca.transform.SetParent(Instance.transform.Find("Head"));
          ca.transform.localPosition = new Vector3(0, 0f);
          ca.transform.localScale = new Vector3(1f, 1f);
          var caSprite = ca.AddComponent<SpriteRenderer>();
          caSprite.sprite = ModAPI.LoadSprite("image/Brookitem.png");
          ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
          ca.AddComponent<UseEventTrigger>().Action = () => {
          caSprite.sprite = ModAPI.LoadSprite("none.png");
          };

          person.SetBodyTextures(skin, flesh, bone, 1);
          person.SetBruiseColor(255, 255, 255);
          person.SetSecondBruiseColor(204, 204, 204);
          person.SetThirdBruiseColor(255, 255, 255);
          person.SetBloodColour(204, 204, 204);
          person.SetRottenColour(255, 255, 255);


                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Jinbe",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Knight of the Sea, Jinbeis the helmsman of the Straw Hat Pirates. He is the tenth member of the crew and the ninth to join, doing so during the Wano Country Arc.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/jinbethumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Jinbe.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.4f, 1.2f);
   middle.transform.localScale = new Vector3(1.3f, 1.2f);
   Lower.transform.localScale = new Vector3(1.2f, 1f);
   arm3.transform.localScale = new Vector3(1.15f, 1.1f);
   arm4.transform.localScale = new Vector3(1.14f, 1.1f);
   arm1.transform.localScale = new Vector3(1.14f, 1.1f);
   arm2.transform.localScale = new Vector3(1.14f, 1.1f);
   leg3.transform.localScale = new Vector3(1.2f, 1f);
   leg4.transform.localScale = new Vector3(1.2f, 1f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);

   arm3.transform.localPosition = new Vector3(0f, -0.12f);
   arm4.transform.localPosition = new Vector3(0f, -0.12f);
   arm1.transform.localPosition = new Vector3(0f, -0.54f);
   arm2.transform.localPosition = new Vector3(0f, -0.54f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   arm1.gameObject.AddComponent<forceBusoshoku>();
   arm2.gameObject.AddComponent<forceBusoshoku>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 0.7f;
        body.Health *= 1000f;
        body.BreakingThreshold *= 100f;
        body.transform.root.localScale *= 1.03f;
        body.IsAndroid = true;
        body.gameObject.AddComponent<strongrege>();
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });




    //jinbehair
      var ca = new GameObject("jinbehair");
      ca.transform.SetParent(Instance.transform.Find("Head"));
      ca.transform.localPosition = new Vector3(0, 0f);
      ca.transform.localScale = new Vector3(1f, 1f);
      var caSprite = ca.AddComponent<SpriteRenderer>();
      caSprite.sprite = ModAPI.LoadSprite("image/jinbehair.png");
      ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
      ca.AddComponent<UseEventTrigger>().Action = () => {
      caSprite.sprite = ModAPI.LoadSprite("none.png");

     };

     //cape20
      var backpack = new GameObject("cape20");
      backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
      backpack.transform.localPosition = new Vector3(0, 0f);
      backpack.transform.localScale = new Vector3(1f, 1f);
      var backpackSprite = backpack.AddComponent<SpriteRenderer>();
      backpackSprite.sprite = ModAPI.LoadSprite("image/cape20.png");
      backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
      backpack.AddComponent<UseEventTrigger>().Action = () => {
      backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                              };

      person.SetBodyTextures(skin, flesh, bone, 1);
      person.SetBruiseColor(000, 000, 000); //main bruise colour. purple-ish by default
      person.SetSecondBruiseColor(000, 000, 000); //second bruise colour. red by default
      person.SetThirdBruiseColor(000, 000, 000); // third bruise colour. light yellow by default
      person.SetBloodColour(000, 000, 000); // blood clour. dark red by default
      person.SetRottenColour(000, 000, 000); // rotten/zombie colour. light yellow/green by default




                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Yamato",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Yamato is the daughter of Kaido of the Four Emperors and proclaims to be Kozuki Oden,and she is widely referred to as Kaido's son.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/yamatothumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Yamato.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   leg3.transform.localScale = new Vector3(1.12f, 1.2f);
   leg4.transform.localScale = new Vector3(1.12f, 1.2f);
   leg1.transform.localScale = new Vector3(1.12f, 1.2f);
   leg2.transform.localScale = new Vector3(1.12f, 1.2f);
   foot1.transform.localScale = new Vector3(1.12f, 1.2f);
   foot2.transform.localScale = new Vector3(1.12f, 1.2f);

   head.transform.localScale = new Vector3(0.8f, 0.8f);

   head.transform.localPosition = new Vector3(0.01f, 0.69f);

   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.064f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.064f, -1.25f);

   head.transform.localScale = new Vector3(0.8f, 0.8f);

   head.transform.localPosition = new Vector3(0.01f, 0.69f);

   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   AudioSource Audio1 = Instance.AddComponent<AudioSource>();
   Audio1.maxDistance = 100;
   Audio1.loop = false;
   Audio1.clip = ModAPI.LoadSound("Sound/yamatorug.mp3");

   head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
       body.BaseStrength *= 0.6f;
       body.Health *= 1000f;
       body.BreakingThreshold *= 1f;
       body.IsAndroid = true;
       body.transform.root.localScale *= 1.02f;
       body.gameObject.AddComponent<strongrege>();
     var bodyuper = Instance.transform.Find("Body").Find("UpperBody");
     bodyuper.localPosition = new Vector3(0.0f, 0.4f);
     UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
     useEventTrigger.Event = new UnityEvent();
     useEventTrigger.Event.AddListener(delegate ()
      {
       body.ImmuneToDamage = true;
       arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
       arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
       arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
       arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
       Audio.Play();
       Audio1.Play();
     });

     UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
     useEventTrigger1.Event = new UnityEvent();
     useEventTrigger1.Event.AddListener(delegate ()
      {
        body.ImmuneToDamage = false;
        arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
        arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
        arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
        arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
        Audio.Play();
     });

             Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("image/yamatobreast.png");
             Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadTexture("image/Fleshbreast.png"));
             Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadTexture("image/Bonebreast.png"));

             var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
             var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");

             ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
             ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

       //Yamatohair1
         var ca = new GameObject("Yamatohair1");
         ca.transform.SetParent(Instance.transform.Find("Head"));
         ca.transform.localPosition = new Vector3(0, 0f);
         ca.transform.localScale = new Vector3(1f, 1f);
         var caSprite = ca.AddComponent<SpriteRenderer>();
         caSprite.sprite = ModAPI.LoadSprite("image/Yamatohair1.png");
         ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
         ca.AddComponent<UseEventTrigger>().Action = () => {
         caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                           };

     //yamatoknot
      var backpack = new GameObject("yamatoknot");
      backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
      backpack.transform.localPosition = new Vector3(0, 0f);
      backpack.transform.localScale = new Vector3(1f, 1f);
      var backpackSprite = backpack.AddComponent<SpriteRenderer>();
      backpackSprite.sprite = ModAPI.LoadSprite("image/yamatoknot.png");
      backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
      backpack.AddComponent<UseEventTrigger>().Action = () => {
      backpackSprite.sprite = ModAPI.LoadSprite("none.png");
     };

     var ca2 = new GameObject("yamatocape");
     ca2.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
     ca2.transform.localPosition = new Vector3(0, 0f);
     ca2.transform.localScale = new Vector3(1f, 1f);
     var ca2Sprite = ca2.AddComponent<SpriteRenderer>();
     ca2Sprite.sprite = ModAPI.LoadSprite("image/yamatocape.png");
     ca2.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
     ca2.AddComponent<UseEventTrigger>().Action = () => {
     ca2Sprite.sprite = ModAPI.LoadSprite("none.png");
     };


           }
        }
      }
);
ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Ulti",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Ulti is one of the Tobiroppo, the six strongest Shinuchi of the Beasts Pirates. She is the elder sister of fellow Tobiroppo Page One.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Ultithumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Ulti.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   leg3.transform.localScale = new Vector3(1.12f, 1.2f);
   leg4.transform.localScale = new Vector3(1.12f, 1.2f);
   leg1.transform.localScale = new Vector3(1.12f, 1.2f);
   leg2.transform.localScale = new Vector3(1.12f, 1.2f);
   foot1.transform.localScale = new Vector3(1.12f, 1.2f);
   foot2.transform.localScale = new Vector3(1.12f, 1.2f);

   head.transform.localScale = new Vector3(0.8f, 0.8f);

   head.transform.localPosition = new Vector3(0.01f, 0.69f);

   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.064f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.064f, -1.25f);

   head.transform.localScale = new Vector3(0.8f, 0.8f);

   head.transform.localPosition = new Vector3(0.01f, 0.69f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");


   head.gameObject.AddComponent<forceBusoshoku>();
   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
       body.BaseStrength *= 0.2f;
       body.Health *= 1000f;
       body.BreakingThreshold *= 1f;
       body.IsAndroid = true;
       body.transform.root.localScale *= 1f;
       body.gameObject.AddComponent<strongrege>();
       UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger.Event = new UnityEvent();
       useEventTrigger.Event.AddListener(delegate ()
        {
         body.ImmuneToDamage = true;
         head.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         head.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.5f, 0.5f, 0.5f, 1f);
         Audio.Play();
       });

       UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger1.Event = new UnityEvent();
       useEventTrigger1.Event.AddListener(delegate ()
        {
          body.ImmuneToDamage = false;
          head.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          head.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          Audio.Play();
       });
     var bodyuper = Instance.transform.Find("Body").Find("UpperBody");
     bodyuper.localPosition = new Vector3(0.0f, 0.4f);

             Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("image/ultibreast.png");
             Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadTexture("image/Fleshbreast.png"));
             Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadTexture("image/Bonebreast.png"));




             //Ultihair
      var ca = new GameObject("Ultihair");
      ca.transform.SetParent(Instance.transform.Find("Head"));
      ca.transform.localPosition = new Vector3(0, 0f);
      ca.transform.localScale = new Vector3(1f, 1f);
      var caSprite = ca.AddComponent<SpriteRenderer>();
      caSprite.sprite = ModAPI.LoadSprite("image/Ultihair.png");
      ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ca.AddComponent<UseEventTrigger>().Action = () => {
      caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                        };

      //cape21
       var backpack = new GameObject("cape21");
       backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
       backpack.transform.localPosition = new Vector3(0, 0f);
       backpack.transform.localScale = new Vector3(1f, 1f);
       var backpackSprite = backpack.AddComponent<SpriteRenderer>();
       backpackSprite.sprite = ModAPI.LoadSprite("image/cape21.png");
       backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
       backpack.AddComponent<UseEventTrigger>().Action = () => {
       backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                                };

      var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
      var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");

      ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";


           }
        }
      }
);
ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Gol D. Roger",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Gol D. Roger,  was a legendary pirate who, as captain of the Roger Pirates,He is also known as the pirate king." + "\n <color=red>King of the pirates ",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/goldrogerthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Gol D. Roger.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.3f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();



   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
      body.BaseStrength *= 0.4f;
      body.Health *= 11000f;
      body.BreakingThreshold *= 1f;
      body.IsAndroid = true;
      body.transform.root.localScale *= 1.02f;
      body.gameObject.AddComponent<strongrege>();
    UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
    useEventTrigger.Event = new UnityEvent();
    useEventTrigger.Event.AddListener(delegate ()
     {
      body.ImmuneToDamage = true;
      arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
      arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
      arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
      arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
      Audio.Play();
    });

    UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
    useEventTrigger1.Event = new UnityEvent();
    useEventTrigger1.Event.AddListener(delegate ()
     {
       body.ImmuneToDamage = false;
       arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
       arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
       arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
       arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
       Audio.Play();
    });


      var ornamentobject = new GameObject("rogerhair.png");
      ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
      ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
      ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
      ornamentobject.transform.localScale = new Vector3(1f, 1f);
      var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
      ornamentsprite.sprite = ModAPI.LoadSprite("image/rogerhair.png",2f);
      ornamentsprite.sortingLayerName = "Middle";

    //cape3
     var backpack = new GameObject("cape3");
     backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
     backpack.transform.localPosition = new Vector3(0, 0f);
     backpack.transform.localScale = new Vector3(1f, 1f);
     var backpackSprite = backpack.AddComponent<SpriteRenderer>();
     backpackSprite.sprite = ModAPI.LoadSprite("image/cape3.png");
     backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
     backpack.AddComponent<UseEventTrigger>().Action = () => {
     backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                             };

    //GSword
      var ca = new GameObject("GSword");
      ca.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
      ca.transform.localPosition = new Vector3(0, 0f);
      ca.transform.localScale = new Vector3(1f, 1f);
      var caSprite = ca.AddComponent<SpriteRenderer>();
      caSprite.sprite = ModAPI.LoadSprite("image/GSword.png");
      ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
      ca.AddComponent<UseEventTrigger>().Action = () => {
      caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                         };

      person.SetBruiseColor(000, 000, 000);
      person.SetSecondBruiseColor(000, 000, 000);
      person.SetThirdBruiseColor(000, 000, 000);
      person.SetBloodColour(000, 000, 000);
      person.SetRottenColour(000, 000, 000);


          }
       }
    }
 );

 ModAPI.Register(
     new Modification()
         {
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Silvers Rayleigh",
    NameToOrderByOverride = "Z1",
    DescriptionOverride = "Silvers Rayleigh, also known as the Dark King is an extremely powerful and famous retired pirate who formerly served as the first mate of the legendary Roger Pirates.",
    CategoryOverride = ModAPI.FindCategory("One Piece pack"),
    ThumbnailOverride = ModAPI.LoadSprite("image/Silvers Rayleighthumbnail.png"),
    AfterSpawn = (Instance) =>
    {

    var skin = ModAPI.LoadTexture("image/Silvers Rayleigh.png");
    var flesh = ModAPI.LoadTexture("Flesh.png");
    var bone = ModAPI.LoadTexture("Bone.png");


    var person = Instance.GetComponent<PersonBehaviour>();

    var head = Instance.transform.Find("Head");
    var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
    var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
    var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
    var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
    var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
    var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
    var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
    var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
    var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
    var upper = Instance.transform.Find("Body").Find("UpperBody");
    var middle = Instance.transform.Find("Body").Find("MiddleBody");
    var Lower = Instance.transform.Find("Body").Find("LowerBody");

    upper.transform.localScale = new Vector3(1.3f, 1.2f);
    middle.transform.localScale = new Vector3(1.1f, 1.2f);
    head.transform.localScale = new Vector3(0.9f, 0.9f);
    arm3.transform.localScale = new Vector3(1.18f, 1.2f);
    arm4.transform.localScale = new Vector3(1.18f, 1.2f);
    arm1.transform.localScale = new Vector3(1.18f, 1.2f);
    arm2.transform.localScale = new Vector3(1.18f, 1.2f);
    leg3.transform.localScale = new Vector3(1.19f, 1.2f);
    leg4.transform.localScale = new Vector3(1.19f, 1.2f);
    leg1.transform.localScale = new Vector3(1.19f, 1.2f);
    leg2.transform.localScale = new Vector3(1.19f, 1.2f);
    foot1.transform.localScale = new Vector3(1.19f, 1.2f);
    foot2.transform.localScale = new Vector3(1.19f, 1.2f);

    head.transform.localPosition = new Vector3(0.01f, 0.73f);
    arm3.transform.localPosition = new Vector3(0f, -0.15f);
    arm4.transform.localPosition = new Vector3(0f, -0.15f);
    arm1.transform.localPosition = new Vector3(0f, -0.60f);
    arm2.transform.localPosition = new Vector3(0f, -0.60f);
    leg3.transform.localPosition = new Vector3(0f, -0.46f);
    leg4.transform.localPosition = new Vector3(0f, -0.46f);
    leg1.transform.localPosition = new Vector3(0f, -0.96f);
    leg2.transform.localPosition = new Vector3(0f, -0.96f);
    foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
    foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
    AudioSource Audio = Instance.AddComponent<AudioSource>();
    Audio.maxDistance = 10;
    Audio.loop = false;
    Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");


    head.gameObject.AddComponent<hao>();
    arm1.gameObject.AddComponent<Busoshoku>();
    arm2.gameObject.AddComponent<Busoshoku>();
    leg1.gameObject.AddComponent<Busoshoku>();
    leg2.gameObject.AddComponent<Busoshoku>();



    person.SetBodyTextures(skin, flesh, bone, 1);
    foreach (var body in person.Limbs)
     {
       body.BaseStrength *= 0.2f;
       body.Health *= 11000f;
       body.BreakingThreshold *= 1f;
       body.IsAndroid = true;
       body.transform.root.localScale *= 1.01f;
       body.gameObject.AddComponent<strongrege>();
       UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger.Event = new UnityEvent();
       useEventTrigger.Event.AddListener(delegate ()
        {
         body.ImmuneToDamage = true;
         arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         Audio.Play();
       });

       UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger1.Event = new UnityEvent();
       useEventTrigger1.Event.AddListener(delegate ()
        {
          body.ImmuneToDamage = false;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          Audio.Play();
       });


       var ornamentobject = new GameObject("Rayleighhair.png");
       ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
       ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
       ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
       ornamentobject.transform.localScale = new Vector3(1f, 1f);
       var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
       ornamentsprite.sprite = ModAPI.LoadSprite("image/Rayleighhair.png",2f);
       ornamentsprite.sortingLayerName = "Middle";

       var ornamentobject2 = new GameObject("Rayleighhair2.png");
       ornamentobject2.transform.SetParent(Instance.transform.Find("Head"));
       ornamentobject2.transform.localPosition = new Vector3(-0.03f, 0.03f);
       ornamentobject2.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
       ornamentobject2.transform.localScale = new Vector3(1f, 1f);
       var ornamentsprite2 = ornamentobject2.AddComponent<SpriteRenderer>();
       ornamentsprite2.sprite = ModAPI.LoadSprite("image/Rayleighhair2.png",2f);
       ornamentsprite2.sortingLayerName = "Middle";

       var ca = new GameObject("Rayleighcape.png");
       ca.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
       ca.transform.localPosition = new Vector3(0, 0f);
       ca.transform.localScale = new Vector3(1f, 1f);
       var caSprite = ca.AddComponent<SpriteRenderer>();
       caSprite.sprite = ModAPI.LoadSprite("image/Rayleighcape.png");
       ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
       ca.AddComponent<UseEventTrigger>().Action = () => {
       caSprite.sprite = ModAPI.LoadSprite("none.png");
       };

       var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
       var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");

       ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
       ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

       person.SetBruiseColor(000, 000, 000);
       person.SetSecondBruiseColor(000, 000, 000);
       person.SetThirdBruiseColor(000, 000, 000);
       person.SetBloodColour(000, 000, 000);
       person.SetRottenColour(000, 000, 000);

           }
        }
     }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Kozuki Oden",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Kozuki Oden was the daimyo of Kuri in Wano Country and the son of the former shogun Kozuki Sukiyaki.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Kozuki Odenthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Kozuki Oden.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.4f, 1.2f);
   middle.transform.localScale = new Vector3(1.3f, 1.2f);
   Lower.transform.localScale = new Vector3(1.2f, 1f);
   arm3.transform.localScale = new Vector3(1.3f, 1.2f);
   arm4.transform.localScale = new Vector3(1.3f, 1.2f);
   arm1.transform.localScale = new Vector3(1.3f, 1.2f);
   arm2.transform.localScale = new Vector3(1.3f, 1.2f);
   leg3.transform.localScale = new Vector3(1.43f, 1.2f);
   leg4.transform.localScale = new Vector3(1.43f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.2f, 1.2f);
   foot2.transform.localScale = new Vector3(1.2f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.02f, 0.73f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();


   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 1.5f;
        body.Health *= 10000f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.04f;
        body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
        body.gameObject.AddComponent<strongrege>();
        body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[]
      {
                                    ModAPI.LoadSound("Sound/a1.wav"),
                                    ModAPI.LoadSound("Sound/a2.wav"),
                                    ModAPI.LoadSound("Sound/a3.wav"),
                                    ModAPI.LoadSound("Sound/a4.wav"),
                                    ModAPI.LoadSound("Sound/a5.wav"),
                                    ModAPI.LoadSound("Sound/a6.wav"),
                                    ModAPI.LoadSound("Sound/a1.wav"),
                                    ModAPI.LoadSound("Sound/a2.wav"),
                                    ModAPI.LoadSound("Sound/a3.wav"),
                                  };

                                  UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
                                  useEventTrigger.Event = new UnityEvent();
                                  useEventTrigger.Event.AddListener(delegate ()
                                   {
                                    arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
                                    arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
                                    Audio.Play();
                                  });

                                  UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
                                  useEventTrigger1.Event = new UnityEvent();
                                  useEventTrigger1.Event.AddListener(delegate ()
                                   {
                                     arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
                                     arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
                                     Audio.Play();
                                  });



    //kozuki oden hairstyle
      var ca = new GameObject("kozuki oden hairstyle");
      ca.transform.SetParent(Instance.transform.Find("Head"));
      ca.transform.localPosition = new Vector3(0, 0f);
      ca.transform.localScale = new Vector3(1f, 1f);
      var caSprite = ca.AddComponent<SpriteRenderer>();
      caSprite.sprite = ModAPI.LoadSprite("image/kozuki oden hairstyle.png");
      ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
      ca.AddComponent<UseEventTrigger>().Action = () => {
      caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                         };
  //knot
   var backpack = new GameObject("knot");
   backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
   backpack.transform.localPosition = new Vector3(0, 0f);
   backpack.transform.localScale = new Vector3(1f, 1f);
   var backpackSprite = backpack.AddComponent<SpriteRenderer>();
   backpackSprite.sprite = ModAPI.LoadSprite("image/knot.png");
   backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
   backpack.AddComponent<UseEventTrigger>().Action = () => {
   backpackSprite.sprite = ModAPI.LoadSprite("none.png");
                                                            };


  var ornamentobject = new GameObject("Odenswords.png");
  ornamentobject.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
  ornamentobject.transform.localPosition = new Vector3(-0.03f, 0f);
  ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
  ornamentobject.transform.localScale = new Vector3(1f, 1f);
  var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
  ornamentsprite.sprite = ModAPI.LoadSprite("image/Odenswords.png",0.9f);
  ornamentsprite.sortingLayerName = "Middle";


                        }
                    }
                }
);

ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Human"),
      NameOverride = ""+"\n <color=purple>Kaido",
      NameToOrderByOverride = "Z1",
      DescriptionOverride = ""+"\n <color=white>Kaido of the Beasts renowned as the worlds Strongest Creature is the Governor General of the Beasts Pirates and one of the Four Emperors ruling over the New World" + "\n <color=purple>Yonkou ",
      CategoryOverride = ModAPI.FindCategory("One Piece pack"),
      ThumbnailOverride = ModAPI.LoadSprite("image/Kaidothumbnail.png"),
      AfterSpawn = (Instance) =>
      {
          var person = Instance.GetComponent<PersonBehaviour>();
          var head = Instance.transform.Find("Head");
          var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
          var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
          var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
          var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
          var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
          var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
          var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
          var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
          var upper = Instance.transform.Find("Body").Find("UpperBody");
          var middle = Instance.transform.Find("Body").Find("MiddleBody");
          var Lower = Instance.transform.Find("Body").Find("LowerBody");

          upper.transform.localScale = new Vector3(1.5f, 1.2f);
          middle.transform.localScale = new Vector3(1.4f, 1.2f);
          Lower.transform.localScale = new Vector3(1.3f, 1.2f);
          arm3.transform.localScale = new Vector3(1.7f, 1.25f);
          arm4.transform.localScale = new Vector3(1.7f, 1.25f);
          arm1.transform.localScale = new Vector3(1.7f, 1.3f);
          arm2.transform.localScale = new Vector3(1.7f, 1.3f);
          leg3.transform.localScale = new Vector3(1.3f, 1f);
          leg4.transform.localScale = new Vector3(1.3f, 1f);

          head.transform.localScale = new Vector3(0.9f, 0.9f);

          head.transform.localPosition = new Vector3(0.01f, 0.73f);

          arm3.transform.localPosition = new Vector3(0f, -0.15f);
          arm4.transform.localPosition = new Vector3(0f, -0.15f);
          arm1.transform.localPosition = new Vector3(0f, -0.61f);
          arm2.transform.localPosition = new Vector3(0f, -0.61f);

  head.gameObject.AddComponent<hao>();

          foreach (var body in person.Limbs)
          {
              body.PhysicalBehaviour.ReflectsLasers = true;
body.PhysicalBehaviour.SimulateTemperature = false;
              body.PhysicalBehaviour.Disintegratable = false;
              body.IsAndroid = true;
body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
              body.gameObject.AddComponent<undeath>();
              body.BaseStrength *= 14f;
              body.Health *= 500f;
              body.transform.root.localScale *= 1.107f;
              body.Vitality = 20f;
              body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[]
            {
                                          ModAPI.LoadSound("Sound/a1.wav"),
                                          ModAPI.LoadSound("Sound/a2.wav"),
                                          ModAPI.LoadSound("Sound/a3.wav"),
                                          ModAPI.LoadSound("Sound/a4.wav"),
                                          ModAPI.LoadSound("Sound/a5.wav"),
                                          ModAPI.LoadSound("Sound/a6.wav"),
                                          ModAPI.LoadSound("Sound/a1.wav"),
                                          ModAPI.LoadSound("Sound/a2.wav"),
                                          ModAPI.LoadSound("Sound/a3.wav"),
                                        };


            var ornamentobject = new GameObject("Kaidohair.png");
            ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
            ornamentobject.transform.localPosition = new Vector3(0f, 0f);
            ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            ornamentobject.transform.localScale = new Vector3(1f, 1f);
            var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
            ornamentsprite.sprite = ModAPI.LoadSprite("image/Kaidohair.png");
            ornamentsprite.sortingLayerName = "Mid";


            var ornamentobject2 = new GameObject("cape10.png");
            ornamentobject2.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
            ornamentobject2.transform.localPosition = new Vector3(0f, 0f);
            ornamentobject2.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            ornamentobject2.transform.localScale = new Vector3(1f, 1f);
            var ornamentsprite2 = ornamentobject2.AddComponent<SpriteRenderer>();
            ornamentsprite2.sprite = ModAPI.LoadSprite("image/cape10.png");
            ornamentsprite2.sortingLayerName = "Bottom";

            var ornamentobject3 = new GameObject("Kaidobeard.png");
            ornamentobject3.transform.SetParent(Instance.transform.Find("Head"));
            ornamentobject3.transform.localPosition = new Vector3(0f, 0f);
            ornamentobject3.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            ornamentobject3.transform.localScale = new Vector3(1f, 1f);
            var ornamentsprite3 = ornamentobject3.AddComponent<SpriteRenderer>();
            ornamentsprite3.sprite = ModAPI.LoadSprite("image/Kaidobeard.png");
            ornamentsprite3.sortingLayerName = "Top";

            var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
            var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");

            ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
            ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

          }
          var skin = ModAPI.LoadTexture("image/Kaido.png");
var flesh = ModAPI.LoadTexture("Flesh.png");
var bone = ModAPI.LoadTexture("Bone.png");
          Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);




      }
  }
);

ModAPI.Register(
new Modification()
{
  OriginalItem = ModAPI.FindSpawnable("Human"),
  NameOverride = ""+"\n <color=purple>Charlotte Linlin",
  NameToOrderByOverride = "Z1",
  DescriptionOverride = ""+"\n <color=white>Charlotte Linlin better known as Big Mom, is the captain of the Big Mom Pirates and one of the Four Emperors ruling over the New World, as the only female member." + "\n <color=purple>Yonkou ",
  CategoryOverride = ModAPI.FindCategory("One Piece pack"),
  ThumbnailOverride = ModAPI.LoadSprite("image/Charlotte Linlinthumbnail.png"),
  AfterSpawn = (Instance) =>
  {
    var person = Instance.GetComponent<PersonBehaviour>();

    var head = Instance.transform.Find("Head");
    var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
    var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
    var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
    var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
    var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
    var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
    var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
    var upper = Instance.transform.Find("Body").Find("UpperBody");
    var middle = Instance.transform.Find("Body").Find("MiddleBody");
    var Lower = Instance.transform.Find("Body").Find("LowerBody");

    upper.transform.localScale = new Vector3(1.6f, 1.2f);
    middle.transform.localScale = new Vector3(1.6f, 1.2f);
    Lower.transform.localScale = new Vector3(1.6f, 1.2f);
    arm3.transform.localScale = new Vector3(1.7f, 1.25f);
    arm4.transform.localScale = new Vector3(1.7f, 1.25f);
    arm1.transform.localScale = new Vector3(1.7f, 1.3f);
    arm2.transform.localScale = new Vector3(1.7f, 1.3f);
    leg3.transform.localScale = new Vector3(1.3f, 1f);
    leg4.transform.localScale = new Vector3(1.3f, 1f);

    head.transform.localScale = new Vector3(0.9f, 0.9f);

    head.transform.localPosition = new Vector3(0.01f, 0.765f);

    arm3.transform.localPosition = new Vector3(0f, -0.13f);
    arm4.transform.localPosition = new Vector3(0f, -0.13f);
    arm1.transform.localPosition = new Vector3(0f, -0.59f);
    arm2.transform.localPosition = new Vector3(0f, -0.59f);

    AudioSource Audio = Instance.AddComponent<AudioSource>();
    Audio.maxDistance = 10;
    Audio.loop = false;
    Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

    head.gameObject.AddComponent<hao>();
    arm1.gameObject.AddComponent<Busoshoku>();
    arm2.gameObject.AddComponent<Busoshoku>();

      foreach (var body in person.Limbs)
      {
        body.PhysicalBehaviour.ReflectsLasers = true;
        body.IsAndroid = true;
        body.BreakingThreshold *= 100f;
        body.BaseStrength *= 30f;
        body.Health *= 666f;
        body.DoStumble = true;
        body.DoBalanceJerk = true;
        body.Wince(0f);
        body.Vitality = 50f;
        body.transform.root.localScale *= 1.106f;
        body.gameObject.AddComponent<strongrege>();
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });

        var ca = new GameObject("linhat");
        ca.transform.SetParent(Instance.transform.Find("Head"));
        ca.transform.localPosition = new Vector3(0, 0f);
        ca.transform.localScale = new Vector3(1f, 1f);
        var caSprite = ca.AddComponent<SpriteRenderer>();
        caSprite.sprite = ModAPI.LoadSprite("image/linhat.png");
        ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
        ca.AddComponent<UseEventTrigger>().Action = () => {
        caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                          };


         var ca2 = new GameObject("cape12");
         ca2.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
         ca2.transform.localPosition = new Vector3(0, 0f);
         ca2.transform.localScale = new Vector3(1f, 1f);
         var ca2Sprite = ca2.AddComponent<SpriteRenderer>();
         ca2Sprite.sprite = ModAPI.LoadSprite("image/cape12.png");
         ca2.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
         ca2.AddComponent<UseEventTrigger>().Action = () => {
         ca2Sprite.sprite = ModAPI.LoadSprite("none.png");
                                                             };

        var ca3 = new GameObject("linlincape");
        ca3.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
        ca3.transform.localPosition = new Vector3(0, 0f);
        ca3.transform.localScale = new Vector3(1f, 1f);
        var ca3Sprite = ca3.AddComponent<SpriteRenderer>();
        ca3Sprite.sprite = ModAPI.LoadSprite("image/linlincape.png");
        ca3.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        ca3.AddComponent<UseEventTrigger>().Action = () => {
        ca3Sprite.sprite = ModAPI.LoadSprite("none.png");
        };

        var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");

        ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

       }
      var skin = ModAPI.LoadTexture("image/Charlotte Linlin.png");
var flesh = ModAPI.LoadTexture("Flesh.png");
var bone = ModAPI.LoadTexture("Bone.png");
      Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

      Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("image/linlinbreast.png");
      Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadTexture("image/Fleshbreast.png"));
      Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadTexture("image/Bonebreast.png"));


  }
}
);

ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Edward Newgate",
    NameToOrderByOverride = "Z1",
    DescriptionOverride = ""+"\n <color=white>Edward Newgate more commonly known as Whitebeard was the captain of the Whitebeard Pirates" + "\n <color=purple>Yonkou ",
    CategoryOverride = ModAPI.FindCategory("One Piece pack"),
    ThumbnailOverride = ModAPI.LoadSprite("image/whitebeardthumnail.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();

        var head = Instance.transform.Find("Head");
        var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
        var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
        var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
        var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
        var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
        var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
        var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
        var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
        var upper = Instance.transform.Find("Body").Find("UpperBody");
        var middle = Instance.transform.Find("Body").Find("MiddleBody");
        var Lower = Instance.transform.Find("Body").Find("LowerBody");

        upper.transform.localScale = new Vector3(1.4f, 1.2f);
        middle.transform.localScale = new Vector3(1.3f, 1.2f);
        Lower.transform.localScale = new Vector3(1.2f, 1f);
        arm3.transform.localScale = new Vector3(1.3f, 1.2f);
        arm4.transform.localScale = new Vector3(1.3f, 1.2f);
        arm1.transform.localScale = new Vector3(1.3f, 1.2f);
        arm2.transform.localScale = new Vector3(1.3f, 1.2f);
        leg3.transform.localScale = new Vector3(1.43f, 1.2f);
        leg4.transform.localScale = new Vector3(1.43f, 1.2f);
        leg1.transform.localScale = new Vector3(1.19f, 1.2f);
        leg2.transform.localScale = new Vector3(1.19f, 1.2f);
        foot1.transform.localScale = new Vector3(1.19f, 1.2f);
        foot2.transform.localScale = new Vector3(1.19f, 1.2f);
        head.transform.localScale = new Vector3(0.9f, 0.9f);

        head.transform.localPosition = new Vector3(0.02f, 0.73f);
        leg3.transform.localPosition = new Vector3(0f, -0.46f);
        leg4.transform.localPosition = new Vector3(0f, -0.46f);
        leg1.transform.localPosition = new Vector3(0f, -0.96f);
        leg2.transform.localPosition = new Vector3(0f, -0.96f);
        foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
        foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

        arm3.transform.localPosition = new Vector3(0f, -0.15f);
        arm4.transform.localPosition = new Vector3(0f, -0.15f);
        arm1.transform.localPosition = new Vector3(0f, -0.60f);
        arm2.transform.localPosition = new Vector3(0f, -0.60f);
        AudioSource Audio = Instance.AddComponent<AudioSource>();
        Audio.maxDistance = 10;
        Audio.loop = false;
        Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

head.gameObject.AddComponent<hao>();

        foreach (var body in person.Limbs)
        {

            body.PhysicalBehaviour.ReflectsLasers = true;
body.PhysicalBehaviour.SimulateTemperature = false;
            body.PhysicalBehaviour.Disintegratable = false;
            body.PhysicalBehaviour.Deletable = false;
            body.IsAndroid = true;
            body.BaseStrength *= 13f;
            body.Health *= 666f;
            body.DoStumble = true;
      			body.DoBalanceJerk = true;
            body.Wince(0f);
      			body.Vitality = 50f;
            body.BreakingThreshold *= 100f;
            body.transform.root.localScale *= 1.09f;

            body.gameObject.AddComponent<strongrege>();
            UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
             {
              body.ImmuneToDamage = true;
              arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
              arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
              arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
              arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
              Audio.Play();
            });

            UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
            useEventTrigger1.Event = new UnityEvent();
            useEventTrigger1.Event.AddListener(delegate ()
             {
               body.ImmuneToDamage = false;
               arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
               arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
               arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
               arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
               Audio.Play();
            });

        //edwardhat1
          var ca = new GameObject("edwardhat1");
          ca.transform.SetParent(Instance.transform.Find("Head"));
          ca.transform.localPosition = new Vector3(0, 0f);
          ca.transform.localScale = new Vector3(1f, 1f);
          var caSprite = ca.AddComponent<SpriteRenderer>();
          caSprite.sprite = ModAPI.LoadSprite("image/edwardhat1.png");
          ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
          ca.AddComponent<UseEventTrigger>().Action = () => {
          caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                            };

        //cape2
         var backpack = new GameObject("cape2");
         backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
         backpack.transform.localPosition = new Vector3(0, 0f);
         backpack.transform.localScale = new Vector3(1f, 1f);
         var backpackSprite = backpack.AddComponent<SpriteRenderer>();
         backpackSprite.sprite = ModAPI.LoadSprite("image/cape2.png");
         backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
         backpack.AddComponent<UseEventTrigger>().Action = () => {
         backpackSprite.sprite = ModAPI.LoadSprite("none.png");

        };
        }
        var skin = ModAPI.LoadTexture("image/whitebeard.png");
var flesh = ModAPI.LoadTexture("Flesh.png");
var bone = ModAPI.LoadTexture("Bone.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);




    }
}
);

ModAPI.Register(
      new Modification()
          {
     OriginalItem = ModAPI.FindSpawnable("Human"),
     NameOverride = ""+"\n <color=purple>Marshall D. Teach",
     NameToOrderByOverride = "Z1",
     DescriptionOverride = ""+"\n <color=white>Marshall D. Teach most commonly referred to by his epithet Blackbeard is the captain-turned-admiral of the Blackbeard Pirates and currently one of the Four Emperors." + "\n <color=purple>Yonkou ",
     CategoryOverride = ModAPI.FindCategory("One Piece pack"),
     ThumbnailOverride = ModAPI.LoadSprite("image/Marshall D. Teachthumnail.png"),
     AfterSpawn = (Instance) =>
     {

     var skin = ModAPI.LoadTexture("image/Marshall D. Teach.png");
     var flesh = ModAPI.LoadTexture("Flesh.png");
     var bone = ModAPI.LoadTexture("Bone.png");

     var person = Instance.GetComponent<PersonBehaviour>();

     var head = Instance.transform.Find("Head");
     var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
     var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
     var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
     var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
     var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
     var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
     var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
     var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
     var upper = Instance.transform.Find("Body").Find("UpperBody");
     var middle = Instance.transform.Find("Body").Find("MiddleBody");
     var Lower = Instance.transform.Find("Body").Find("LowerBody");

     upper.transform.localScale = new Vector3(1.8f, 1.2f);
     middle.transform.localScale = new Vector3(1.8f, 1.2f);
     Lower.transform.localScale = new Vector3(1.8f, 1f);
     arm3.transform.localScale = new Vector3(1.14f, 1.1f);
     arm4.transform.localScale = new Vector3(1.14f, 1.1f);
     arm1.transform.localScale = new Vector3(1.14f, 1.1f);
     arm2.transform.localScale = new Vector3(1.14f, 1.1f);
     leg3.transform.localScale = new Vector3(1.2f, 1f);
     leg4.transform.localScale = new Vector3(1.2f, 1f);
     head.transform.localScale = new Vector3(0.9f, 0.9f);

     head.transform.localPosition = new Vector3(0.03f, 0.73f);

     arm3.transform.localPosition = new Vector3(0f, -0.12f);
     arm4.transform.localPosition = new Vector3(0f, -0.12f);
     arm1.transform.localPosition = new Vector3(0f, -0.54f);
     arm2.transform.localPosition = new Vector3(0f, -0.54f);

     arm1.gameObject.AddComponent<BlackVortex>();
     arm2.gameObject.AddComponent<BlackVortex>();
     arm1.gameObject.AddComponent<forceBusoshoku>();
     arm2.gameObject.AddComponent<forceBusoshoku>();
     leg1.gameObject.AddComponent<Busoshoku>();
     leg2.gameObject.AddComponent<Busoshoku>();


     person.SetBodyTextures(skin, flesh, bone, 1);
     foreach (var body in person.Limbs)
      {
         body.BaseStrength *= 0.9f;
         body.Health *= 1000000f;
         body.BreakingThreshold *= 1f;
         body.IsAndroid = true;
         body.transform.root.localScale *= 1.04f;
         body.gameObject.AddComponent<Regeneration>();



       //Teachhair
         var ca = new GameObject("Teachhair");
         ca.transform.SetParent(Instance.transform.Find("Head"));
         ca.transform.localPosition = new Vector3(0, 0f);
         ca.transform.localScale = new Vector3(1f, 1f);
         var caSprite = ca.AddComponent<SpriteRenderer>();
         caSprite.sprite = ModAPI.LoadSprite("image/Teachhair.png");
         ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
         ca.AddComponent<UseEventTrigger>().Action = () => {
         caSprite.sprite = ModAPI.LoadSprite("none.png");

                                                            };

         var ornamentobject = new GameObject("Teachbeard.png");
         ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
         ornamentobject.transform.localPosition = new Vector3(0f, 0f);
         ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
         ornamentobject.transform.localScale = new Vector3(1f, 1f);
         var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
         ornamentsprite.sprite = ModAPI.LoadSprite("image/Teachbeard.png");
         ornamentsprite.sortingLayerName = "Top";


      //cape16
       var backpack = new GameObject("cape16");
       backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
       backpack.transform.localPosition = new Vector3(0, 0f);
       backpack.transform.localScale = new Vector3(1f, 1f);
       var backpackSprite = backpack.AddComponent<SpriteRenderer>();
       backpackSprite.sprite = ModAPI.LoadSprite("image/cape16.png");
       backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
       backpack.AddComponent<UseEventTrigger>().Action = () => {
       backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                                };
      var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
      var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");

      ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

       person.SetBruiseColor(000, 000, 000);
       person.SetSecondBruiseColor(051, 051, 051);
       person.SetThirdBruiseColor(051, 051, 051);
       person.SetBloodColour(000, 000, 000);
       person.SetRottenColour(000, 000, 000);


             }
          }
       }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = ""+"\n <color=purple>Shanks",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = ""+"\n <color=white>Red-Haired Shanks, commonly known as just Red Hair, is the chief of the Red Hair Pirates and one of the Four Emperors that rule over the New World." + "\n <color=purple>Yonkou ",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Shanksthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Shanks.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");

   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.3f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<Busoshoku>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 0.3f;
        body.Health *= 10000000f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.01f;
        body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
        body.gameObject.AddComponent<strongrege>();
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });

       var ornamentobject = new GameObject("shankshair.png");
       ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
       ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
       ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
       ornamentobject.transform.localScale = new Vector3(1f, 1f);
       var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
       ornamentsprite.sprite = ModAPI.LoadSprite("image/shankshair.png",2f);
       ornamentsprite.sortingLayerName = "Middle";

       var ornamentobject2 = new GameObject("shankshair2.png");
       ornamentobject2.transform.SetParent(Instance.transform.Find("Head"));
       ornamentobject2.transform.localPosition = new Vector3(-0.03f, 0.03f);
       ornamentobject2.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
       ornamentobject2.transform.localScale = new Vector3(1f, 1f);
       var ornamentsprite2 = ornamentobject2.AddComponent<SpriteRenderer>();
       ornamentsprite2.sprite = ModAPI.LoadSprite("image/shankshair2.png",2.8f);
       ornamentsprite2.sortingLayerName = "Top";

        //cape6
         var backpack = new GameObject("cape6");
         backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
         backpack.transform.localPosition = new Vector3(0, 0f);
         backpack.transform.localScale = new Vector3(1f, 1f);
         var backpackSprite = backpack.AddComponent<SpriteRenderer>();
         backpackSprite.sprite = ModAPI.LoadSprite("image/cape6.png");
         backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
         backpack.AddComponent<UseEventTrigger>().Action = () => {
         backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                                 };

        //Ssword
          var ca = new GameObject("Ssword");
          ca.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
          ca.transform.localPosition = new Vector3(0, 0f);
          ca.transform.localScale = new Vector3(1f, 1f);
          var caSprite = ca.AddComponent<SpriteRenderer>();
          caSprite.sprite = ModAPI.LoadSprite("image/Ssword.png");
          ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
          ca.AddComponent<UseEventTrigger>().Action = () => {
          caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                             };
          Instance.transform.Find("BackArm").Find("LowerArm").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
          Instance.transform.Find("BackArm").Find("UpperArm").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();

          person.SetBruiseColor(000, 000, 000);
          person.SetSecondBruiseColor(000, 000, 000);
          person.SetThirdBruiseColor(000, 000, 000);
          person.SetBloodColour(000, 000, 000);
          person.SetRottenColour(000, 000, 000);

                        }
                    }
                }
  );
  ModAPI.Register(
      new Modification()
          {
     OriginalItem = ModAPI.FindSpawnable("Human"),
     NameOverride = "Dracule Mihawk",
     NameToOrderByOverride = "Z1",
     DescriptionOverride = "Dracule Hawk Eyes Mihawk is a world-famous pirate who holds the title of Strongest Swordsman in the World.",
     CategoryOverride = ModAPI.FindCategory("One Piece pack"),
     ThumbnailOverride = ModAPI.LoadSprite("image/Dracule Mihawkthumbnail.png"),
     AfterSpawn = (Instance) =>
     {

     var skin = ModAPI.LoadTexture("image/Dracule Mihawk.png");
     var flesh = ModAPI.LoadTexture("Flesh.png");
     var bone = ModAPI.LoadTexture("Bone.png");


     var person = Instance.GetComponent<PersonBehaviour>();

     var head = Instance.transform.Find("Head");
     var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
     var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
     var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
     var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
     var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
     var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
     var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
     var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
     var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
     var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
     var upper = Instance.transform.Find("Body").Find("UpperBody");
     var middle = Instance.transform.Find("Body").Find("MiddleBody");
     var Lower = Instance.transform.Find("Body").Find("LowerBody");

     upper.transform.localScale = new Vector3(1.3f, 1.2f);
     middle.transform.localScale = new Vector3(1.1f, 1.2f);
     head.transform.localScale = new Vector3(0.9f, 0.9f);
     arm3.transform.localScale = new Vector3(1.18f, 1.2f);
     arm4.transform.localScale = new Vector3(1.18f, 1.2f);
     arm1.transform.localScale = new Vector3(1.18f, 1.2f);
     arm2.transform.localScale = new Vector3(1.18f, 1.2f);
     leg3.transform.localScale = new Vector3(1.19f, 1.2f);
     leg4.transform.localScale = new Vector3(1.19f, 1.2f);
     leg1.transform.localScale = new Vector3(1.19f, 1.2f);
     leg2.transform.localScale = new Vector3(1.19f, 1.2f);
     foot1.transform.localScale = new Vector3(1.19f, 1.2f);
     foot2.transform.localScale = new Vector3(1.19f, 1.2f);

     head.transform.localPosition = new Vector3(0.01f, 0.73f);
     arm3.transform.localPosition = new Vector3(0f, -0.15f);
     arm4.transform.localPosition = new Vector3(0f, -0.15f);
     arm1.transform.localPosition = new Vector3(0f, -0.60f);
     arm2.transform.localPosition = new Vector3(0f, -0.60f);
     leg3.transform.localPosition = new Vector3(0f, -0.46f);
     leg4.transform.localPosition = new Vector3(0f, -0.46f);
     leg1.transform.localPosition = new Vector3(0f, -0.96f);
     leg2.transform.localPosition = new Vector3(0f, -0.96f);
     foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
     foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
     AudioSource Audio = Instance.AddComponent<AudioSource>();
     Audio.maxDistance = 10;
     Audio.loop = false;
     Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");


     arm1.gameObject.AddComponent<Busoshoku>();
     arm2.gameObject.AddComponent<Busoshoku>();
     leg1.gameObject.AddComponent<Busoshoku>();
     leg2.gameObject.AddComponent<Busoshoku>();

     person.SetBodyTextures(skin, flesh, bone, 1);
     foreach (var body in person.Limbs)
      {
          body.BaseStrength *= 0.3f;
          body.Health *= 10000000f;
          body.BreakingThreshold *= 1f;
          body.IsAndroid = true;
          body.transform.root.localScale *= 1.01f;
          body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
          body.gameObject.AddComponent<strongrege>();
          UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
          useEventTrigger.Event = new UnityEvent();
          useEventTrigger.Event.AddListener(delegate ()
           {
            body.ImmuneToDamage = true;
            arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
            arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
            arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
            arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
            Audio.Play();
          });

          UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
          useEventTrigger1.Event = new UnityEvent();
          useEventTrigger1.Event.AddListener(delegate ()
           {
             body.ImmuneToDamage = false;
             arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
             arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
             arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
             arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
             Audio.Play();
          });


      //Mhat
        var ca = new GameObject("Mhat");
        ca.transform.SetParent(Instance.transform.Find("Head"));
        ca.transform.localPosition = new Vector3(0, 0f);
        ca.transform.localScale = new Vector3(1f, 1f);
        var caSprite = ca.AddComponent<SpriteRenderer>();
        caSprite.sprite = ModAPI.LoadSprite("image/Mhat.png");
        ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        ca.AddComponent<UseEventTrigger>().Action = () => {
        caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                           };

        var ornamentobject = new GameObject("Mihawkhair.png");
        ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
        ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
        ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
        ornamentobject.transform.localScale = new Vector3(1f, 1f);
        var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
        ornamentsprite.sprite = ModAPI.LoadSprite("image/Mihawkhair.png",2f);
        ornamentsprite.sortingLayerName = "Middle";

      //cape7
       var backpack = new GameObject("cape7");
       backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
       backpack.transform.localPosition = new Vector3(0, 0f);
       backpack.transform.localScale = new Vector3(1f, 1f);
       var backpackSprite = backpack.AddComponent<SpriteRenderer>();
       backpackSprite.sprite = ModAPI.LoadSprite("image/cape7.png");
       backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
       backpack.AddComponent<UseEventTrigger>().Action = () => {
       backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                               };

      var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
      var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");

      ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

      person.SetBruiseColor(000, 000, 000);
      person.SetSecondBruiseColor(000, 000, 000);
      person.SetThirdBruiseColor(000, 000, 000);
      person.SetBloodColour(000, 000, 000);
      person.SetRottenColour(000, 000, 000);
                          }
                      }
                  }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Boa Hancock",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Pirate Empress Boa Hancock is the captain of the Kuja Pirates and was the only female Warlord of the Sea prior to the organization's disbandment.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/BoaHancockthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Boa Hancock.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   leg3.transform.localScale = new Vector3(1.12f, 1.2f);
   leg4.transform.localScale = new Vector3(1.12f, 1.2f);
   leg1.transform.localScale = new Vector3(1.12f, 1.2f);
   leg2.transform.localScale = new Vector3(1.12f, 1.2f);
   foot1.transform.localScale = new Vector3(1.12f, 1.2f);
   foot2.transform.localScale = new Vector3(1.12f, 1.2f);

   head.transform.localScale = new Vector3(0.8f, 0.8f);

   head.transform.localPosition = new Vector3(0.01f, 0.69f);

   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.064f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.064f, -1.25f);

   head.transform.localScale = new Vector3(0.8f, 0.8f);

   head.transform.localPosition = new Vector3(0.01f, 0.69f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();
   foot1.gameObject.AddComponent<Busoshoku>();
   foot2.gameObject.AddComponent<Busoshoku>();
   foot1.gameObject.AddComponent<petrification>();
   foot2.gameObject.AddComponent<petrification>();


   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
       body.BaseStrength *= 0.2f;
       body.Health *= 1000f;
       body.BreakingThreshold *= 1f;
       body.IsAndroid = true;
       body.transform.root.localScale *= 1f;
       body.gameObject.AddComponent<strongrege>();
       UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger.Event = new UnityEvent();
       useEventTrigger.Event.AddListener(delegate ()
        {
         body.ImmuneToDamage = true;
         arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         Audio.Play();
       });

       UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger1.Event = new UnityEvent();
       useEventTrigger1.Event.AddListener(delegate ()
        {
          body.ImmuneToDamage = false;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          Audio.Play();
       });


     var bodyuper = Instance.transform.Find("Body").Find("UpperBody");
     bodyuper.localPosition = new Vector3(0.0f, 0.4f);

             Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("image/Boa Hancockbreast.png");
             Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadTexture("image/Fleshbreast.png"));
             Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadTexture("image/Bonebreast.png"));

          var ca = new GameObject("hancock hair");
          ca.transform.SetParent(Instance.transform.Find("Head"));
          ca.transform.localPosition = new Vector3(0, 0f);
          ca.transform.localScale = new Vector3(1f, 1f);
          var caSprite = ca.AddComponent<SpriteRenderer>();
          caSprite.sprite = ModAPI.LoadSprite("image/hancock hair.png");
          ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
          ca.AddComponent<UseEventTrigger>().Action = () => {
          caSprite.sprite = ModAPI.LoadSprite("none.png");
          };

          var ornamentobject2 = new GameObject("Boa Hancockcape.png");
          ornamentobject2.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
          ornamentobject2.transform.localPosition = new Vector3(0f, 0f);
          ornamentobject2.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
          ornamentobject2.transform.localScale = new Vector3(1f, 1f);
          var ornamentsprite2 = ornamentobject2.AddComponent<SpriteRenderer>();
          ornamentsprite2.sprite = ModAPI.LoadSprite("image/Boa Hancockcape.png");
          ornamentsprite2.sortingLayerName = "Bottom";

          var ca3 = new GameObject("Boa Hancockcape2");
          ca3.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
          ca3.transform.localPosition = new Vector3(0, 0f);
          ca3.transform.localScale = new Vector3(1f, 1f);
          var ca3Sprite = ca3.AddComponent<SpriteRenderer>();
          ca3Sprite.sprite = ModAPI.LoadSprite("image/Boa Hancockcape2.png");
          ca3.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          ca3.AddComponent<UseEventTrigger>().Action = () => {
          ca3Sprite.sprite = ModAPI.LoadSprite("none.png");
          };

          var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
          var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");

          ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

           }
        }
      }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Gecko Moria",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Gecko Moria is the captain of the Thriller Bark Pirates and a former member of the Seven Warlords of the Sea who resides on the largest ship in the world, Thriller Bark.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Gecko Moriathumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Gecko Moria.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.5f, 1.2f);
   middle.transform.localScale = new Vector3(1.6f, 1.2f);
   Lower.transform.localScale = new Vector3(1.7f, 1f);
   arm3.transform.localScale = new Vector3(1.14f, 1.1f);
   arm4.transform.localScale = new Vector3(1.14f, 1.1f);
   arm1.transform.localScale = new Vector3(1.14f, 1.1f);
   arm2.transform.localScale = new Vector3(1.14f, 1.1f);
   leg3.transform.localScale = new Vector3(1.2f, 1f);
   leg4.transform.localScale = new Vector3(1.2f, 1f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);

   arm3.transform.localPosition = new Vector3(0f, -0.12f);
   arm4.transform.localPosition = new Vector3(0f, -0.12f);
   arm1.transform.localPosition = new Vector3(0f, -0.54f);
   arm2.transform.localPosition = new Vector3(0f, -0.54f);





   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 7f;
        body.Health *= 50f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.09f;
        body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
        body.gameObject.AddComponent<strongrege>();

        var ornamentobject = new GameObject("moriahair.png");
        ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
        ornamentobject.transform.localPosition = new Vector3(-0.02f, 0.03f);
        ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
        ornamentobject.transform.localScale = new Vector3(1f, 1f);
        var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
        ornamentsprite.sprite = ModAPI.LoadSprite("image/moriahair.png",1.3f);
        ornamentsprite.sortingLayerName = "Middle";



      person.SetBodyTextures(skin, flesh, bone, 1);
      person.SetBruiseColor(000, 000, 000); //main bruise colour. purple-ish by default
      person.SetSecondBruiseColor(000, 000, 000); //second bruise colour. red by default
      person.SetThirdBruiseColor(000, 000, 000); // third bruise colour. light yellow by default
      person.SetBloodColour(000, 000, 000); // blood clour. dark red by default
      person.SetRottenColour(000, 000, 000); // rotten/zombie colour. light yellow/green by default




                        }
                    }
                }
);

ModAPI.Register(
  new Modification()
      {
 OriginalItem = ModAPI.FindSpawnable("Human"),
 NameOverride = "Bartholomew Kuma",
 NameToOrderByOverride = "Z1",
 DescriptionOverride = "Bartholomew Kuma is a former Warlord of the Sea, the former king of the Sorbet Kingdom, and a former officer of the Revolutionary Army.",
 CategoryOverride = ModAPI.FindCategory("One Piece pack"),
 ThumbnailOverride = ModAPI.LoadSprite("image/Bartholomew Kumathumbnail.png"),
 AfterSpawn = (Instance) =>
 {

 var skin = ModAPI.LoadTexture("image/Bartholomew Kuma.png");
 var flesh = ModAPI.LoadTexture("Flesh.png");
 var bone = ModAPI.LoadTexture("Bone.png");
 var head = Instance.transform.Find("Head");
 var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
 var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
 var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
 var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
 var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
 var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
 var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
 var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
 var upper = Instance.transform.Find("Body").Find("UpperBody");
 var middle = Instance.transform.Find("Body").Find("MiddleBody");
 var Lower = Instance.transform.Find("Body").Find("LowerBody");

 upper.transform.localScale = new Vector3(1.4f, 1.2f);
 middle.transform.localScale = new Vector3(1.3f, 1.2f);
 Lower.transform.localScale = new Vector3(1.2f, 1f);
 arm3.transform.localScale = new Vector3(1.14f, 1.1f);
 arm4.transform.localScale = new Vector3(1.14f, 1.1f);
 arm1.transform.localScale = new Vector3(1.14f, 1.1f);
 arm2.transform.localScale = new Vector3(1.14f, 1.1f);
 leg3.transform.localScale = new Vector3(1.2f, 1f);
 leg4.transform.localScale = new Vector3(1.2f, 1f);
 head.transform.localScale = new Vector3(0.9f, 0.9f);

 head.transform.localPosition = new Vector3(0.02f, 0.73f);

 arm3.transform.localPosition = new Vector3(0f, -0.12f);
 arm4.transform.localPosition = new Vector3(0f, -0.12f);
 arm1.transform.localPosition = new Vector3(0f, -0.54f);
 arm2.transform.localPosition = new Vector3(0f, -0.54f);

 var person = Instance.GetComponent<PersonBehaviour>();

 AudioClip Repulsor = ModAPI.LoadSound("padcannonsound.mp3");
 AudioClip beam2 = ModAPI.LoadSound("padcannonsound.mp3");

 arm1.gameObject.AddComponent<PawPaw1>();
 arm2.gameObject.AddComponent<PawPaw1>();
 arm1.gameObject.AddComponent<eqp>();
 arm2.gameObject.AddComponent<eqp>();

 foreach (var Limbs in person.Limbs)
 {;

     if (Limbs.GetComponent<GripBehaviour>())
     {
         Limbs.gameObject.AddComponent<UseEventTrigger>().Action = () =>
         {


             AudioSource audio = Limbs.gameObject.AddComponent<AudioSource>();
             audio.spatialBlend = 1;
             audio.PlayOneShot(Repulsor);
         };
     }
 }




 person.SetBodyTextures(skin, flesh, bone, 1);
 foreach (var body in person.Limbs)
  {
      body.BaseStrength *= 25f;
      body.Health *= 1000f;
      body.BreakingThreshold *= 1000f;
      body.IsAndroid = true;
      body.transform.root.localScale *= 1.08f;
      body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
      body.gameObject.AddComponent<strongrege>();



  //kumahat
    var ca = new GameObject("kumahat");
    ca.transform.SetParent(Instance.transform.Find("Head"));
    ca.transform.localPosition = new Vector3(0, -0.01f);
    ca.transform.localScale = new Vector3(1f, 1f);
    var caSprite = ca.AddComponent<SpriteRenderer>();
    caSprite.sprite = ModAPI.LoadSprite("image/kumahat.png");
    ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
    ca.AddComponent<UseEventTrigger>().Action = () => {
    caSprite.sprite = ModAPI.LoadSprite("none.png");
    };

    //kumahat2
     var backpack = new GameObject("kumahat2");
     backpack.transform.SetParent(Instance.transform.Find("Head"));
     backpack.transform.localPosition = new Vector3(0, 0f);
     backpack.transform.localScale = new Vector3(1f, 1f);
     var backpackSprite = backpack.AddComponent<SpriteRenderer>();
     backpackSprite.sprite = ModAPI.LoadSprite("image/kumahat2.png");
     backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
     backpack.AddComponent<UseEventTrigger>().Action = () => {
     backpackSprite.sprite = ModAPI.LoadSprite("none.png");

    };

    var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
    var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


    ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
    ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";





    person.SetBodyTextures(skin, flesh, bone, 1);
    person.SetBruiseColor(000, 000, 000); //main bruise colour. purple-ish by default
    person.SetSecondBruiseColor(000, 000, 000); //second bruise colour. red by default
    person.SetThirdBruiseColor(000, 000, 000); // third bruise colour. light yellow by default
    person.SetBloodColour(000, 000, 000); // blood clour. dark red by default
    person.SetRottenColour(000, 000, 000); // rotten/zombie colour. light yellow/green by default




                      }
                  }
              }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Magellan",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Magellan is the vice warden of Impel Down. He was formerly the chief warden,but after his failure to stop the jail's one and only mass-breakout, he was replaced by Hannyabal and demoted to vice warden.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Magellanthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Magellan.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.4f, 1.2f);
   middle.transform.localScale = new Vector3(1.3f, 1.2f);
   Lower.transform.localScale = new Vector3(1.2f, 1f);
   arm3.transform.localScale = new Vector3(1.1f, 1f);
   arm4.transform.localScale = new Vector3(1.1f, 1f);
   arm1.transform.localScale = new Vector3(1.1f, 1f);
   arm2.transform.localScale = new Vector3(1.1f, 1f);
   leg3.transform.localScale = new Vector3(1.2f, 1f);
   leg4.transform.localScale = new Vector3(1.2f, 1f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0f, 0.73f);

   arm3.transform.localPosition = new Vector3(0f, -0.12f);
   arm4.transform.localPosition = new Vector3(0f, -0.12f);
   arm1.transform.localPosition = new Vector3(0f, -0.52f);
   arm2.transform.localPosition = new Vector3(0f, -0.52f);

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 3f;
        body.Health *= 100f;
        body.BreakingThreshold *= 100f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.06f;
        body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
        body.gameObject.AddComponent<strongrege>();
        body.gameObject.AddComponent<Venom>();


        //Magellanhat
          var ca = new GameObject("Magellanhat");
          ca.transform.SetParent(Instance.transform.Find("Head"));
          ca.transform.localPosition = new Vector3(0, 0f);
          ca.transform.localScale = new Vector3(1f, 1f);
          var caSprite = ca.AddComponent<SpriteRenderer>();
          caSprite.sprite = ModAPI.LoadSprite("image/Magellanhat.png");
          ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          ca.AddComponent<UseEventTrigger>().Action = () => {
          caSprite.sprite = ModAPI.LoadSprite("none.png");
          };

          //Magellanwing
           var backpack = new GameObject("Magellanwing");
           backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
           backpack.transform.localPosition = new Vector3(0, 0f);
           backpack.transform.localScale = new Vector3(1f, 1f);
           var backpackSprite = backpack.AddComponent<SpriteRenderer>();
           backpackSprite.sprite = ModAPI.LoadSprite("image/Magellanwing.png");
           backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
           backpack.AddComponent<UseEventTrigger>().Action = () => {
           backpackSprite.sprite = ModAPI.LoadSprite("none.png");
          };



      var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
      var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


      ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";


                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "King",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "King the Conflagration is one of the three All-Stars of the Beasts Pirates, also called Disasters, and is Kaidou's righ hand man, He is a member of the nigh-extinct lunarian race from the Red Line, noted for their ability to create fire.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Kingthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/King.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();
   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.4f, 1.2f);
   middle.transform.localScale = new Vector3(1.2f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.25f, 1.2f);
   arm4.transform.localScale = new Vector3(1.25f, 1.2f);
   arm1.transform.localScale = new Vector3(1.25f, 1.2f);
   arm2.transform.localScale = new Vector3(1.25f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   foot1.gameObject.AddComponent<Firebeh>();
   foot2.gameObject.AddComponent<Firebeh>();
   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 6f;
        body.Health *= 1000f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.08f;
        body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
        body.gameObject.AddComponent<strongrege>();
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });


        //Kinghair
          var ca = new GameObject("Kinghair");
          ca.transform.SetParent(Instance.transform.Find("Head"));
          ca.transform.localPosition = new Vector3(0, 0f);
          ca.transform.localScale = new Vector3(1f, 1f);
          var caSprite = ca.AddComponent<SpriteRenderer>();
          caSprite.sprite = ModAPI.LoadSprite("image/Kinghair.png");
          ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
          ca.AddComponent<UseEventTrigger>().Action = () => {
          caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                             };

        //Kingwing
         var backpack = new GameObject("Kingwing");
         backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
         backpack.transform.localPosition = new Vector3(0, 0f);
         backpack.transform.localScale = new Vector3(1f, 1f);
         var backpackSprite = backpack.AddComponent<SpriteRenderer>();
         backpackSprite.sprite = ModAPI.LoadSprite("image/Kingwing.png");
         backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
         backpack.AddComponent<UseEventTrigger>().Action = () => {
         backpackSprite.sprite = ModAPI.LoadSprite("none.png");
        };

        var ornamentobject = new GameObject("Kingsword.png");
        ornamentobject.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
        ornamentobject.transform.localPosition = new Vector3(-0.03f, 0f);
        ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
        ornamentobject.transform.localScale = new Vector3(1f, 1f);
        var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
        ornamentsprite.sprite = ModAPI.LoadSprite("image/Kingsword.png",0.9f);
        ornamentsprite.sortingLayerName = "Middle";

        person.SetBodyTextures(skin, flesh, bone, 1);
        person.SetBruiseColor(000, 000, 000); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(000, 000, 000); //second bruise colour. red by default
        person.SetThirdBruiseColor(000, 000, 000); // third bruise colour. light yellow by default
        person.SetBloodColour(000, 000, 000); // blood clour. dark red by default
        person.SetRottenColour(000, 000, 000); // rotten/zombie colour. light yellow/green by default

                        }
                    }
                }
);


ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Charlotte Katakuri",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Charlotte Katakuri is the second son and third child of the Charlotte Familyand the elder triplet brother of Daifuku and Oven.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/CharlotteKatakurithumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Charlotte Katakuri.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.4f, 1.2f);
   middle.transform.localScale = new Vector3(1.2f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.25f, 1.2f);
   arm4.transform.localScale = new Vector3(1.25f, 1.2f);
   arm1.transform.localScale = new Vector3(1.25f, 1.2f);
   arm2.transform.localScale = new Vector3(1.25f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();

   var person = Instance.GetComponent<PersonBehaviour>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 6f;
        body.Health *= 10000f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.08f;
        body.gameObject.AddComponent<Regeneration>();

        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.2f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.2f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });

        var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


        ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";


        var ornamentobject = new GameObject("katakurihair.png");
        ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
        ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
        ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
        ornamentobject.transform.localScale = new Vector3(1f, 1f);
        var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
        ornamentsprite.sprite = ModAPI.LoadSprite("image/katakurihair.png",2f);
        ornamentsprite.sortingLayerName = "Middle";


        person.SetBodyTextures(skin, flesh, bone, 1);
        person.SetBruiseColor(255, 255, 255);
        person.SetSecondBruiseColor(255, 255, 255);
        person.SetThirdBruiseColor(255, 255, 255);
        person.SetBloodColour(255, 255, 255);
        person.SetRottenColour(255, 255, 255);

           }
        }
    }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Crocodile",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Desert King Sir Crocodile is the former president of the mysterious crime syndicate Baroque Works.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Crocodilethumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Crocodile.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");

   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.3f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

   arm1.gameObject.AddComponent<Barchan>();
   arm2.gameObject.AddComponent<Barchan>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
       body.BaseStrength *= 0.7f;
       body.Health *= 1000f;
       body.BreakingThreshold *= 1f;
       body.IsAndroid = true;
       body.transform.root.localScale *= 1.01f;
       body.gameObject.AddComponent<Regeneration>();

       UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger.Event = new UnityEvent();
       useEventTrigger.Event.AddListener(delegate ()
        {
          body.ImmuneToDamage = true;
          body.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.7f, 0.6f, 0f, 1f);
          head.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.7f, 0.6f, 0f, 1f);

       });

       UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger1.Event = new UnityEvent();
       useEventTrigger1.Event.AddListener(delegate ()
        {
          body.ImmuneToDamage = false;
          body.SkinMaterialHandler.ClearAllDamage();
          body.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          upper.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);

       });



    //cape8
     var backpack = new GameObject("cape8");
     backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
     backpack.transform.localPosition = new Vector3(0, 0f);
     backpack.transform.localScale = new Vector3(1f, 1f);
     var backpackSprite = backpack.AddComponent<SpriteRenderer>();
     backpackSprite.sprite = ModAPI.LoadSprite("image/cape9.png");
     backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
     backpack.AddComponent<UseEventTrigger>().Action = () => {
     backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                             };

   //Waxhead
     var ca = new GameObject("Waxhead");
     ca.transform.SetParent(Instance.transform.Find("Head"));
     ca.transform.localPosition = new Vector3(0, 0f);
     ca.transform.localScale = new Vector3(1f, 1f);
     var caSprite = ca.AddComponent<SpriteRenderer>();
     caSprite.sprite = ModAPI.LoadSprite("image/Waxhead.png");
     ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
     ca.AddComponent<UseEventTrigger>().Action = () => {
     caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                        };

    person.SetBodyTextures(skin, flesh, bone, 1);
    person.SetBruiseColor(120, 051, 000);
    person.SetSecondBruiseColor(153, 102, 051);
    person.SetThirdBruiseColor(255, 000, 000);
    person.SetBloodColour(204, 153, 000);
    person.SetRottenColour(000, 000, 000);



           }
        }
     }
  );

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Donquixote Doflamingo",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Donquixote Doflamingo, nicknamed Heavenly Yaksha, is the captain of the Donquixote Pirates.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/DonquixoteDoflamingothumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Donquixote Doflamingo.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");

   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.3f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");



   AudioClip Repulsor = ModAPI.LoadSound("itotionomi.mp3");
   AudioClip beam2 = ModAPI.LoadSound("itotionomi.mp3");

head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<Webs>();
   arm2.gameObject.AddComponent<Webs>();
   leg1.gameObject.AddComponent<Webs>();
   leg2.gameObject.AddComponent<Webs>();
   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();

   foreach (var Limbs in person.Limbs)
   {;

       if (Limbs.GetComponent<GripBehaviour>())
       {
           Limbs.gameObject.AddComponent<UseEventTrigger>().Action = () =>
           {


               AudioSource audio = Limbs.gameObject.AddComponent<AudioSource>();
               audio.spatialBlend = 1;
               audio.PlayOneShot(Repulsor);
           };
       }
   }


   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
       body.BaseStrength *= 0.5f;
       body.Health *= 5000f;
       body.BreakingThreshold *= 30f;
       body.IsAndroid = true;
       body.transform.root.localScale *= 1.03f;
       body.gameObject.AddComponent<strongrege>();

       UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger.Event = new UnityEvent();
       useEventTrigger.Event.AddListener(delegate ()
        {
         body.ImmuneToDamage = true;
         arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         Audio.Play();
       });



       UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger1.Event = new UnityEvent();
       useEventTrigger1.Event.AddListener(delegate ()
        {
          body.ImmuneToDamage = false;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          Audio.Play();
       });


    //cape8
     var backpack = new GameObject("cape8");
     backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
     backpack.transform.localPosition = new Vector3(0, 0f);
     backpack.transform.localScale = new Vector3(1f, 1f);
     var backpackSprite = backpack.AddComponent<SpriteRenderer>();
     backpackSprite.sprite = ModAPI.LoadSprite("image/cape8.png");
     backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
     backpack.AddComponent<UseEventTrigger>().Action = () => {
     backpackSprite.sprite = ModAPI.LoadSprite("none.png");
                                                              };

     var ornamentobject = new GameObject("Donquixote Doflamingohair.png");
     ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
     ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
     ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
     ornamentobject.transform.localScale = new Vector3(1f, 1f);
     var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
     ornamentsprite.sprite = ModAPI.LoadSprite("image/Donquixote Doflamingohair.png",2f);
     ornamentsprite.sortingLayerName = "Middle";

           }
        }
     }
 );

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Trafalgar D. Water Law",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Trafalgar D. Water Law, by his epithet as the Surgeon of Death, is a pirate from North Blue and the captain and doctor of the Heart Pirates. He is one of twelve pirates who are referred to as the Worst Generation.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Lawthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Trafalgar D. Water Law.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.2f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");




   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 0.3f;
        body.Health *= 1000f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.01f;
        body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
        body.gameObject.AddComponent<strongrege>();
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });

    //Lawhat
      var ca = new GameObject("Lawhat");
      ca.transform.SetParent(Instance.transform.Find("Head"));
      ca.transform.localPosition = new Vector3(0, 0f);
      ca.transform.localScale = new Vector3(1f, 1f);
      var caSprite = ca.AddComponent<SpriteRenderer>();
      caSprite.sprite = ModAPI.LoadSprite("image/Lawhat.png");
      ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ca.AddComponent<UseEventTrigger>().Action = () => {
      caSprite.sprite = ModAPI.LoadSprite("none.png");
      };

      //cape22
       var backpack = new GameObject("cape22");
       backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
       backpack.transform.localPosition = new Vector3(0, 0f);
       backpack.transform.localScale = new Vector3(1f, 1f);
       var backpackSprite = backpack.AddComponent<SpriteRenderer>();
       backpackSprite.sprite = ModAPI.LoadSprite("image/cape22.png");
       backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
       backpack.AddComponent<UseEventTrigger>().Action = () => {
       backpackSprite.sprite = ModAPI.LoadSprite("none.png");

      };

      var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
      var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


      ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";




                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Eustass Kid",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Eustass  Captain Kid is a notorious pirate from South Blue and the captain of the Kid Pirates. He is one of twelve pirates who are referred to as the Worst Generation.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/EustassKidthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Eustass Kid.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.4f, 1.2f);
   middle.transform.localScale = new Vector3(1.3f, 1.2f);
   Lower.transform.localScale = new Vector3(1.2f, 1f);
   arm3.transform.localScale = new Vector3(1.3f, 1.2f);
   arm4.transform.localScale = new Vector3(2f, 1.7f);
   arm1.transform.localScale = new Vector3(1.3f, 1.2f);
   arm2.transform.localScale = new Vector3(2f, 1.7f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.02f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.23f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.85f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   head.gameObject.AddComponent<hao>();
   arm2.gameObject.AddComponent<Busoshoku>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
       body.BaseStrength *= 0.5f;
       body.Health *= 100f;
       body.BreakingThreshold *= 100f;
       body.IsAndroid = true;
       body.transform.root.localScale *= 1.02f;
       body.gameObject.AddComponent<strongrege>();

       var Hand = new GameObject("Hand");
       Hand.transform.SetParent(Instance.transform.Find("BackArm").Find("UpperArm"));
       Hand.transform.localPosition = new Vector3(0, 0f);
       Hand.transform.localScale = new Vector3(1f, 1f);
       var HandSprite = Hand.AddComponent<SpriteRenderer>();
       HandSprite.sprite = ModAPI.LoadSprite("image/Kidarm2.png");
       HandSprite.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";

       var Up = new GameObject("Up");
       Up.transform.SetParent(Instance.transform.Find("BackArm").Find("LowerArm"));
       Up.transform.localPosition = new Vector3(0, 0f);
       Up.transform.localScale = new Vector3(1f, 1f);
       var UpSprite = Up.AddComponent<SpriteRenderer>();
       UpSprite.sprite = ModAPI.LoadSprite("image/Kidarm1.png");
       Up.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";

       UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger.Event = new UnityEvent();
       useEventTrigger.Event.AddListener(delegate ()
        {
         body.ImmuneToDamage = true;
         arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         Audio.Play();
       });

       UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger1.Event = new UnityEvent();
       useEventTrigger1.Event.AddListener(delegate ()
        {
          body.ImmuneToDamage = false;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          Audio.Play();
       });

       var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
       var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");

       ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
       ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

       var ornamentobject = new GameObject("Kidhair.png");
       ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
       ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
       ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
       ornamentobject.transform.localScale = new Vector3(1f, 1f);
       var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
       ornamentsprite.sprite = ModAPI.LoadSprite("image/Kidhair.png",2f);
       ornamentsprite.sortingLayerName = "Top";



     var ca2 = new GameObject("Kidcape.png");
     ca2.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
     ca2.transform.localPosition = new Vector3(0, 0f);
     ca2.transform.localScale = new Vector3(1f, 1f);
     var ca2Sprite = ca2.AddComponent<SpriteRenderer>();
     ca2Sprite.sprite = ModAPI.LoadSprite("image/Kidcape.png");
     ca2.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
     ca2.AddComponent<UseEventTrigger>().Action = () => {
     ca2Sprite.sprite = ModAPI.LoadSprite("none.png");
                                                       };


      person.SetBruiseColor(255, 255, 000);
      person.SetSecondBruiseColor(255, 255, 102);
      person.SetThirdBruiseColor(255, 255, 153);
      person.SetBloodColour(255, 255, 204);
      person.SetRottenColour(000, 000, 000);

           }
        }
     }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Urouge",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Urouge nicknamed the Mad Monk, is a pirate hailing from a sky island and captain of the Fallen Monk Pirates He is one of twelve pirates referred to as the Worst Generation.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Urougethumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Urouge.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");
   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.5f, 1.2f);
   middle.transform.localScale = new Vector3(1.4f, 1.2f);
   Lower.transform.localScale = new Vector3(1.3f, 1.2f);
   arm3.transform.localScale = new Vector3(1.7f, 1.25f);
   arm4.transform.localScale = new Vector3(1.7f, 1.25f);
   arm1.transform.localScale = new Vector3(1.7f, 1.3f);
   arm2.transform.localScale = new Vector3(1.7f, 1.3f);
   leg3.transform.localScale = new Vector3(1.3f, 1f);
   leg4.transform.localScale = new Vector3(1.3f, 1f);

   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);

   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.61f);
   arm2.transform.localPosition = new Vector3(0f, -0.61f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   var person = Instance.GetComponent<PersonBehaviour>();
   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 2f;
        body.Health *= 100f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.03f;
        body.gameObject.AddComponent<strongrege>();
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });



        var ca = new GameObject("Urougehair");
        ca.transform.SetParent(Instance.transform.Find("Head"));
        ca.transform.localPosition = new Vector3(0, 0f);
        ca.transform.localScale = new Vector3(1f, 1f);
        var caSprite = ca.AddComponent<SpriteRenderer>();
        caSprite.sprite = ModAPI.LoadSprite("image/Urougehair.png");
        ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        ca.AddComponent<UseEventTrigger>().Action = () => {
        caSprite.sprite = ModAPI.LoadSprite("none.png");
        };

        var ca2 = new GameObject("Urougewing");
        ca2.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
        ca2.transform.localPosition = new Vector3(0, 0f);
        ca2.transform.localScale = new Vector3(1f, 1f);
        var ca2Sprite = ca2.AddComponent<SpriteRenderer>();
        ca2Sprite.sprite = ModAPI.LoadSprite("image/Urougewing.png");
        ca2.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
        ca2.AddComponent<UseEventTrigger>().Action = () => {
        ca2Sprite.sprite = ModAPI.LoadSprite("none.png");
        };

        var ca3 = new GameObject("Urougecape");
        ca3.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
        ca3.transform.localPosition = new Vector3(0, 0f);
        ca3.transform.localScale = new Vector3(1f, 1f);
        var ca3Sprite = ca3.AddComponent<SpriteRenderer>();
        ca3Sprite.sprite = ModAPI.LoadSprite("image/Urougecape.png");
        ca3.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
        ca3.AddComponent<UseEventTrigger>().Action = () => {
        ca3Sprite.sprite = ModAPI.LoadSprite("none.png");
      };


                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Basil Hawkins",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Basil Hawkins is an infamous pirate from North Blue known as the Magician and the captain of the Hawkins Pirates. He is one of twelve pirates who are referred to as the Worst Generation.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/BasilHawkinsthumb.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Basil Hawkins.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.2f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");




   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 0.3f;
        body.Health *= 1000f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.01f;
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });


      var ca = new GameObject("BasilHawkinshair");
      ca.transform.SetParent(Instance.transform.Find("Head"));
      ca.transform.localPosition = new Vector3(0, 0f);
      ca.transform.localScale = new Vector3(1f, 1f);
      var caSprite = ca.AddComponent<SpriteRenderer>();
      caSprite.sprite = ModAPI.LoadSprite("image/BasilHawkinshair.png");
      ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
      ca.AddComponent<UseEventTrigger>().Action = () => {
      caSprite.sprite = ModAPI.LoadSprite("none.png");
      };


       var backpack = new GameObject("BasilHawkinscape");
       backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
       backpack.transform.localPosition = new Vector3(0, 0f);
       backpack.transform.localScale = new Vector3(1f, 1f);
       var backpackSprite = backpack.AddComponent<SpriteRenderer>();
       backpackSprite.sprite = ModAPI.LoadSprite("image/BasilHawkinscape.png");
       backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
       backpack.AddComponent<UseEventTrigger>().Action = () => {
       backpackSprite.sprite = ModAPI.LoadSprite("none.png");

      };

      var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
      var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


      ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";




                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "X Drake",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Red Flag X Drake (read as Diez Drake) is the captain of the Marine Secret Special Unit SWORD.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/X Drakethumb.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/X Drake.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.2f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 0.3f;
        body.Health *= 1000f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.01f;
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });


      var ca = new GameObject("X Drakehair");
      ca.transform.SetParent(Instance.transform.Find("Head"));
      ca.transform.localPosition = new Vector3(0, 0f);
      ca.transform.localScale = new Vector3(1f, 1f);
      var caSprite = ca.AddComponent<SpriteRenderer>();
      caSprite.sprite = ModAPI.LoadSprite("image/X Drakehair.png",2f);
      ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
      ca.AddComponent<UseEventTrigger>().Action = () => {
      caSprite.sprite = ModAPI.LoadSprite("none.png");
      };


       var backpack = new GameObject("X Drakecape");
       backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
       backpack.transform.localPosition = new Vector3(0, 0f);
       backpack.transform.localScale = new Vector3(1f, 1f);
       var backpackSprite = backpack.AddComponent<SpriteRenderer>();
       backpackSprite.sprite = ModAPI.LoadSprite("image/X Drakecape.png");
       backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
       backpack.AddComponent<UseEventTrigger>().Action = () => {
       backpackSprite.sprite = ModAPI.LoadSprite("none.png");

      };

      var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
      var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


      ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";




                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Capone Bege",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Capone Gang Bege is a mafia don-turned-pirate and the captain of the Fire Tank Pirates. He is also one of twelve pirates who are referred to as the Worst Generation.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/CaponeBegethumb.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Capone Bege.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.4f, 1.1f);
   middle.transform.localScale = new Vector3(1.4f, 1.1f);
   Lower.transform.localScale = new Vector3(1.4f, 1.1f);

   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.2f, 1.1f);
   arm4.transform.localScale = new Vector3(1.2f, 1.1f);
   arm1.transform.localScale = new Vector3(1.2f, 1.1f);
   arm2.transform.localScale = new Vector3(1.2f, 1.1f);
   leg3.transform.localScale = new Vector3(1.2f, 1.1f);
   leg4.transform.localScale = new Vector3(1.2f, 1.1f);
   leg1.transform.localScale = new Vector3(1.2f, 1.1f);
   leg2.transform.localScale = new Vector3(1.2f, 1.1f);


   head.transform.localPosition = new Vector3(0f, 0.72f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");




   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 0.3f;
        body.Health *= 1000f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1f;
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });


      var ca = new GameObject("CaponeBegehat");
      ca.transform.SetParent(Instance.transform.Find("Head"));
      ca.transform.localPosition = new Vector3(0, 0f);
      ca.transform.localScale = new Vector3(1f, 1f);
      var caSprite = ca.AddComponent<SpriteRenderer>();
      caSprite.sprite = ModAPI.LoadSprite("image/CaponeBegehat.png");
      ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ca.AddComponent<UseEventTrigger>().Action = () => {
      caSprite.sprite = ModAPI.LoadSprite("none.png");
      };


       var backpack = new GameObject("CaponeBegecape");
       backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
       backpack.transform.localPosition = new Vector3(0, 0f);
       backpack.transform.localScale = new Vector3(1f, 1f);
       var backpackSprite = backpack.AddComponent<SpriteRenderer>();
       backpackSprite.sprite = ModAPI.LoadSprite("image/CaponeBegecape.png");
       backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
       backpack.AddComponent<UseEventTrigger>().Action = () => {
       backpackSprite.sprite = ModAPI.LoadSprite("none.png");

      };

      var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
      var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


      ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";




                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Jewelry Bonney",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Jewelry Bonney, also known as the Big Eater, is a pirate and the captain of the Bonney Pirates. She and her crew originated from South Blue. She is one of twelve pirates who are referred to as the Worst Generation.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/JewelryBonneythumb.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Jewelry Bonney.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   leg3.transform.localScale = new Vector3(1.12f, 1.2f);
   leg4.transform.localScale = new Vector3(1.12f, 1.2f);
   leg1.transform.localScale = new Vector3(1.12f, 1.2f);
   leg2.transform.localScale = new Vector3(1.12f, 1.2f);
   foot1.transform.localScale = new Vector3(1.12f, 1.2f);
   foot2.transform.localScale = new Vector3(1.12f, 1.2f);

   head.transform.localScale = new Vector3(0.8f, 0.8f);

   head.transform.localPosition = new Vector3(0.01f, 0.69f);

   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.064f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.064f, -1.25f);

   head.transform.localScale = new Vector3(0.8f, 0.8f);

   head.transform.localPosition = new Vector3(0.01f, 0.69f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");


   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();
   leg1.gameObject.AddComponent<petrification>();
   leg2.gameObject.AddComponent<Busoshoku>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
       body.BaseStrength *= 0.2f;
       body.Health *= 1000f;
       body.BreakingThreshold *= 1f;
       body.IsAndroid = true;
       body.transform.root.localScale *= 1f;
       UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger.Event = new UnityEvent();
       useEventTrigger.Event.AddListener(delegate ()
        {
         body.ImmuneToDamage = true;
         arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         Audio.Play();
       });

       UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger1.Event = new UnityEvent();
       useEventTrigger1.Event.AddListener(delegate ()
        {
          body.ImmuneToDamage = false;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          Audio.Play();
       });


     var bodyuper = Instance.transform.Find("Body").Find("UpperBody");
     bodyuper.localPosition = new Vector3(0.0f, 0.4f);

             Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("image/Jewelry Bonneybreast.png");
             Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadTexture("image/Fleshbreast.png"));
             Instance.transform.Find("Body").Find("UpperBody").GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadTexture("image/Bonebreast.png"));


          var ca = new GameObject("Bonneyhair");
          ca.transform.SetParent(Instance.transform.Find("Head"));
          ca.transform.localPosition = new Vector3(0, 0f);
          ca.transform.localScale = new Vector3(1f, 1f);
          var caSprite = ca.AddComponent<SpriteRenderer>();
          caSprite.sprite = ModAPI.LoadSprite("image/Bonneyhair.png");
          ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
          ca.AddComponent<UseEventTrigger>().Action = () => {
          caSprite.sprite = ModAPI.LoadSprite("none.png");
          };

          var ca2 = new GameObject("Bonneyhat");
          ca2.transform.SetParent(Instance.transform.Find("Head"));
          ca2.transform.localPosition = new Vector3(0, 0f);
          ca2.transform.localScale = new Vector3(1f, 1f);
          var ca2Sprite = ca2.AddComponent<SpriteRenderer>();
          ca2Sprite.sprite = ModAPI.LoadSprite("image/Bonneyhat.png");
          ca2.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          ca2.AddComponent<UseEventTrigger>().Action = () => {
          ca2Sprite.sprite = ModAPI.LoadSprite("none.png");
          };




           }
        }
      }
);
            ModAPI.Register(
                new Modification()
                    {
               OriginalItem = ModAPI.FindSpawnable("Human"),
               NameOverride = "Otama",
               NameToOrderByOverride = "Z1",
               DescriptionOverride = "O-Tama is a girl from the region of Kuri in Wano Country. She is a kasa weaver and a kunoichi in training, working under Tenguyama Hitetsu.",
               CategoryOverride = ModAPI.FindCategory("One Piece pack"),
               ThumbnailOverride = ModAPI.LoadSprite("image/otamathumbnail.png"),
               AfterSpawn = (Instance) =>
               {

               var skin = ModAPI.LoadTexture("image/Otama.png");
               var flesh = ModAPI.LoadTexture("Flesh.png");
               var bone = ModAPI.LoadTexture("Bone.png");
               var head = Instance.transform.Find("Head");
               var Lower = Instance.transform.Find("Body").Find("LowerBody");

               head.transform.localScale = new Vector3(1.2f, 1.2f);
               head.transform.localPosition = new Vector3(0.001f, 0.75f);

               var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
               var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


               ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
               ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

               var person = Instance.GetComponent<PersonBehaviour>();
               person.SetBodyTextures(skin, flesh, bone, 1);
               foreach (var body in person.Limbs)
                {
                    body.BaseStrength *= 0.3f;
                    body.Health *= 10f;
                    body.BreakingThreshold *= 1f;
                    body.transform.root.localScale *= 0.97f;


                  var ca = new GameObject("otamahair");
                  ca.transform.SetParent(Instance.transform.Find("Head"));
                  ca.transform.localPosition = new Vector3(0, 0f);
                  ca.transform.localScale = new Vector3(1f, 1f);
                  var caSprite = ca.AddComponent<SpriteRenderer>();
                  caSprite.sprite = ModAPI.LoadSprite("image/otamahair.png");
                  ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
                  ca.AddComponent<UseEventTrigger>().Action = () => {
                  caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                                    };

                  var ca2 = new GameObject("otamacape");
                  ca2.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                  ca2.transform.localPosition = new Vector3(0, 0f);
                  ca2.transform.localScale = new Vector3(1f, 1f);
                  var ca2Sprite = ca2.AddComponent<SpriteRenderer>();
                  ca2Sprite.sprite = ModAPI.LoadSprite("image/otamacape.png");
                  ca2.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                  ca2.AddComponent<UseEventTrigger>().Action = () => {
                  ca2Sprite.sprite = ModAPI.LoadSprite("none.png");
                                                                    };

                                    }
                                }
                            }
            );

            ModAPI.Register(
                  new Modification()
                      {
                 OriginalItem = ModAPI.FindSpawnable("Human"),
                 NameOverride = "Saint Shalria",
                 NameToOrderByOverride = "Z1",
                 DescriptionOverride = "Saint Shalria  is a World Noble, the younger sister of Saint Charlos, and the daughter of Saint Rosward.",
                 CategoryOverride = ModAPI.FindCategory("One Piece pack"),
                 ThumbnailOverride = ModAPI.LoadSprite("image/SaintShalriathumbnail.png"),
                 AfterSpawn = (Instance) =>
                 {

                 var skin = ModAPI.LoadTexture("image/Saint Shalria.png");
                 var flesh = ModAPI.LoadTexture("Flesh.png");
                 var bone = ModAPI.LoadTexture("Bone.png");
                 var head = Instance.transform.Find("Head");
                 var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
                 var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
                 var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                 var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                 var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
                 var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
                 var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                 var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                 var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
                 var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
                 var upper = Instance.transform.Find("Body").Find("UpperBody");
                 var middle = Instance.transform.Find("Body").Find("MiddleBody");
                 var Lower = Instance.transform.Find("Body").Find("LowerBody");

                 upper.transform.localScale = new Vector3(1.2f, 1.1f);
                 middle.transform.localScale = new Vector3(1.3f, 1.1f);
                 Lower.transform.localScale = new Vector3(1.3f, 1.1f);
                 leg3.transform.localScale = new Vector3(1.12f, 1.2f);
                 leg4.transform.localScale = new Vector3(1.12f, 1.2f);
                 leg1.transform.localScale = new Vector3(1.12f, 1.2f);
                 leg2.transform.localScale = new Vector3(1.12f, 1.2f);
                 foot1.transform.localScale = new Vector3(1.12f, 1.2f);
                 foot2.transform.localScale = new Vector3(1.12f, 1.2f);

                 head.transform.localScale = new Vector3(0.9f, 0.9f);

                 head.transform.localPosition = new Vector3(0.01f, 0.73f);

                 upper.transform.localPosition = new Vector3(0f, 0.45f);
                 leg3.transform.localPosition = new Vector3(0f, -0.46f);
                 leg4.transform.localPosition = new Vector3(0f, -0.46f);
                 leg1.transform.localPosition = new Vector3(0f, -0.96f);
                 leg2.transform.localPosition = new Vector3(0f, -0.96f);
                 foot1.transform.localPosition = new Vector3(0.064f, -1.25f);
                 foot2.transform.localPosition = new Vector3(0.064f, -1.25f);

                 head.transform.localScale = new Vector3(0.8f, 0.8f);

                 var person = Instance.GetComponent<PersonBehaviour>();
                 person.SetBodyTextures(skin, flesh, bone, 1);
                 foreach (var body in person.Limbs)
                  {
                      body.BaseStrength *= 1f;
                      body.Health *= 8f;
                      body.BreakingThreshold *= 1f;
                      body.transform.root.localScale *= 1f;

                      var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                      var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


                      ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                      ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                    var ca = new GameObject("Saint Shalriahair");
                    ca.transform.SetParent(Instance.transform.Find("Head"));
                    ca.transform.localPosition = new Vector3(0, 0f);
                    ca.transform.localScale = new Vector3(1f, 1f);
                    var caSprite = ca.AddComponent<SpriteRenderer>();
                    caSprite.sprite = ModAPI.LoadSprite("image/Saint Shalriahair.png");
                    ca.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                    ca.AddComponent<UseEventTrigger>().Action = () => {
                    caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                                      };


                    var backpack = new GameObject("Saint Shalriahelmet");
                    backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                    backpack.transform.localPosition = new Vector3(0, 0f);
                    backpack.transform.localScale = new Vector3(1f, 1f);
                    var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                    backpackSprite.sprite = ModAPI.LoadSprite("image/Saint Shalriahelmet.png");
                    backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                    backpack.AddComponent<UseEventTrigger>().Action = () => {
                    backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                                            };
                    var ca2 = new GameObject("Saint Shalriacape");
                    ca2.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                    ca2.transform.localPosition = new Vector3(0, 0f);
                    ca2.transform.localScale = new Vector3(1f, 1f);
                    var ca2Sprite = ca2.AddComponent<SpriteRenderer>();
                    ca2Sprite.sprite = ModAPI.LoadSprite("image/Saint Shalriacape.png");
                    ca2.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                    ca2.AddComponent<UseEventTrigger>().Action = () => {
                    ca2Sprite.sprite = ModAPI.LoadSprite("none.png");
                                                                      };



                                      }
                                  }
                              }
                         );
  ModAPI.Register(
      new Modification()
          {
     OriginalItem = ModAPI.FindSpawnable("Human"),
     NameOverride = "Gol D. Roger",
     NameToOrderByOverride = "Z1",
     DescriptionOverride = "Gol D. Roger,  was a legendary pirate who, as captain of the Roger Pirates,He is also known as the pirate king." + "\n <color=red>King of the pirates ",
     CategoryOverride = ModAPI.FindCategory("One Piece pack"),
     ThumbnailOverride = ModAPI.LoadSprite("image/goldrogerthumbnail.png"),
     AfterSpawn = (Instance) =>
     {

     var skin = ModAPI.LoadTexture("image/Gol D. Roger.png");
     var flesh = ModAPI.LoadTexture("Flesh.png");
     var bone = ModAPI.LoadTexture("Bone.png");


     var person = Instance.GetComponent<PersonBehaviour>();

     var head = Instance.transform.Find("Head");
     var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
     var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
     var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
     var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
     var upper = Instance.transform.Find("Body").Find("UpperBody");
     AudioSource Audio = Instance.AddComponent<AudioSource>();
     Audio.maxDistance = 10;
     Audio.loop = false;
     Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

     head.gameObject.AddComponent<hao>();
     arm1.gameObject.AddComponent<Busoshoku>();
     arm2.gameObject.AddComponent<Busoshoku>();
     leg1.gameObject.AddComponent<Busoshoku>();
     leg2.gameObject.AddComponent<Busoshoku>();






     person.SetBodyTextures(skin, flesh, bone, 1);
     foreach (var body in person.Limbs)
      {
        body.BaseStrength *= 0.4f;
        body.Health *= 11000f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.01f;
        body.gameObject.AddComponent<strongrege>();
      UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
      useEventTrigger.Event = new UnityEvent();
      useEventTrigger.Event.AddListener(delegate ()
       {
        body.ImmuneToDamage = true;
        arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
        arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
        arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
        arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
        Audio.Play();
      });

      UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
      useEventTrigger1.Event = new UnityEvent();
      useEventTrigger1.Event.AddListener(delegate ()
       {
         body.ImmuneToDamage = false;
         arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
         arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
         arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
         arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
         Audio.Play();
      });


        var ornamentobject = new GameObject("rogerhair.png");
        ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
        ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
        ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
        ornamentobject.transform.localScale = new Vector3(1f, 1f);
        var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
        ornamentsprite.sprite = ModAPI.LoadSprite("image/rogerhair.png",2f);
        ornamentsprite.sortingLayerName = "Middle";

      //cape3
       var backpack = new GameObject("cape3");
       backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
       backpack.transform.localPosition = new Vector3(0, 0f);
       backpack.transform.localScale = new Vector3(1f, 1f);
       var backpackSprite = backpack.AddComponent<SpriteRenderer>();
       backpackSprite.sprite = ModAPI.LoadSprite("image/cape3.png");
       backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
       backpack.AddComponent<UseEventTrigger>().Action = () => {
       backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                               };

      //GSword
        var ca = new GameObject("GSword");
        ca.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
        ca.transform.localPosition = new Vector3(0, 0f);
        ca.transform.localScale = new Vector3(1f, 1f);
        var caSprite = ca.AddComponent<SpriteRenderer>();
        caSprite.sprite = ModAPI.LoadSprite("image/GSword.png");
        ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
        ca.AddComponent<UseEventTrigger>().Action = () => {
        caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                           };

        person.SetBruiseColor(000, 000, 000);
        person.SetSecondBruiseColor(000, 000, 000);
        person.SetThirdBruiseColor(000, 000, 000);
        person.SetBloodColour(000, 000, 000);
        person.SetRottenColour(000, 000, 000);


            }
         }
      }
   );

   ModAPI.Register(
       new Modification()
           {
      OriginalItem = ModAPI.FindSpawnable("Human"),
      NameOverride = "Silvers Rayleigh",
      NameToOrderByOverride = "Z1",
      DescriptionOverride = "Silvers Rayleigh, also known as the Dark King is an extremely powerful and famous retired pirate who formerly served as the first mate of the legendary Roger Pirates.",
      CategoryOverride = ModAPI.FindCategory("One Piece pack"),
      ThumbnailOverride = ModAPI.LoadSprite("image/Silvers Rayleighthumbnail.png"),
      AfterSpawn = (Instance) =>
      {

      var skin = ModAPI.LoadTexture("image/Silvers Rayleigh.png");
      var flesh = ModAPI.LoadTexture("Flesh.png");
      var bone = ModAPI.LoadTexture("Bone.png");


      var person = Instance.GetComponent<PersonBehaviour>();

      var head = Instance.transform.Find("Head");
      var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
      var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
      var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
      var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
      var upper = Instance.transform.Find("Body").Find("UpperBody");
      AudioSource Audio = Instance.AddComponent<AudioSource>();
      Audio.maxDistance = 10;
      Audio.loop = false;
      Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");


      head.gameObject.AddComponent<hao>();
      arm1.gameObject.AddComponent<Busoshoku>();
      arm2.gameObject.AddComponent<Busoshoku>();
      leg1.gameObject.AddComponent<Busoshoku>();
      leg2.gameObject.AddComponent<Busoshoku>();



      person.SetBodyTextures(skin, flesh, bone, 1);
      foreach (var body in person.Limbs)
       {
         body.BaseStrength *= 0.4f;
         body.Health *= 11000f;
         body.BreakingThreshold *= 1f;
         body.IsAndroid = true;
         body.transform.root.localScale *= 1f;
         body.gameObject.AddComponent<strongrege>();
         UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
         useEventTrigger.Event = new UnityEvent();
         useEventTrigger.Event.AddListener(delegate ()
          {
           body.ImmuneToDamage = true;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
           Audio.Play();
         });

         UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
         useEventTrigger1.Event = new UnityEvent();
         useEventTrigger1.Event.AddListener(delegate ()
          {
            body.ImmuneToDamage = false;
            arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
            arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
            Audio.Play();
         });


         var ornamentobject = new GameObject("Rayleighhair.png");
         ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
         ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
         ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
         ornamentobject.transform.localScale = new Vector3(1f, 1f);
         var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
         ornamentsprite.sprite = ModAPI.LoadSprite("image/Rayleighhair.png",2f);
         ornamentsprite.sortingLayerName = "Middle";



         var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
         var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");

         ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
         ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";




         person.SetBruiseColor(000, 000, 000);
         person.SetSecondBruiseColor(000, 000, 000);
         person.SetThirdBruiseColor(000, 000, 000);
         person.SetBloodColour(000, 000, 000);
         person.SetRottenColour(000, 000, 000);


             }
          }
       }
);

  ModAPI.Register(
      new Modification()
          {
     OriginalItem = ModAPI.FindSpawnable("Human"),
     NameOverride = "Monkey D. Garp",
     NameToOrderByOverride = "Z1",
     DescriptionOverride = "Monkey D. Garp is an extremely famous and powerful Marine vice admiral." + "\n <color=blue>Hero of the Navy ",
     CategoryOverride = ModAPI.FindCategory("One Piece pack"),
     ThumbnailOverride = ModAPI.LoadSprite("image/Monkey D. Garpthumbnail.png"),
     AfterSpawn = (Instance) =>
     {

     var skin = ModAPI.LoadTexture("image/Monkey D. Garp.png");
     var flesh = ModAPI.LoadTexture("Flesh.png");
     var bone = ModAPI.LoadTexture("Bone.png");



     var person = Instance.GetComponent<PersonBehaviour>();

     var head = Instance.transform.Find("Head");
     var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
     var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
     var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
     var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
     var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
     var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
     var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
     var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
     var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
     var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
     var upper = Instance.transform.Find("Body").Find("UpperBody");
     var middle = Instance.transform.Find("Body").Find("MiddleBody");
     var Lower = Instance.transform.Find("Body").Find("LowerBody");

     upper.transform.localScale = new Vector3(1.4f, 1.2f);
     middle.transform.localScale = new Vector3(1.3f, 1.2f);
     Lower.transform.localScale = new Vector3(1.2f, 1f);
     arm3.transform.localScale = new Vector3(1.3f, 1.2f);
     arm4.transform.localScale = new Vector3(1.3f, 1.2f);
     arm1.transform.localScale = new Vector3(1.3f, 1.2f);
     arm2.transform.localScale = new Vector3(1.3f, 1.2f);
     leg3.transform.localScale = new Vector3(1.19f, 1.2f);
     leg4.transform.localScale = new Vector3(1.19f, 1.2f);
     leg1.transform.localScale = new Vector3(1.19f, 1.2f);
     leg2.transform.localScale = new Vector3(1.19f, 1.2f);
     foot1.transform.localScale = new Vector3(1.19f, 1.2f);
     foot2.transform.localScale = new Vector3(1.19f, 1.2f);
     head.transform.localScale = new Vector3(0.9f, 0.9f);

     head.transform.localPosition = new Vector3(0.02f, 0.73f);
     arm3.transform.localPosition = new Vector3(0f, -0.15f);
     arm4.transform.localPosition = new Vector3(0f, -0.15f);
     arm1.transform.localPosition = new Vector3(0f, -0.60f);
     arm2.transform.localPosition = new Vector3(0f, -0.60f);
     leg3.transform.localPosition = new Vector3(0f, -0.46f);
     leg4.transform.localPosition = new Vector3(0f, -0.46f);
     leg1.transform.localPosition = new Vector3(0f, -0.96f);
     leg2.transform.localPosition = new Vector3(0f, -0.96f);
     foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
     foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
     AudioSource Audio = Instance.AddComponent<AudioSource>();
     Audio.maxDistance = 10;
     Audio.loop = false;
     Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

     leg1.gameObject.AddComponent<Busoshoku>();
     leg2.gameObject.AddComponent<Busoshoku>();
     arm1.gameObject.AddComponent<ryuo>();
     arm2.gameObject.AddComponent<ryuo>();
     person.SetBodyTextures(skin, flesh, bone, 1);
     foreach (var body in person.Limbs)
      {
         body.BaseStrength *= 0.4f;
         body.Health *= 11000f;
         body.BreakingThreshold *= 1f;
         body.IsAndroid = true;
         body.transform.root.localScale *= 1.02f;
         body.gameObject.AddComponent<strongrege>();

         UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
         useEventTrigger.Event = new UnityEvent();
         useEventTrigger.Event.AddListener(delegate ()
          {
           body.ImmuneToDamage = true;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
           Audio.Play();
         });

         UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
         useEventTrigger1.Event = new UnityEvent();
         useEventTrigger1.Event.AddListener(delegate ()
          {
            body.ImmuneToDamage = false;
            arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
            arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
            Audio.Play();
         });

         var ornamentobject = new GameObject("garphair.png");
         ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
         ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
         ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
         ornamentobject.transform.localScale = new Vector3(1f, 1f);
         var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
         ornamentsprite.sprite = ModAPI.LoadSprite("image/garphair.png",2f);
         ornamentsprite.sortingLayerName = "Middle";

      //cape4
       var backpack = new GameObject("cape4");
       backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
       backpack.transform.localPosition = new Vector3(0, 0f);
       backpack.transform.localScale = new Vector3(1f, 1f);
       var backpackSprite = backpack.AddComponent<SpriteRenderer>();
       backpackSprite.sprite = ModAPI.LoadSprite("image/cape4.png");
       backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
       backpack.AddComponent<UseEventTrigger>().Action = () => {
       backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                               };

      person.SetBruiseColor(000, 000, 000);
      person.SetSecondBruiseColor(000, 000, 000);
      person.SetThirdBruiseColor(000, 000, 000);
      person.SetBloodColour(000, 000, 000);
      person.SetRottenColour(000, 000, 000);



             }
          }
       }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Sengoku",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Sengoku the Buddha is a former fleet admiral of the Marines, succeeding Kong and preceding Sakazuki. Sometime during the timeskip, he became an Inspector General.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Sengokuthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Sengoku.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.4f, 1.2f);
   middle.transform.localScale = new Vector3(1.3f, 1.2f);
   Lower.transform.localScale = new Vector3(1.2f, 1f);
   arm3.transform.localScale = new Vector3(1.3f, 1.2f);
   arm4.transform.localScale = new Vector3(1.3f, 1.2f);
   arm1.transform.localScale = new Vector3(1.3f, 1.2f);
   arm2.transform.localScale = new Vector3(1.3f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.02f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<forceBusoshoku>();
   arm2.gameObject.AddComponent<forceBusoshoku>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
       body.BaseStrength *= 0.4f;
       body.Health *= 11000f;
       body.BreakingThreshold *= 1f;
       body.IsAndroid = true;
       body.transform.root.localScale *= 1.01f;
       body.gameObject.AddComponent<strongrege>();
       UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger.Event = new UnityEvent();
       useEventTrigger.Event.AddListener(delegate ()
        {
         body.ImmuneToDamage = true;
         arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         Audio.Play();
       });

       UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger1.Event = new UnityEvent();
       useEventTrigger1.Event.AddListener(delegate ()
        {
          body.ImmuneToDamage = false;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          Audio.Play();
       });


         var ca = new GameObject("sengokuhair");
         ca.transform.SetParent(Instance.transform.Find("Head"));
         ca.transform.localPosition = new Vector3(0, 0f);
         ca.transform.localScale = new Vector3(1f, 1f);
         var caSprite = ca.AddComponent<SpriteRenderer>();
         caSprite.sprite = ModAPI.LoadSprite("image/sengokuhair.png");
         ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
         ca.AddComponent<UseEventTrigger>().Action = () => {
         caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                          };

    //cape4
     var backpack = new GameObject("cape4");
     backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
     backpack.transform.localPosition = new Vector3(0, 0f);
     backpack.transform.localScale = new Vector3(1f, 1f);
     var backpackSprite = backpack.AddComponent<SpriteRenderer>();
     backpackSprite.sprite = ModAPI.LoadSprite("image/cape4.png");
     backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
     backpack.AddComponent<UseEventTrigger>().Action = () => {
     backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                             };

    person.SetBruiseColor(000, 000, 000);
    person.SetSecondBruiseColor(000, 000, 000);
    person.SetThirdBruiseColor(000, 000, 000);
    person.SetBloodColour(000, 000, 000);
    person.SetRottenColour(000, 000, 000);



           }
        }
     }
);

ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
    NameOverride = "Edward Newgate Old", //new item name with a suffix to assure it is globally unique
    NameToOrderByOverride = "Z1",
    DescriptionOverride = "Edward Newgate more commonly known as Whitebeard was the captain of the Whitebeard Pirates Old shape.", //new item description
    CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
    ThumbnailOverride = ModAPI.LoadSprite("image/Edward Newgate Oldthumbnnail.png"), //new item thumbnail (relative path)
    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
    {
        //load textures for each layer (see Human textures folder in this repository)
        var skin = ModAPI.LoadTexture("image/Edward Newgate old.png");
        var flesh = ModAPI.LoadTexture("Flesh.png");
        var bone = ModAPI.LoadTexture("Bone.png");

        var person = Instance.GetComponent<PersonBehaviour>();

        var head = Instance.transform.Find("Head");
        var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
        var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
        var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
        var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
        var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
        var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
        var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
        var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
        var upper = Instance.transform.Find("Body").Find("UpperBody");
        var middle = Instance.transform.Find("Body").Find("MiddleBody");
        var Lower = Instance.transform.Find("Body").Find("LowerBody");

        upper.transform.localScale = new Vector3(1.4f, 1.2f);
        middle.transform.localScale = new Vector3(1.3f, 1.2f);
        Lower.transform.localScale = new Vector3(1.2f, 1f);
        arm3.transform.localScale = new Vector3(1.3f, 1.2f);
        arm4.transform.localScale = new Vector3(1.3f, 1.2f);
        arm1.transform.localScale = new Vector3(1.3f, 1.2f);
        arm2.transform.localScale = new Vector3(1.3f, 1.2f);
        leg3.transform.localScale = new Vector3(1.43f, 1.2f);
        leg4.transform.localScale = new Vector3(1.43f, 1.2f);
        leg1.transform.localScale = new Vector3(1.19f, 1.2f);
        leg2.transform.localScale = new Vector3(1.19f, 1.2f);
        foot1.transform.localScale = new Vector3(1.19f, 1.2f);
        foot2.transform.localScale = new Vector3(1.19f, 1.2f);
        head.transform.localScale = new Vector3(0.9f, 0.9f);

        head.transform.localPosition = new Vector3(0.02f, 0.73f);
        leg3.transform.localPosition = new Vector3(0f, -0.46f);
        leg4.transform.localPosition = new Vector3(0f, -0.46f);
        leg1.transform.localPosition = new Vector3(0f, -0.96f);
        leg2.transform.localPosition = new Vector3(0f, -0.96f);
        foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
        foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

        arm3.transform.localPosition = new Vector3(0f, -0.15f);
        arm4.transform.localPosition = new Vector3(0f, -0.15f);
        arm1.transform.localPosition = new Vector3(0f, -0.60f);
        arm2.transform.localPosition = new Vector3(0f, -0.60f);

        head.gameObject.AddComponent<hao>();
        arm1.gameObject.AddComponent<forceBusoshoku>();
        arm2.gameObject.AddComponent<forceBusoshoku>();
        arm1.gameObject.AddComponent<guraguranomi>();
        arm2.gameObject.AddComponent<guraguranomi>();
        leg1.gameObject.AddComponent<Busoshoku>();
        leg2.gameObject.AddComponent<Busoshoku>();


        foreach (var body in person.Limbs)
        {
          body.BaseStrength *= 13f;
          body.Health *= 666f;
          body.DoStumble = true;
          body.DoBalanceJerk = true;
          body.Wince(0f);
          body.Vitality = 50f;
          body.IsAndroid = true;
          body.transform.root.localScale *= 1.09f;
          body.PhysicalBehaviour.BurningProgressionMultiplier = -100;
          body.gameObject.AddComponent<strongrege>();


      //Edward Newgate old1.png
        var ca = new GameObject("Edward Newgate old1.png");
        ca.transform.SetParent(Instance.transform.Find("Head"));
        ca.transform.localPosition = new Vector3(0, 0f);
        ca.transform.localScale = new Vector3(1f, 1f);
        var caSprite = ca.AddComponent<SpriteRenderer>();
        caSprite.sprite = ModAPI.LoadSprite("image/Edward Newgate old1.png");
        ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
        ca.AddComponent<UseEventTrigger>().Action = () => {
        caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                          };

      //cape2
       var backpack = new GameObject("cape2");
       backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
       backpack.transform.localPosition = new Vector3(0, 0f);
       backpack.transform.localScale = new Vector3(1f, 1f);
       var backpackSprite = backpack.AddComponent<SpriteRenderer>();
       backpackSprite.sprite = ModAPI.LoadSprite("image/cape2.png");
       backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
       backpack.AddComponent<UseEventTrigger>().Action = () => {
       backpackSprite.sprite = ModAPI.LoadSprite("none.png");

      };

        }
        person.SetBodyTextures(skin, flesh, bone, 1);
        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
        person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
    }
}
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = ""+"\n <color=yellow>Shiki",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = ""+"\n <color=white>Shiki the Golden Lion, also known as the Flying Pirate, is the admiral of the Golden Lion Pirates, the first known prisoner ever to escape from Impel Down and a former member of the Rocks Pirates." + "\n <color=yellow>Golden Lion",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Shikithumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Shiki.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.4f, 1.2f);
   middle.transform.localScale = new Vector3(1.4f, 1.2f);
   Lower.transform.localScale = new Vector3(1.4f, 1.2f);
   arm3.transform.localScale = new Vector3(1.15f, 1.1f);
   arm4.transform.localScale = new Vector3(1.14f, 1.1f);
   arm1.transform.localScale = new Vector3(1.14f, 1.1f);
   arm2.transform.localScale = new Vector3(1.14f, 1.1f);
   leg3.transform.localScale = new Vector3(1.2f, 1f);
   leg4.transform.localScale = new Vector3(1.2f, 1f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);

   arm3.transform.localPosition = new Vector3(0f, -0.12f);
   arm4.transform.localPosition = new Vector3(0f, -0.12f);
   arm1.transform.localPosition = new Vector3(0f, -0.54f);
   arm2.transform.localPosition = new Vector3(0f, -0.54f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();
   arm1.gameObject.AddComponent<Antigravity>();
   arm2.gameObject.AddComponent<Antigravity>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();


   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
       body.BaseStrength *= 0.5f;
       body.Health *= 10000000f;
       body.BreakingThreshold *= 100f;
       body.IsAndroid = true;
       body.transform.root.localScale *= 1.03f;
       body.PhysicalBehaviour.BurningProgressionMultiplier = -10000000;
       body.gameObject.AddComponent<strongrege>();
       UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger.Event = new UnityEvent();
       useEventTrigger.Event.AddListener(delegate ()
        {
         body.ImmuneToDamage = true;
         arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         Audio.Play();
       });

       UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger1.Event = new UnityEvent();
       useEventTrigger1.Event.AddListener(delegate ()
        {
          body.ImmuneToDamage = false;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          Audio.Play();
       });

     var ornamentobject = new GameObject("Shikihair.png");
     ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
     ornamentobject.transform.localPosition = new Vector3(-0.03f, -0.3f);
     ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
     ornamentobject.transform.localScale = new Vector3(1f, 1f);
     var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
     ornamentsprite.sprite = ModAPI.LoadSprite("image/Shikihair.png",2f);
     ornamentsprite.sortingLayerName = "Middle";

       var ca = new GameObject("Shikicape.png");
       ca.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
       ca.transform.localPosition = new Vector3(0, 0f);
       ca.transform.localScale = new Vector3(1f, 1f);
       var caSprite = ca.AddComponent<SpriteRenderer>();
       caSprite.sprite = ModAPI.LoadSprite("image/Shikicape.png");
       ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
       ca.AddComponent<UseEventTrigger>().Action = () => {
       caSprite.sprite = ModAPI.LoadSprite("none.png");
       };

       var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
       var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


       ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
       ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";


      person.SetBruiseColor(000, 000, 000);
      person.SetSecondBruiseColor(000, 000, 000);
      person.SetThirdBruiseColor(000, 000, 000);
      person.SetBloodColour(000, 000, 000);
      person.SetRottenColour(000, 000, 000);

           }
        }
     }
 );

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Byrnndi World",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Byrnndi World is a powerful pirate who caused havoc on the seas over 30 years ago and is the captain of the World Pirates He also is Byojack's younger brother.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/ByrnndiWorldthumb.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Byrnndi World.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");
   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.5f, 1.2f);
   middle.transform.localScale = new Vector3(1.4f, 1.2f);
   Lower.transform.localScale = new Vector3(1.3f, 1.2f);
   arm3.transform.localScale = new Vector3(1.7f, 1.25f);
   arm4.transform.localScale = new Vector3(1.7f, 1.25f);
   arm1.transform.localScale = new Vector3(1.7f, 1.3f);
   arm2.transform.localScale = new Vector3(1.7f, 1.3f);
   leg3.transform.localScale = new Vector3(1.3f, 1f);
   leg4.transform.localScale = new Vector3(1.3f, 1f);

   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);

   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.61f);
   arm2.transform.localPosition = new Vector3(0f, -0.61f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();

   var person = Instance.GetComponent<PersonBehaviour>();
   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 2f;
        body.Health *= 100f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.04f;
        body.gameObject.AddComponent<strongrege>();
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });



        var ca = new GameObject("ByrnndiWorldhat");
        ca.transform.SetParent(Instance.transform.Find("Head"));
        ca.transform.localPosition = new Vector3(0, 0f);
        ca.transform.localScale = new Vector3(1f, 1f);
        var caSprite = ca.AddComponent<SpriteRenderer>();
        caSprite.sprite = ModAPI.LoadSprite("image/ByrnndiWorldhat.png");
        ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        ca.AddComponent<UseEventTrigger>().Action = () => {
        caSprite.sprite = ModAPI.LoadSprite("none.png");
        };

        var ca2 = new GameObject("ByrnndiWorldhair");
        ca2.transform.SetParent(Instance.transform.Find("Head"));
        ca2.transform.localPosition = new Vector3(0, 0f);
        ca2.transform.localScale = new Vector3(1f, 1f);
        var ca2Sprite = ca2.AddComponent<SpriteRenderer>();
        ca2Sprite.sprite = ModAPI.LoadSprite("image/ByrnndiWorldhair.png");
        ca2.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        ca2.AddComponent<UseEventTrigger>().Action = () => {
        ca2Sprite.sprite = ModAPI.LoadSprite("none.png");
        };

        var ca3 = new GameObject("ByrnndiWorldcape");
        ca3.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
        ca3.transform.localPosition = new Vector3(0, 0f);
        ca3.transform.localScale = new Vector3(1f, 1f);
        var ca3Sprite = ca3.AddComponent<SpriteRenderer>();
        ca3Sprite.sprite = ModAPI.LoadSprite("image/ByrnndiWorldcape.png");
        ca3.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
        ca3.AddComponent<UseEventTrigger>().Action = () => {
        ca3Sprite.sprite = ModAPI.LoadSprite("none.png");
      };


                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Gild Tesoro",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Gild Tesoro,also known as the Casino King, was the proprietor of Gran Tesoro, the largest entertainment city-ship in the world, before his defeat by the Straw Hat Pirates and arrest by the Marines.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/GildTesorothumb.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Gild Tesoro.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");
   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.2f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();

   var person = Instance.GetComponent<PersonBehaviour>();
   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 0.3f;
        body.Health *= 100f;
        body.BreakingThreshold *= 1f;
        body.transform.root.localScale *= 1.02f;
        body.IsAndroid = true;
        body.gameObject.AddComponent<strongrege>();
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(255f, 255f, 0f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(255f, 255f, 0f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });

        var ca = new GameObject("GildTesorohair");
        ca.transform.SetParent(Instance.transform.Find("Head"));
        ca.transform.localPosition = new Vector3(0, 0f);
        ca.transform.localScale = new Vector3(1f, 1f);
        var caSprite = ca.AddComponent<SpriteRenderer>();
        caSprite.sprite = ModAPI.LoadSprite("image/GildTesorohair.png");
        ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
        ca.AddComponent<UseEventTrigger>().Action = () => {
        caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                           };

        var ca2 = new GameObject("GildTesoroflower");
        ca2.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
        ca2.transform.localPosition = new Vector3(0, 0f);
        ca2.transform.localScale = new Vector3(1f, 1f);
        var ca2Sprite = ca2.AddComponent<SpriteRenderer>();
        ca2Sprite.sprite = ModAPI.LoadSprite("image/GildTesoroflower.png");
        ca2.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
        ca2.AddComponent<UseEventTrigger>().Action = () => {
        ca2Sprite.sprite = ModAPI.LoadSprite("none.png");
                                                           };


                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Douglas Bullet",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Douglas Bullet, known as the Demon Heir,After serving as a child soldier in his homeland of Galzburg, he joined the Roger Pirates and was later imprisoned in Impel Down for over 20 years.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/DouglasBulletthumb.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Douglas Bullet.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");
   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.5f, 1.2f);
   middle.transform.localScale = new Vector3(1.4f, 1.2f);
   Lower.transform.localScale = new Vector3(1.3f, 1.2f);
   arm3.transform.localScale = new Vector3(1.7f, 1.25f);
   arm4.transform.localScale = new Vector3(1.7f, 1.25f);
   arm1.transform.localScale = new Vector3(1.7f, 1.3f);
   arm2.transform.localScale = new Vector3(1.7f, 1.3f);
   leg3.transform.localScale = new Vector3(1.3f, 1f);
   leg4.transform.localScale = new Vector3(1.3f, 1f);

   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);

   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.61f);
   arm2.transform.localPosition = new Vector3(0f, -0.61f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();

   var person = Instance.GetComponent<PersonBehaviour>();
   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 2f;
        body.Health *= 1000f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.04f;
        body.gameObject.AddComponent<strongrege>();
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });



        var ca = new GameObject("DouglasBullethair");
        ca.transform.SetParent(Instance.transform.Find("Head"));
        ca.transform.localPosition = new Vector3(0, 0f);
        ca.transform.localScale = new Vector3(1f, 1f);
        var caSprite = ca.AddComponent<SpriteRenderer>();
        caSprite.sprite = ModAPI.LoadSprite("image/DouglasBullethair.png");
        ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
        ca.AddComponent<UseEventTrigger>().Action = () => {
        caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                          };


                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Zephyr",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Z, also known by his birth name and former epithet Black Arm Zephyr, was the leader and founder of the Neo Marines as well as a former Marine Admiral and instructor before his resignation.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Zephyrthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Zephyr.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.4f, 1.2f);
   middle.transform.localScale = new Vector3(1.3f, 1.2f);
   Lower.transform.localScale = new Vector3(1.2f, 1f);
   arm3.transform.localScale = new Vector3(2.3f, 1.7f);
   arm4.transform.localScale = new Vector3(1.3f, 1.2f);
   arm1.transform.localScale = new Vector3(3.2f, 2.5f);
   arm2.transform.localScale = new Vector3(1.3f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.02f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.23f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -1.05f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");


   arm2.gameObject.AddComponent<Busoshoku>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
       body.BaseStrength *= 0.5f;
       body.Health *= 100f;
       body.BreakingThreshold *= 100f;
       body.IsAndroid = true;
       body.transform.root.localScale *= 1.03f;
       arm3.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
       arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
       body.gameObject.AddComponent<strongrege>();
       if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArmFront")
       {
           body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
           {
               GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
               HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(255, 255, 0);
               HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(255, 255, 0);

               ModAPI.CreateParticleEffect("Vapor", new Vector2(arm1.transform.position.x, arm1.transform.position.y + 0.1f));
               HandOBJ2.transform.position = body.gameObject.transform.position;
               HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
               HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

           };
       }

       var Hand = new GameObject("Hand");
       Hand.transform.SetParent(Instance.transform.Find("BackArm").Find("UpperArm"));
       Hand.transform.localPosition = new Vector3(0, 0f);
       Hand.transform.localScale = new Vector3(1f, 1f);
       var HandSprite = Hand.AddComponent<SpriteRenderer>();
       HandSprite.sprite = ModAPI.LoadSprite("image/Zephyrarm2.png");
       HandSprite.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";

       var Up = new GameObject("Up");
       Up.transform.SetParent(Instance.transform.Find("BackArm").Find("LowerArm"));
       Up.transform.localPosition = new Vector3(0, 0f);
       Up.transform.localScale = new Vector3(1f, 1f);
       var UpSprite = Up.AddComponent<SpriteRenderer>();
       UpSprite.sprite = ModAPI.LoadSprite("image/Zephyrarm1.png");
       Up.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";

       UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger.Event = new UnityEvent();
       useEventTrigger.Event.AddListener(delegate ()
        {
         arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         Audio.Play();
       });

       UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger1.Event = new UnityEvent();
       useEventTrigger1.Event.AddListener(delegate ()
        {
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          Audio.Play();
       });

       var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
       var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");

       ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
       ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

       var ornamentobject = new GameObject("Zephyrhair.png");
       ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
       ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
       ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
       ornamentobject.transform.localScale = new Vector3(1f, 1f);
       var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
       ornamentsprite.sprite = ModAPI.LoadSprite("image/Zephyrhair.png",2f);
       ornamentsprite.sortingLayerName = "Top";



     var ca2 = new GameObject("Zephyrcape.png");
     ca2.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
     ca2.transform.localPosition = new Vector3(0, 0f);
     ca2.transform.localScale = new Vector3(1f, 1f);
     var ca2Sprite = ca2.AddComponent<SpriteRenderer>();
     ca2Sprite.sprite = ModAPI.LoadSprite("image/Zephyrcape.png");
     ca2.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
     ca2.AddComponent<UseEventTrigger>().Action = () => {
     ca2Sprite.sprite = ModAPI.LoadSprite("none.png");
                                                         };

     person.SetBruiseColor(000, 000, 000);
     person.SetSecondBruiseColor(000, 000, 000);
     person.SetThirdBruiseColor(000, 000, 000);
     person.SetBloodColour(000, 000, 000);
     person.SetRottenColour(000, 000, 000);

           }
        }
     }
   );

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = ""+"\n <color=green>Monkey D. Dragon",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = ""+"\n <color=white>Monkey D. Dragon, commonly known as the World's Worst Criminal, is the infamous Supreme Commander of the Revolutionary Army who has been attempting to overthrow the World Government." + "\n <color=green>World's Worst Criminal ",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Monkey D. Dragonthumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Monkey D. Dragon.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");



   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.4f, 1.2f);
   middle.transform.localScale = new Vector3(1.3f, 1.2f);
   Lower.transform.localScale = new Vector3(1.2f, 1f);
   arm3.transform.localScale = new Vector3(1.3f, 1.2f);
   arm4.transform.localScale = new Vector3(1.3f, 1.2f);
   arm1.transform.localScale = new Vector3(1.3f, 1.2f);
   arm2.transform.localScale = new Vector3(1.3f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.02f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<dragonpower>();
   arm2.gameObject.AddComponent<dragonpower>();
   arm1.gameObject.AddComponent<forceBusoshoku>();
   arm2.gameObject.AddComponent<forceBusoshoku>();
   leg1.gameObject.AddComponent<Busoshoku>();
   leg2.gameObject.AddComponent<Busoshoku>();
   arm1.gameObject.AddComponent<ryuo>();
   arm2.gameObject.AddComponent<ryuo>();
   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
       body.BaseStrength *= 0.4f;
       body.Health *= 11000f;
       body.BreakingThreshold *= 1f;
       body.IsAndroid = true;
       body.transform.root.localScale *= 1.01f;
       body.gameObject.AddComponent<strongrege>();

       UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger.Event = new UnityEvent();
       useEventTrigger.Event.AddListener(delegate ()
        {
         body.ImmuneToDamage = true;
         arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
         arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
         Audio.Play();
       });

       UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger1.Event = new UnityEvent();
       useEventTrigger1.Event.AddListener(delegate ()
        {
          body.ImmuneToDamage = false;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          Audio.Play();
       });


       var ornamentobject = new GameObject("dragonhair.png");
       ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
       ornamentobject.transform.localPosition = new Vector3(-0.03f, -0.3f);
       ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
       ornamentobject.transform.localScale = new Vector3(1f, 1f);
       var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
       ornamentsprite.sprite = ModAPI.LoadSprite("image/dragonhair.png",2f);
       ornamentsprite.sortingLayerName = "Middle";

    //cape19
     var backpack = new GameObject("cape19");
     backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
     backpack.transform.localPosition = new Vector3(0, 0f);
     backpack.transform.localScale = new Vector3(1f, 1f);
     var backpackSprite = backpack.AddComponent<SpriteRenderer>();
     backpackSprite.sprite = ModAPI.LoadSprite("image/cape19.png");
     backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
     backpack.AddComponent<UseEventTrigger>().Action = () => {
     backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                             };

    person.SetBruiseColor(000, 000, 000);
    person.SetSecondBruiseColor(000, 000, 000);
    person.SetThirdBruiseColor(000, 000, 000);
    person.SetBloodColour(000, 000, 000);
    person.SetRottenColour(000, 000, 000);



           }
        }
     }
  );

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Portgas D. Ace",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "nicknamed Fire Fist Ace, was the sworn older brother of Luffy and Sabo, and the biological son of the late Pirate King, Gol D. Roger.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Portgas D. Acethunbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Portgas D. Ace.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");

   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.2f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 1;
   Audio.loop = true;
   Audio.clip = ModAPI.LoadSound("Sound/acethem.mp3");

   head.gameObject.AddComponent<hao>();
   arm1.gameObject.AddComponent<Firebeh>();
   arm2.gameObject.AddComponent<Firebeh>();
   arm1.gameObject.AddComponent<Firebeh2>();
   arm2.gameObject.AddComponent<Firebeh2>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 0.1f;
        body.Health *= 100f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1f;
        body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
        body.gameObject.AddComponent<Regeneration>();
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = true;
           body.gameObject.GetComponent<PhysicalBehaviour>().Temperature = 200f;
           body.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 0.5f, 0f, 1f);
           head.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 0.5f, 0f, 1f);
           Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           body.SkinMaterialHandler.ClearAllDamage();
           body.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           upper.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Stop();
        });


    //Ahat
      var ca = new GameObject("Ahat");
      ca.transform.SetParent(Instance.transform.Find("Head"));
      ca.transform.localPosition = new Vector3(0, 0f);
      ca.transform.localScale = new Vector3(1f, 1f);
      var caSprite = ca.AddComponent<SpriteRenderer>();
      caSprite.sprite = ModAPI.LoadSprite("image/Ahat.png");
      ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ca.AddComponent<UseEventTrigger>().Action = () => {
      caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                         };

      var ornamentobject = new GameObject("acehair.png");
      ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
      ornamentobject.transform.localPosition = new Vector3(-0.03f, 0.03f);
      ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
      ornamentobject.transform.localScale = new Vector3(1f, 1f);
      var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
      ornamentsprite.sprite = ModAPI.LoadSprite("image/acehair.png",2f);
      ornamentsprite.sortingLayerName = "Middle";

      var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
      var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


      ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";


      person.SetBodyTextures(skin, flesh, bone, 1);
      person.SetBruiseColor(255, 153, 000); //main bruise colour. purple-ish by default
      person.SetSecondBruiseColor(255, 051, 0000); //second bruise colour. red by default
      person.SetThirdBruiseColor(255, 000, 000); // third bruise colour. light yellow by default
      person.SetBloodColour(255, 102, 000); // blood clour. dark red by default
      person.SetRottenColour(000, 000, 000); // rotten/zombie colour. light yellow/green by default




                        }
                    }
                }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = "Sabo",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = "Sabo is the Revolutionary Army's chief of staff, recognized as the No. 2 of the entire organization outranked only by Supreme Commander Monkey D. Dragon.",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Sabothumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Sabo.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");

   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.2f, 1.2f);
   middle.transform.localScale = new Vector3(1.1f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);
   arm3.transform.localScale = new Vector3(1.18f, 1.2f);
   arm4.transform.localScale = new Vector3(1.18f, 1.2f);
   arm1.transform.localScale = new Vector3(1.18f, 1.2f);
   arm2.transform.localScale = new Vector3(1.18f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);

   head.transform.localPosition = new Vector3(0.01f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 10;
   Audio.loop = false;
   Audio.clip = ModAPI.LoadSound("Sound/haki sound.mp3");

   arm1.gameObject.AddComponent<Firebeh>();
   arm2.gameObject.AddComponent<Firebeh>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
        body.BaseStrength *= 0.3f;
        body.Health *= 1000f;
        body.BreakingThreshold *= 1f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.01f;
        body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
        body.gameObject.AddComponent<Regeneration>();
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
          body.ImmuneToDamage = true;
          arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0.1f, 0.1f, 0.1f, 1f);
          Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           arm1.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           arm2.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });


    //Sabohat
      var ca = new GameObject("Sabohat");
      ca.transform.SetParent(Instance.transform.Find("Head"));
      ca.transform.localPosition = new Vector3(0, 0f);
      ca.transform.localScale = new Vector3(1f, 1f);
      var caSprite = ca.AddComponent<SpriteRenderer>();
      caSprite.sprite = ModAPI.LoadSprite("image/Sabohat.png");
      ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ca.AddComponent<UseEventTrigger>().Action = () => {
      caSprite.sprite = ModAPI.LoadSprite("none.png");
      };

      var ca2 = new GameObject("Sabocape.png");
      ca2.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
      ca2.transform.localPosition = new Vector3(0, 0f);
      ca2.transform.localScale = new Vector3(1f, 1f);
      var ca2Sprite = ca2.AddComponent<SpriteRenderer>();
      ca2Sprite.sprite = ModAPI.LoadSprite("image/Sabocape.png");
      ca2.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ca2.AddComponent<UseEventTrigger>().Action = () => {
      ca2Sprite.sprite = ModAPI.LoadSprite("none.png");
      };

      var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
      var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


      ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
      ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";




      person.SetBodyTextures(skin, flesh, bone, 1);
      person.SetBruiseColor(255, 153, 000); //main bruise colour. purple-ish by default
      person.SetSecondBruiseColor(255, 051, 0000); //second bruise colour. red by default
      person.SetThirdBruiseColor(255, 000, 000); // third bruise colour. light yellow by default
      person.SetBloodColour(255, 102, 000); // blood clour. dark red by default
      person.SetRottenColour(000, 000, 000); // rotten/zombie colour. light yellow/green by default




                        }
                    }
                }
);
ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = ""+"\n <color=purple>Issho",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = ""+"\n <color=white>Issho, better known by his alias Fujitora, is an admiral in the Marines." + "\n <color=purple>Fujitora",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Isshothumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Issho.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.4f, 1.2f);
   middle.transform.localScale = new Vector3(1.3f, 1.2f);
   Lower.transform.localScale = new Vector3(1.2f, 1f);
   arm3.transform.localScale = new Vector3(1.3f, 1.2f);
   arm4.transform.localScale = new Vector3(1.3f, 1.2f);
   arm1.transform.localScale = new Vector3(1.3f, 1.2f);
   arm2.transform.localScale = new Vector3(1.3f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.02f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();

   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
       body.BaseStrength *= 0.5f;
       body.Health *= 10000000f;
       body.BreakingThreshold *= 100f;
       body.IsAndroid = true;
       body.transform.root.localScale *= 1.02f;
       body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
       body.gameObject.AddComponent<strongrege>();

       var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
       var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


       ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
       ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";



     //scarf2
       var ca = new GameObject("scarf2");
       ca.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
       ca.transform.localPosition = new Vector3(0, 0f);
       ca.transform.localScale = new Vector3(1f, 1f);
       var caSprite = ca.AddComponent<SpriteRenderer>();
       caSprite.sprite = ModAPI.LoadSprite("image/scarf2.png");
       ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
       ca.AddComponent<UseEventTrigger>().Action = () => {
       caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                          };

    //cape17
     var backpack = new GameObject("cape17");
     backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
     backpack.transform.localPosition = new Vector3(0, 0f);
     backpack.transform.localScale = new Vector3(1f, 1f);
     var backpackSprite = backpack.AddComponent<SpriteRenderer>();
     backpackSprite.sprite = ModAPI.LoadSprite("image/cape17.png");
     backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
     backpack.AddComponent<UseEventTrigger>().Action = () => {
     backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                              };

      person.SetBruiseColor(000, 000, 000);
      person.SetSecondBruiseColor(000, 000, 000);
      person.SetThirdBruiseColor(000, 000, 000);
      person.SetBloodColour(000, 000, 000);
      person.SetRottenColour(000, 000, 000);

           }
        }
     }
);

ModAPI.Register(
    new Modification()
        {
   OriginalItem = ModAPI.FindSpawnable("Human"),
   NameOverride = ""+"\n <color=yellow>Borsalino",
   NameToOrderByOverride = "Z1",
   DescriptionOverride = ""+"\n <color=white>Borsalino more commonly known by his alias Kizaru is an admiral in the Marines." + "\n <color=yellow>Kizaru",
   CategoryOverride = ModAPI.FindCategory("One Piece pack"),
   ThumbnailOverride = ModAPI.LoadSprite("image/Borsalinothumbnail.png"),
   AfterSpawn = (Instance) =>
   {

   var skin = ModAPI.LoadTexture("image/Borsalino.png");
   var flesh = ModAPI.LoadTexture("Flesh.png");
   var bone = ModAPI.LoadTexture("Bone.png");


   var person = Instance.GetComponent<PersonBehaviour>();

   var head = Instance.transform.Find("Head");
   var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
   var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
   var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
   var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
   var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
   var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
   var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
   var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
   var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
   var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
   var upper = Instance.transform.Find("Body").Find("UpperBody");
   var middle = Instance.transform.Find("Body").Find("MiddleBody");
   var Lower = Instance.transform.Find("Body").Find("LowerBody");

   upper.transform.localScale = new Vector3(1.4f, 1.2f);
   middle.transform.localScale = new Vector3(1.3f, 1.2f);
   Lower.transform.localScale = new Vector3(1.2f, 1f);
   arm3.transform.localScale = new Vector3(1.3f, 1.2f);
   arm4.transform.localScale = new Vector3(1.3f, 1.2f);
   arm1.transform.localScale = new Vector3(1.3f, 1.2f);
   arm2.transform.localScale = new Vector3(1.3f, 1.2f);
   leg3.transform.localScale = new Vector3(1.19f, 1.2f);
   leg4.transform.localScale = new Vector3(1.19f, 1.2f);
   leg1.transform.localScale = new Vector3(1.19f, 1.2f);
   leg2.transform.localScale = new Vector3(1.19f, 1.2f);
   foot1.transform.localScale = new Vector3(1.19f, 1.2f);
   foot2.transform.localScale = new Vector3(1.19f, 1.2f);
   head.transform.localScale = new Vector3(0.9f, 0.9f);

   head.transform.localPosition = new Vector3(0.02f, 0.73f);
   arm3.transform.localPosition = new Vector3(0f, -0.15f);
   arm4.transform.localPosition = new Vector3(0f, -0.15f);
   arm1.transform.localPosition = new Vector3(0f, -0.60f);
   arm2.transform.localPosition = new Vector3(0f, -0.60f);
   leg3.transform.localPosition = new Vector3(0f, -0.46f);
   leg4.transform.localPosition = new Vector3(0f, -0.46f);
   leg1.transform.localPosition = new Vector3(0f, -0.96f);
   leg2.transform.localPosition = new Vector3(0f, -0.96f);
   foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
   foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

   arm1.gameObject.AddComponent<Busoshoku>();
   arm2.gameObject.AddComponent<Busoshoku>();

   AudioSource Audio = Instance.AddComponent<AudioSource>();
   Audio.maxDistance = 1;
   Audio.loop = true;
   Audio.clip = ModAPI.LoadSound("Sound/kizaruthem.mp3");


   AudioClip Repulsor = ModAPI.LoadSound("beam2.mp3");
   AudioClip beam2 = ModAPI.LoadSound("beam2.mp3");


   arm1.gameObject.AddComponent<GunBeh>();
   arm2.gameObject.AddComponent<GunBeh>();
   foot1.gameObject.AddComponent<GunBeh>();
   foot2.gameObject.AddComponent<GunBeh>();

   foreach (var Limbs in person.Limbs)
   {;

       if (Limbs.GetComponent<GripBehaviour>())
       {
           Limbs.gameObject.AddComponent<UseEventTrigger>().Action = () =>
           {


               AudioSource audio = Limbs.gameObject.AddComponent<AudioSource>();
               audio.spatialBlend = 1;
               audio.PlayOneShot(Repulsor);
           };
       }
   }



   person.SetBodyTextures(skin, flesh, bone, 1);
   foreach (var body in person.Limbs)
    {
       body.BaseStrength *= 0.5f;
       body.Health *= 10000000f;
       body.BreakingThreshold *= 100f;
       body.IsAndroid = true;
       body.transform.root.localScale *= 1.02f;
       body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
       body.gameObject.AddComponent<strongrege>();
       UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger.Event = new UnityEvent();
       useEventTrigger.Event.AddListener(delegate ()
        {
          body.gameObject.layer = 10;
          body.ImmuneToDamage = true;
          body.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(255f, 255f, 0f, 1f);
          head.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(255f, 255f, 0f, 1f);
          Audio.Play();
       });

       UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
       useEventTrigger1.Event = new UnityEvent();
       useEventTrigger1.Event.AddListener(delegate ()
        {
          body.gameObject.layer = 9;
          body.ImmuneToDamage = false;
          body.SkinMaterialHandler.ClearAllDamage();
          body.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          upper.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
          Audio.Stop();
       });




    //cape13
     var backpack = new GameObject("cape13");
     backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
     backpack.transform.localPosition = new Vector3(0, 0f);
     backpack.transform.localScale = new Vector3(1f, 1f);
     var backpackSprite = backpack.AddComponent<SpriteRenderer>();
     backpackSprite.sprite = ModAPI.LoadSprite("image/cape13.png");
     backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
     backpack.AddComponent<UseEventTrigger>().Action = () => {
     backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                              };

      person.SetBruiseColor(255, 255, 000);
      person.SetSecondBruiseColor(255, 255, 102);
      person.SetThirdBruiseColor(255, 255, 153);
      person.SetBloodColour(255, 255, 204);
      person.SetRottenColour(000, 000, 000);

           }
        }
     }
 );

 ModAPI.Register(
     new Modification()
         {
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = ""+"\n <color=blue>Kuzan",
    NameToOrderByOverride = "Z1",
    DescriptionOverride = ""+"\n <color=white>Kuzan better known by his former epithet Aokiji is a Marine admiral and the first one to be revealed." + "\n <color=blue>Aokiji",
    CategoryOverride = ModAPI.FindCategory("One Piece pack"),
    ThumbnailOverride = ModAPI.LoadSprite("image/Kuzanthumnail.png"),
    AfterSpawn = (Instance) =>
    {

    var skin = ModAPI.LoadTexture("image/Kuzan.png");
    var flesh = ModAPI.LoadTexture("Flesh.png");
    var bone = ModAPI.LoadTexture("Bone.png");



    var person = Instance.GetComponent<PersonBehaviour>();

    var head = Instance.transform.Find("Head");
    var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
    var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
    var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
    var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
    var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
    var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
    var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
    var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
    var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
    var upper = Instance.transform.Find("Body").Find("UpperBody");
    var middle = Instance.transform.Find("Body").Find("MiddleBody");
    var Lower = Instance.transform.Find("Body").Find("LowerBody");

    upper.transform.localScale = new Vector3(1.4f, 1.2f);
    middle.transform.localScale = new Vector3(1.3f, 1.2f);
    Lower.transform.localScale = new Vector3(1.2f, 1f);
    arm3.transform.localScale = new Vector3(1.3f, 1.2f);
    arm4.transform.localScale = new Vector3(1.3f, 1.2f);
    arm1.transform.localScale = new Vector3(1.3f, 1.2f);
    arm2.transform.localScale = new Vector3(1.3f, 1.2f);
    leg3.transform.localScale = new Vector3(1.19f, 1.2f);
    leg4.transform.localScale = new Vector3(1.19f, 1.2f);
    leg1.transform.localScale = new Vector3(1.19f, 1.2f);
    leg2.transform.localScale = new Vector3(1.19f, 1.2f);
    foot1.transform.localScale = new Vector3(1.19f, 1.2f);
    foot2.transform.localScale = new Vector3(1.19f, 1.2f);
    head.transform.localScale = new Vector3(0.9f, 0.9f);

    head.transform.localPosition = new Vector3(0.02f, 0.73f);
    arm3.transform.localPosition = new Vector3(0f, -0.15f);
    arm4.transform.localPosition = new Vector3(0f, -0.15f);
    arm1.transform.localPosition = new Vector3(0f, -0.60f);
    arm2.transform.localPosition = new Vector3(0f, -0.60f);
    leg3.transform.localPosition = new Vector3(0f, -0.46f);
    leg4.transform.localPosition = new Vector3(0f, -0.46f);
    leg1.transform.localPosition = new Vector3(0f, -0.96f);
    leg2.transform.localPosition = new Vector3(0f, -0.96f);
    foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
    foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

    arm1.gameObject.AddComponent<Busoshoku>();
    arm2.gameObject.AddComponent<Busoshoku>();

    AudioSource Audio = Instance.AddComponent<AudioSource>();
    Audio.maxDistance = 1;
    Audio.loop = false;
    Audio.clip = ModAPI.LoadSound("Sound/aokijithem.mp3");

    AudioClip Repulsor = ModAPI.LoadSound("iceage.mp3");
    AudioClip beam2 = ModAPI.LoadSound("iceage.mp3");


    arm1.gameObject.AddComponent<ice2>();
    arm2.gameObject.AddComponent<ice2>();

    foreach (var Limbs in person.Limbs)
    {;

        if (Limbs.GetComponent<GripBehaviour>())
        {
            Limbs.gameObject.AddComponent<UseEventTrigger>().Action = () =>
            {


                AudioSource audio = Limbs.gameObject.AddComponent<AudioSource>();
                audio.spatialBlend = 1;
                audio.PlayOneShot(Repulsor);
            };
        }
    }



    person.SetBodyTextures(skin, flesh, bone, 1);
    foreach (var body in person.Limbs)
     {
        body.BaseStrength *= 0.5f;
        body.Health *= 10000000f;
        body.BreakingThreshold *= 100f;
        body.IsAndroid = true;
        body.transform.root.localScale *= 1.02f;
        body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
        body.gameObject.AddComponent<strongrege>();
        body.gameObject.AddComponent<Ice>();
        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger.Event = new UnityEvent();
        useEventTrigger.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = true;
           body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Ice");
           body.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0f, 200f, 200f, 1f);
           head.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0f, 200f, 200f, 1f);
           Audio.Play();
        });

        UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
        useEventTrigger1.Event = new UnityEvent();
        useEventTrigger1.Event.AddListener(delegate ()
         {
           body.ImmuneToDamage = false;
           body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
           body.SkinMaterialHandler.ClearAllDamage();
           body.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           upper.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
           Audio.Play();
        });


    //Kuzan item
      var ca = new GameObject("Kuzan item");
      ca.transform.SetParent(Instance.transform.Find("Head"));
      ca.transform.localPosition = new Vector3(0, 0f);
      ca.transform.localScale = new Vector3(1f, 1f);
      var caSprite = ca.AddComponent<SpriteRenderer>();
      caSprite.sprite = ModAPI.LoadSprite("image/Kuzan item.png");
      ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
      ca.AddComponent<UseEventTrigger>().Action = () => {
      caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                         };



     //cape14
      var backpack = new GameObject("cape14");
      backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
      backpack.transform.localPosition = new Vector3(0, 0f);
      backpack.transform.localScale = new Vector3(1f, 1f);
      var backpackSprite = backpack.AddComponent<SpriteRenderer>();
      backpackSprite.sprite = ModAPI.LoadSprite("image/cape14.png");
      backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
      backpack.AddComponent<UseEventTrigger>().Action = () => {
      backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                               };

       person.SetBruiseColor(255, 255, 255);
       person.SetSecondBruiseColor(000, 000, 153);
       person.SetThirdBruiseColor(255, 255, 255);
       person.SetBloodColour(000, 000, 102);
       person.SetRottenColour(000, 000, 000);

            }
         }
      }
  );

  ModAPI.Register(
          new Modification()
              {
         OriginalItem = ModAPI.FindSpawnable("Human"),
         NameOverride = ""+"\n <color=red>Sakazuki",
         NameToOrderByOverride = "Z1",
         DescriptionOverride = ""+"\n <color=white>Sakazuki formerly known by his admiral alias Akainu is the current fleet admiral of the Marines, succeeding the previous fleet admiral, Sengoku." + "\n <color=red>Akainu",
         CategoryOverride = ModAPI.FindCategory("One Piece pack"),
         ThumbnailOverride = ModAPI.LoadSprite("image/sakazukithumbnail.png"),
         AfterSpawn = (Instance) =>
         {

         var skin = ModAPI.LoadTexture("image/Sakazuki.png");
         var flesh = ModAPI.LoadTexture("Flesh.png");
         var bone = ModAPI.LoadTexture("Bone.png");


         var person = Instance.GetComponent<PersonBehaviour>();

         var head = Instance.transform.Find("Head");
         var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
         var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
         var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
         var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
         var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
         var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
         var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
         var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
         var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
         var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
         var upper = Instance.transform.Find("Body").Find("UpperBody");
         var middle = Instance.transform.Find("Body").Find("MiddleBody");
         var Lower = Instance.transform.Find("Body").Find("LowerBody");

         upper.transform.localScale = new Vector3(1.4f, 1.2f);
         middle.transform.localScale = new Vector3(1.3f, 1.2f);
         Lower.transform.localScale = new Vector3(1.2f, 1f);
         arm3.transform.localScale = new Vector3(1.3f, 1.2f);
         arm4.transform.localScale = new Vector3(1.3f, 1.2f);
         arm1.transform.localScale = new Vector3(1.3f, 1.2f);
         arm2.transform.localScale = new Vector3(1.3f, 1.2f);
         leg3.transform.localScale = new Vector3(1.19f, 1.2f);
         leg4.transform.localScale = new Vector3(1.19f, 1.2f);
         leg1.transform.localScale = new Vector3(1.19f, 1.2f);
         leg2.transform.localScale = new Vector3(1.19f, 1.2f);
         foot1.transform.localScale = new Vector3(1.19f, 1.2f);
         foot2.transform.localScale = new Vector3(1.19f, 1.2f);
         head.transform.localScale = new Vector3(0.9f, 0.9f);

         head.transform.localPosition = new Vector3(0.02f, 0.73f);
         arm3.transform.localPosition = new Vector3(0f, -0.15f);
         arm4.transform.localPosition = new Vector3(0f, -0.15f);
         arm1.transform.localPosition = new Vector3(0f, -0.60f);
         arm2.transform.localPosition = new Vector3(0f, -0.60f);
         leg3.transform.localPosition = new Vector3(0f, -0.46f);
         leg4.transform.localPosition = new Vector3(0f, -0.46f);
         leg1.transform.localPosition = new Vector3(0f, -0.96f);
         leg2.transform.localPosition = new Vector3(0f, -0.96f);
         foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
         foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

         arm1.gameObject.AddComponent<Busoshoku>();
         arm2.gameObject.AddComponent<Busoshoku>();

         AudioSource Audio = Instance.AddComponent<AudioSource>();
         Audio.maxDistance = 1;
         Audio.loop = true;
         Audio.clip = ModAPI.LoadSound("Sound/akainuthem.mp3");

         AudioClip Repulsor = ModAPI.LoadSound("ryusekazan.mp3");
         AudioClip beam2 = ModAPI.LoadSound("ryusekazan.mp3");


         arm1.gameObject.AddComponent<Crush>();
         arm2.gameObject.AddComponent<Crush>();
         arm1.gameObject.AddComponent<Firebeh>();
         arm2.gameObject.AddComponent<Firebeh>();
         arm1.gameObject.AddComponent<mg1>();
         arm2.gameObject.AddComponent<mg1>();

         foreach (var Limbs in person.Limbs)
         {;

             if (Limbs.GetComponent<GripBehaviour>())
             {
                 Limbs.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                 {


                     AudioSource audio = Limbs.gameObject.AddComponent<AudioSource>();
                     audio.spatialBlend = 1;
                     audio.PlayOneShot(Repulsor);
                 };
             }
         }


         person.SetBodyTextures(skin, flesh, bone, 1);
         foreach (var body in person.Limbs)
          {
             body.BaseStrength *= 0.5f;
             body.Health *= 10000000f;
             body.BreakingThreshold *= 100f;
             body.IsAndroid = true;
             body.transform.root.localScale *= 1.02f;
             body.PhysicalBehaviour.BurningProgressionMultiplier = -1000000;
             body.gameObject.AddComponent<luffyrege>();
             UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
             useEventTrigger.Event = new UnityEvent();
             useEventTrigger.Event.AddListener(delegate ()
              {
                body.ImmuneToDamage = true;

                body.gameObject.GetComponent<PhysicalBehaviour>().Temperature = 200f;
                body.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 0.3f, 0f, 1f);
                head.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 0.3f, 0f, 1f);
                Audio.Play();
             });

             UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
             useEventTrigger1.Event = new UnityEvent();
             useEventTrigger1.Event.AddListener(delegate ()
              {
                body.gameObject.GetComponent<PhysicalBehaviour>().Temperature = 37f;
                body.ImmuneToDamage = false;
                body.SkinMaterialHandler.ClearAllDamage();
                body.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
                upper.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
                Audio.Stop();
             });



             var ca = new GameObject("Hat2");
             ca.transform.SetParent(Instance.transform.Find("Head"));
             ca.transform.localPosition = new Vector3(0, 0f);
             ca.transform.localScale = new Vector3(1f, 1f);
             var caSprite = ca.AddComponent<SpriteRenderer>();
             caSprite.sprite = ModAPI.LoadSprite("image/Hat2.png");
             ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
             ca.AddComponent<UseEventTrigger>().Action = () => {
             caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                               };


              var ca2 = new GameObject("akainuflower");
              ca2.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
              ca2.transform.localPosition = new Vector3(0, 0f);
              ca2.transform.localScale = new Vector3(1f, 1f);
              var ca2Sprite = ca2.AddComponent<SpriteRenderer>();
              ca2Sprite.sprite = ModAPI.LoadSprite("image/akainuflower.png");
              ca2.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
              ca2.AddComponent<UseEventTrigger>().Action = () => {
              ca2Sprite.sprite = ModAPI.LoadSprite("none.png");
                                                                 };

          //cape11
           var backpack = new GameObject("cape11");
           backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
           backpack.transform.localPosition = new Vector3(0, 0f);
           backpack.transform.localScale = new Vector3(1f, 1f);
           var backpackSprite = backpack.AddComponent<SpriteRenderer>();
           backpackSprite.sprite = ModAPI.LoadSprite("image/cape11.png");
           backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
           backpack.AddComponent<UseEventTrigger>().Action = () => {
           backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                                    };


            person.SetBruiseColor(153, 000, 000);
            person.SetSecondBruiseColor(204, 000, 000);
            person.SetThirdBruiseColor(204, 000, 000);
            person.SetBloodColour(255, 000, 000);
            person.SetRottenColour(102, 000, 000);

                 }
              }
           }
  );

  ModAPI.Register(
      new Modification()
          {
     OriginalItem = ModAPI.FindSpawnable("Human"),
     NameOverride = ""+"\n <color=blue>Enel",
     NameToOrderByOverride = "Z1",
     DescriptionOverride = ""+"\n <color=white>Enel is the former tyrannical God of Skypiea.",
     CategoryOverride = ModAPI.FindCategory("One Piece pack"),
     ThumbnailOverride = ModAPI.LoadSprite("image/enelthumbnail.png"),
     AfterSpawn = (Instance) =>
     {

     var skin = ModAPI.LoadTexture("image/Enel.png");
     var flesh = ModAPI.LoadTexture("Flesh.png");
     var bone = ModAPI.LoadTexture("Bone.png");


     var person = Instance.GetComponent<PersonBehaviour>();
     var head = Instance.transform.Find("Head");
     var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
     var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
     var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
     var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
     var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
     var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
     var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
     var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
     var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
     var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
     var upper = Instance.transform.Find("Body").Find("UpperBody");
     var middle = Instance.transform.Find("Body").Find("MiddleBody");
     var Lower = Instance.transform.Find("Body").Find("LowerBody");

     upper.transform.localScale = new Vector3(1.3f, 1.2f);
     middle.transform.localScale = new Vector3(1.1f, 1.2f);
     head.transform.localScale = new Vector3(0.9f, 0.9f);
     arm3.transform.localScale = new Vector3(1.18f, 1.2f);
     arm4.transform.localScale = new Vector3(1.18f, 1.2f);
     arm1.transform.localScale = new Vector3(1.18f, 1.2f);
     arm2.transform.localScale = new Vector3(1.18f, 1.2f);
     leg3.transform.localScale = new Vector3(1.19f, 1.2f);
     leg4.transform.localScale = new Vector3(1.19f, 1.2f);
     leg1.transform.localScale = new Vector3(1.19f, 1.2f);
     leg2.transform.localScale = new Vector3(1.19f, 1.2f);
     foot1.transform.localScale = new Vector3(1.19f, 1.2f);
     foot2.transform.localScale = new Vector3(1.19f, 1.2f);

     head.transform.localPosition = new Vector3(0.01f, 0.73f);
     arm3.transform.localPosition = new Vector3(0f, -0.15f);
     arm4.transform.localPosition = new Vector3(0f, -0.15f);
     arm1.transform.localPosition = new Vector3(0f, -0.60f);
     arm2.transform.localPosition = new Vector3(0f, -0.60f);
     leg3.transform.localPosition = new Vector3(0f, -0.46f);
     leg4.transform.localPosition = new Vector3(0f, -0.46f);
     leg1.transform.localPosition = new Vector3(0f, -0.96f);
     leg2.transform.localPosition = new Vector3(0f, -0.96f);
     foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
     foot2.transform.localPosition = new Vector3(0.068f, -1.25f);
     AudioSource Audio = Instance.AddComponent<AudioSource>();
     Audio.maxDistance = 1;
     Audio.loop = true;
     Audio.clip = ModAPI.LoadSound("Sound/enelethem.mp3");

     AudioClip Repulsor = ModAPI.LoadSound("enelthor.mp3");
     AudioClip beam2 = ModAPI.LoadSound("enelthor.mp3");

     arm1.gameObject.AddComponent<Lightning>();
     arm2.gameObject.AddComponent<Lightning>();
     arm1.gameObject.AddComponent<spark>();
     arm2.gameObject.AddComponent<spark>();




     foreach (var Limbs in person.Limbs)
     {;

         if (Limbs.GetComponent<GripBehaviour>())
         {
             Limbs.gameObject.AddComponent<UseEventTrigger>().Action = () =>
             {


                 AudioSource audio = Limbs.gameObject.AddComponent<AudioSource>();
                 audio.spatialBlend = 1;
                 audio.PlayOneShot(Repulsor);
             };
         }
     }


     person.SetBodyTextures(skin, flesh, bone, 1);
     foreach (var body in person.Limbs)
      {
         body.BaseStrength *= 0.4f;
         body.Health *= 1000f;
         body.BreakingThreshold *= 1f;
         body.IsAndroid = true;
         body.transform.root.localScale *= 1.01f;
         body.gameObject.AddComponent<enelrege>();

         UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
         useEventTrigger.Event = new UnityEvent();
         useEventTrigger.Event.AddListener(delegate ()
          {
            body.ImmuneToDamage = true;
            body.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0f, 210f, 210f, 1f);
            head.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0f, 210f, 210f, 1f);
            Audio.Play();
         });

         UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
         useEventTrigger1.Event = new UnityEvent();
         useEventTrigger1.Event.AddListener(delegate ()
          {
            body.ImmuneToDamage = false;
            body.SkinMaterialHandler.ClearAllDamage();
            body.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
            upper.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
            Audio.Stop();
         });

      //cape18
       var backpack = new GameObject("cape18");
       backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
       backpack.transform.localPosition = new Vector3(0, 0f);
       backpack.transform.localScale = new Vector3(1f, 1f);
       var backpackSprite = backpack.AddComponent<SpriteRenderer>();
       backpackSprite.sprite = ModAPI.LoadSprite("image/cape18.png");
       backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
       backpack.AddComponent<UseEventTrigger>().Action = () => {
       backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                                };

       person.SetBruiseColor(000, 255, 255);
       person.SetSecondBruiseColor(000, 051, 204);
       person.SetThirdBruiseColor(51, 051, 255);
       person.SetBloodColour(255, 255, 255);
       person.SetRottenColour(000, 000, 000);


             }
          }
       }
   );

   ModAPI.Register(
       new Modification()
           {
      OriginalItem = ModAPI.FindSpawnable("Human"),
      NameOverride = "Marco",
      NameToOrderByOverride = "Z1",
      DescriptionOverride = "Marco the Phoenix is the former 1st division commander of the Whitebeard Pirates. Once starting out as an apprentice on the crew he had come to be Whitebeard's closest confidant and right-hand ma.",
      CategoryOverride = ModAPI.FindCategory("One Piece pack"),
      ThumbnailOverride = ModAPI.LoadSprite("image/Marcothumbnail.png"),
      AfterSpawn = (Instance) =>
      {

      var skin = ModAPI.LoadTexture("image/Marco.png");
      var flesh = ModAPI.LoadTexture("Flesh.png");
      var bone = ModAPI.LoadTexture("Bone.png");


      var person = Instance.GetComponent<PersonBehaviour>();
      var head = Instance.transform.Find("Head");
      var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
      var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
      var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
      var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
      var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
      var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
      var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
      var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
      var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
      var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
      var upper = Instance.transform.Find("Body").Find("UpperBody");
      var middle = Instance.transform.Find("Body").Find("MiddleBody");
      var Lower = Instance.transform.Find("Body").Find("LowerBody");

      upper.transform.localScale = new Vector3(1.3f, 1.2f);
      middle.transform.localScale = new Vector3(1.1f, 1.2f);
      head.transform.localScale = new Vector3(0.9f, 0.9f);
      arm3.transform.localScale = new Vector3(1.18f, 1.2f);
      arm4.transform.localScale = new Vector3(1.18f, 1.2f);
      arm1.transform.localScale = new Vector3(1.18f, 1.2f);
      arm2.transform.localScale = new Vector3(1.18f, 1.2f);
      leg3.transform.localScale = new Vector3(1.43f, 1.2f);
      leg4.transform.localScale = new Vector3(1.43f, 1.2f);
      leg1.transform.localScale = new Vector3(1.19f, 1.2f);
      leg2.transform.localScale = new Vector3(1.19f, 1.2f);
      foot1.transform.localScale = new Vector3(1.19f, 1.2f);
      foot2.transform.localScale = new Vector3(1.19f, 1.2f);

      head.transform.localPosition = new Vector3(0.01f, 0.73f);
      arm3.transform.localPosition = new Vector3(0f, -0.15f);
      arm4.transform.localPosition = new Vector3(0f, -0.15f);
      arm1.transform.localPosition = new Vector3(0f, -0.60f);
      arm2.transform.localPosition = new Vector3(0f, -0.60f);
      leg3.transform.localPosition = new Vector3(0f, -0.46f);
      leg4.transform.localPosition = new Vector3(0f, -0.46f);
      leg1.transform.localPosition = new Vector3(0f, -0.96f);
      leg2.transform.localPosition = new Vector3(0f, -0.96f);
      foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
      foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

      leg1.gameObject.AddComponent<Busoshoku>();
      leg2.gameObject.AddComponent<Busoshoku>();



      person.SetBodyTextures(skin, flesh, bone, 1);
      foreach (var body in person.Limbs)
       {
          body.BaseStrength *= 0.5f;
          body.Health *= 100f;
          body.BreakingThreshold *= 1f;
          body.IsAndroid = true;
          body.transform.root.localScale *= 1.01f;
          body.gameObject.AddComponent<Regeneration>();




        var ornamentobject = new GameObject("marcohair.png");
        ornamentobject.transform.SetParent(Instance.transform.Find("Head"));
        ornamentobject.transform.localPosition = new Vector3(0f, 0.03f);
        ornamentobject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
        ornamentobject.transform.localScale = new Vector3(1f, 1f);
        var ornamentsprite = ornamentobject.AddComponent<SpriteRenderer>();
        ornamentsprite.sprite = ModAPI.LoadSprite("image/marcohair.png",1f);
        ornamentsprite.sortingLayerName = "Top";

        var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");


        ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

        person.SetBruiseColor(000, 255, 255);
        person.SetSecondBruiseColor(051, 255, 255);
        person.SetThirdBruiseColor(255, 255, 000);
        person.SetBloodColour(255, 255, 255);
        person.SetRottenColour(000, 000, 000);


              }
           }
        }
  );

  ModAPI.Register(
      new Modification()
          {
     OriginalItem = ModAPI.FindSpawnable("Human"),
     NameOverride = "Arlong",
     NameToOrderByOverride = "Z1",
     DescriptionOverride = "Arlong the Saw is a sawshark fish-man. He was the captain of the all fish-man crew (excluding Nami), the Arlong Pirates, a former member of the Sun Pirates.",
     CategoryOverride = ModAPI.FindCategory("One Piece pack"),
     ThumbnailOverride = ModAPI.LoadSprite("image/Arlongthumbnail.png"),
     AfterSpawn = (Instance) =>
     {

     var skin = ModAPI.LoadTexture("image/Arlong.png");
     var flesh = ModAPI.LoadTexture("Flesh.png");
     var bone = ModAPI.LoadTexture("Bone.png");
     var head = Instance.transform.Find("Head");
     var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
     var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
     var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
     var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
     var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
     var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
     var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
     var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
     var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
     var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
     var upper = Instance.transform.Find("Body").Find("UpperBody");
     var middle = Instance.transform.Find("Body").Find("MiddleBody");
     var Lower = Instance.transform.Find("Body").Find("LowerBody");

     upper.transform.localScale = new Vector3(1.3f, 1.2f);
     middle.transform.localScale = new Vector3(1.1f, 1.2f);
     head.transform.localScale = new Vector3(0.9f, 0.9f);
     arm3.transform.localScale = new Vector3(1.18f, 1.2f);
     arm4.transform.localScale = new Vector3(1.18f, 1.2f);
     arm1.transform.localScale = new Vector3(1.18f, 1.2f);
     arm2.transform.localScale = new Vector3(1.18f, 1.2f);
     leg3.transform.localScale = new Vector3(1.43f, 1.2f);
     leg4.transform.localScale = new Vector3(1.43f, 1.2f);
     leg1.transform.localScale = new Vector3(1.19f, 1.2f);
     leg2.transform.localScale = new Vector3(1.19f, 1.2f);
     foot1.transform.localScale = new Vector3(1.19f, 1.2f);
     foot2.transform.localScale = new Vector3(1.19f, 1.2f);

     head.transform.localPosition = new Vector3(0.01f, 0.73f);
     arm3.transform.localPosition = new Vector3(0f, -0.15f);
     arm4.transform.localPosition = new Vector3(0f, -0.15f);
     arm1.transform.localPosition = new Vector3(0f, -0.60f);
     arm2.transform.localPosition = new Vector3(0f, -0.60f);
     leg3.transform.localPosition = new Vector3(0f, -0.46f);
     leg4.transform.localPosition = new Vector3(0f, -0.46f);
     leg1.transform.localPosition = new Vector3(0f, -0.96f);
     leg2.transform.localPosition = new Vector3(0f, -0.96f);
     foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
     foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

     var headyss = Instance.transform.Find("Head");
             var phys12 = headyss.GetComponent<PhysicalBehaviour>();
             var prop12 = ModAPI.FindPhysicalProperties("Human");
             prop12.Sharp = true;
             prop12.SharpAxes = new[]
             {
                 new SharpAxis(Vector2.right, 0f, 0.15f, true, true),
             };
             phys12.Properties = prop12;


     var person = Instance.GetComponent<PersonBehaviour>();
     person.SetBodyTextures(skin, flesh, bone, 1);
     foreach (var body in person.Limbs)
      {
          body.BaseStrength *= 1f;
          body.Health *= 500f;
          body.BreakingThreshold *= 10f;
          body.transform.root.localScale *= 1.01f;

          var ca = new GameObject("Arlonghat.png");
          ca.transform.SetParent(Instance.transform.Find("Head"));
          ca.transform.localPosition = new Vector3(0, 0f);
          ca.transform.localScale = new Vector3(1f, 1f);
          var caSprite = ca.AddComponent<SpriteRenderer>();
          caSprite.sprite = ModAPI.LoadSprite("image/Arlonghat.png");
          ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
          ca.AddComponent<UseEventTrigger>().Action = () => {
          caSprite.sprite = ModAPI.LoadSprite("none.png");
                                                            };

          var ca2 = new GameObject("Arlongfin.png");
          ca2.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
          ca2.transform.localPosition = new Vector3(0, 0f);
          ca2.transform.localScale = new Vector3(1f, 1f);
          var ca2Sprite = ca2.AddComponent<SpriteRenderer>();
          ca2Sprite.sprite = ModAPI.LoadSprite("image/Arlongfin.png");
          ca2.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
          ca2.AddComponent<UseEventTrigger>().Action = () => {
          ca2Sprite.sprite = ModAPI.LoadSprite("none.png");
                                                            };



                          }
                      }
                  }
  );

  ModAPI.Register(
      new Modification()
          {
     OriginalItem = ModAPI.FindSpawnable("Human"),
     NameOverride = "Smoker",
     NameToOrderByOverride = "Z1",
     DescriptionOverride = "Smoker the White Hunter is a Marine officer and the Commander of the G-5 Marine Base,  At some point during the timeskip he was promoted to the rank of vice admiral.",
     CategoryOverride = ModAPI.FindCategory("One Piece pack"),
     ThumbnailOverride = ModAPI.LoadSprite("image/Smokerthumbnail.png"),
     AfterSpawn = (Instance) =>
     {

     var skin = ModAPI.LoadTexture("image/Smoker.png");
     var flesh = ModAPI.LoadTexture("Flesh.png");
     var bone = ModAPI.LoadTexture("Bone.png");

     var head = Instance.transform.Find("Head");
     var arm3 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
     var arm4 = Instance.transform.Find("BackArm").Find("UpperArm");
     var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
     var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
     var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
     var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
     var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
     var leg2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
     var leg3 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
     var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");
     var upper = Instance.transform.Find("Body").Find("UpperBody");
     var middle = Instance.transform.Find("Body").Find("MiddleBody");
     var Lower = Instance.transform.Find("Body").Find("LowerBody");

     upper.transform.localScale = new Vector3(1.3f, 1.2f);
     middle.transform.localScale = new Vector3(1.1f, 1.2f);
     head.transform.localScale = new Vector3(0.9f, 0.9f);
     arm3.transform.localScale = new Vector3(1.18f, 1.2f);
     arm4.transform.localScale = new Vector3(1.18f, 1.2f);
     arm1.transform.localScale = new Vector3(1.18f, 1.2f);
     arm2.transform.localScale = new Vector3(1.18f, 1.2f);
     leg3.transform.localScale = new Vector3(1.19f, 1.2f);
     leg4.transform.localScale = new Vector3(1.19f, 1.2f);
     leg1.transform.localScale = new Vector3(1.19f, 1.2f);
     leg2.transform.localScale = new Vector3(1.19f, 1.2f);
     foot1.transform.localScale = new Vector3(1.19f, 1.2f);
     foot2.transform.localScale = new Vector3(1.19f, 1.2f);

     head.transform.localPosition = new Vector3(0.01f, 0.73f);
     arm3.transform.localPosition = new Vector3(0f, -0.15f);
     arm4.transform.localPosition = new Vector3(0f, -0.15f);
     arm1.transform.localPosition = new Vector3(0f, -0.60f);
     arm2.transform.localPosition = new Vector3(0f, -0.60f);
     leg3.transform.localPosition = new Vector3(0f, -0.46f);
     leg4.transform.localPosition = new Vector3(0f, -0.46f);
     leg1.transform.localPosition = new Vector3(0f, -0.96f);
     leg2.transform.localPosition = new Vector3(0f, -0.96f);
     foot1.transform.localPosition = new Vector3(0.068f, -1.25f);
     foot2.transform.localPosition = new Vector3(0.068f, -1.25f);

     var person = Instance.GetComponent<PersonBehaviour>();
     person.SetBodyTextures(skin, flesh, bone, 1);
     foreach (var body in person.Limbs)
      {
         body.BaseStrength *= 0.3f;
         body.Health *= 700f;
         body.BreakingThreshold *= 1f;
         body.IsAndroid = true;
         body.transform.root.localScale *= 1f;
         body.gameObject.AddComponent<Regeneration>();

         UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
         useEventTrigger.Event = new UnityEvent();
         useEventTrigger.Event.AddListener(delegate ()
          {
            body.ImmuneToDamage = true;
            body.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(255f, 255f, 255f, 1f);
            head.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(255f, 255f, 255f, 1f);

         });

         UseEventTrigger useEventTrigger1 = upper.gameObject.AddComponent<UseEventTrigger>();
         useEventTrigger1.Event = new UnityEvent();
         useEventTrigger1.Event.AddListener(delegate ()
          {
            body.ImmuneToDamage = false;
            body.SkinMaterialHandler.ClearAllDamage();
            body.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
            upper.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);

         });


      //cape15
       var backpack = new GameObject("cape15");
       backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
       backpack.transform.localPosition = new Vector3(0, 0f);
       backpack.transform.localScale = new Vector3(1f, 1f);
       var backpackSprite = backpack.AddComponent<SpriteRenderer>();
       backpackSprite.sprite = ModAPI.LoadSprite("image/cape15.png");
       backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
       backpack.AddComponent<UseEventTrigger>().Action = () => {
       backpackSprite.sprite = ModAPI.LoadSprite("none.png");

                                                               };

     //Smokertobacco
       var ca = new GameObject("Smokertobacco");
       ca.transform.SetParent(Instance.transform.Find("Head"));
       ca.transform.localPosition = new Vector3(0, 0f);
       ca.transform.localScale = new Vector3(1f, 1f);
       var caSprite = ca.AddComponent<SpriteRenderer>();
       caSprite.sprite = ModAPI.LoadSprite("image/Smokertobacco.png");
       ca.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
       ca.AddComponent<UseEventTrigger>().Action = () => {
       caSprite.sprite = ModAPI.LoadSprite("none.png");
      };


      person.SetBodyTextures(skin, flesh, bone, 1);
      person.SetBruiseColor(255, 255, 255);
      person.SetSecondBruiseColor(204, 204, 204);
      person.SetThirdBruiseColor(255, 255, 255);
      person.SetBloodColour(204, 204, 204);
      person.SetRottenColour(255, 255, 255);



             }
          }
        }
);



ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Kokutou Yoru", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Yoru is one of the strongest swords in the world, ranked as one of the 12 Supreme Grade swords. It is a Black Blade that is currently owned by Dracule Mihawk, the Strongest Swordsman in the World.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/KokutouYoruthumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Kokutou Yoru.png", 4f);
            Instance.FixColliders();
            Instance.gameObject.AddComponent<Busoshoku>();
            Instance.GetComponent<PhysicalBehaviour>().Charge = 0f;
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
            {
            Instance.GetComponent<PhysicalBehaviour>().Charge = 2000f;
            });

            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;


            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };




              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };

        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Knife"), //item to derive from
        NameOverride = "Kogatana", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Dracule Mihawk's Meal Tools or Dagger.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Kogatana thumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Kogatana.png", 4f);
                                        Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Flintlock Pistol"),
        NameOverride = "Marine Rifles",
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Marine Rifles",
        CategoryOverride = ModAPI.FindCategory("One Piece pack"),
        ThumbnailOverride = ModAPI.LoadSprite("image/MarineRiflesthumbnail.png"),
        AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("image/MarineRifles.png");//This line gets the component of the SpriteRenderer and overrides it by looking in the files. The 2f is the scale of the sprite.

            //Colliders

            foreach (var c in Instance.GetComponents<Collider2D>())
            {
                GameObject.Destroy(c);
            }

            var stock = Instance.AddComponent<BoxCollider2D>();
            stock.offset = new Vector2(0.544f, 0.056f);
            stock.size = new Vector2(1.196f, 0.091f);

            var main = Instance.AddComponent<BoxCollider2D>();
            main.offset = new Vector2(-0.183f, 0.029f);
            main.size = new Vector2(0.256f, 0.143f);

            var barrel = Instance.AddComponent<BoxCollider2D>();
            barrel.offset = new Vector2(-0.467f, -0.034f);
            barrel.size = new Vector2(0.312f, 0.157f);



            //Firearm
            Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(1.1433f, 0.0833f);
            Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.03f;
            var customCartridge = UnityEngine.Object.Instantiate(Instance.GetComponent<FirearmBehaviour>().Cartridge);
            customCartridge.Recoil *= 1.2f;
            customCartridge.Damage *= 1.2f;
            customCartridge.ImpactForce *= 1.2f;
            Instance.GetComponent<FirearmBehaviour>().Cartridge = customCartridge;


            ModAPI.KeepExtraObjects();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
        NameOverride = "Smoker jitte", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "The Nanashaku Jitte is Smoker's primary weapon.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Nanashaku Jitte.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Jitte.png", 2.8f);
            Instance.FixColliders();
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
            Instance.gameObject.AddComponent<Busoshoku>();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Image/Jittehakiskin.png", 2.8f);
            Instance.GetComponent<Brighten>().Colour = new Color32(255, 255, 255, 255);
            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Enma", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Enma is one of the 21 Great Grade swords. It was once wielded by Kozuki Oden alongside his other blade, Ame no Habakiri, and both swords were the only weapons (until the present day) ever to injure Kaido.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Enmathumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Enma.png", 2.8f);
            Instance.gameObject.AddComponent<Busoshoku>();
            Instance.gameObject.AddComponent<Haoshoku>();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Image/Enmahakiskin.png", 2.8f);
            Instance.GetComponent<Brighten>().Colour = new Color32(255, 255, 255, 255);
            Instance.FixColliders();
            Instance.GetComponent<PhysicalBehaviour>().Charge = 0f;
            Instance.FixColliders();
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
            {
            Instance.GetComponent<PhysicalBehaviour>().Charge = 2000f;
            });

            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);





                    };
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Ame no Habakiri", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Ame no Habakiri is one of the 21 Great Grade swords. It was once wielded by Kozuki Oden alongside his other blade, Enma, and both swords were the only weapons (until the present day) ever to injure Kaido.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Amenohabakirithumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Amenohabakiri.png", 2.8f);
            Instance.gameObject.AddComponent<Busoshoku>();
            Instance.gameObject.AddComponent<Haoshoku>();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Image/Amenohabakirihakiskin.png", 2.8f);
            Instance.GetComponent<Brighten>().Colour = new Color32(255, 255, 255, 255);
            Instance.FixColliders();
            Instance.GetComponent<PhysicalBehaviour>().Charge = 0f;
            Instance.FixColliders();
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
            {
            Instance.GetComponent<PhysicalBehaviour>().Charge = 2000f;
            });

            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Ace", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Ace is a cutlass that was owned and wielded by the Pirate King Gol D. Roger, serving as his trademark weapon. It ranks as one of the 12 Supreme Grade Meito.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Acethumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Ace.png", 3.7f);
            Instance.gameObject.AddComponent<Haoshoku>();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Image/Acehakiskin.png", 3.7f);
            Instance.GetComponent<Brighten>().Colour = new Color32(255, 255, 255, 255);
            Instance.FixColliders();
            Instance.GetComponent<PhysicalBehaviour>().Charge = 0f;
            Instance.FixColliders();
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
            {
            Instance.GetComponent<PhysicalBehaviour>().Charge = 2000f;
            });

            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };

        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Murakumogiri", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Murakumogiri is a naginata and one of the 12 Supreme Grade swords,It is a weapon used by the world's best man Edward Newgate.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Murakumogirithumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Murakumogiri.png", 5f);
                                        Instance.FixColliders();
            Instance.gameObject.AddComponent<Busoshoku>();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Image/Murakumogirihakiskin2.png", 5f);
            Instance.GetComponent<Brighten>().Colour = new Color32(255, 255, 255, 255);
            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };

        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Issho Sword", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Sword of Admiral Issho.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/isshopswordthumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Issho Sword.png", 3.7f);
            Instance.FixColliders();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Image/Issho Swordhakiskin.png", 3.7f);
            Instance.GetComponent<Brighten>().Colour = new Color32(255, 255, 255, 255);
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
            {
            Instance.GetComponent<PhysicalBehaviour>().Charge = 2000f;
            });

            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };




              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };

                                        Instance.gameObject.AddComponent<Busoshoku>();

        }
    }
);


ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Soul Solid", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Soul Solid is the name of Brook's cane sword.Since he only gave the name of the sword after the timeskip, it is unknown if his sword always carried this name.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Soul Solidthumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Soul Solid.png", 3.7f);
                                        Instance.FixColliders();
                                        Instance.gameObject.AddComponent<Busoshoku>();

        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
        NameOverride = "Sabo's pipe", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Sabo's pipe.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Sabo's pipethumbnamil.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Sabo's pipe.png", 3.8f);
            Instance.FixColliders();
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
            Instance.gameObject.AddComponent<Busoshoku>();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Image/Sabo's pipehakiskin.png", 3.8f);
            Instance.GetComponent<Brighten>().Colour = new Color32(255, 255, 255, 255);
            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };

        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Shusui", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Shusui is one of the 21 Great Grade swords and a Black Sword/Blade, It boasts tremendous durability.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Shusuithumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Shusui.png", 4.5f);
            Instance.FixColliders();
            Instance.gameObject.AddComponent<Busoshoku>();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Image/Shusuihakiskin.png", 4.5f);
            Instance.GetComponent<Brighten>().Colour = new Color32(255, 255, 255, 255);
            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;


            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Enma Z", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Enma is one of the 21 Great Grade swords, currently in the possession of Roronoa Zoro as one of his three blades.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Enmazthumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Enma Z.png", 4.5f);
            Instance.FixColliders();
            Instance.gameObject.AddComponent<Busoshoku>();
            Instance.gameObject.AddComponent<Haoshoku>();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Image/Enma Zhakiskin.png", 4.5f);
            Instance.GetComponent<Brighten>().Colour = new Color32(255, 255, 255, 255);
            Instance.GetComponent<PhysicalBehaviour>().Charge = 0f;
            Instance.FixColliders();
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
            {
            Instance.GetComponent<PhysicalBehaviour>().Charge = 2000f;
            });

            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);





                    };
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Wado Ichimonji", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "The Wado Ichimonji is a sword of great personal importance to Roronoa Zoro, and it once belonged to Kuina and her family. It is also one of the 21 Great Grade swords.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Wado Ichimonjithumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Wado Ichimonji.png", 4.5f);
            Instance.FixColliders();
            Instance.gameObject.AddComponent<Busoshoku>();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Image/Wado Ichimonjihakiskin.png", 4.5f);
            Instance.GetComponent<Brighten>().Colour = new Color32(255, 255, 255, 255);
            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Sandai Kitetsu", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "The Sandai Kitetsu is one of the Grade swords. Like all of its predecessor Kitetsu swords, this one is said to be cursed. It is one of Tenguyama Hitetsu's creations.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Sandai Kitetsuthumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Sandai Kitetsu.png", 4.5f);
            Instance.FixColliders();
            Instance.gameObject.AddComponent<Busoshoku>();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Image/Sandai Kitetsuhakiskin.png", 4.5f);
            Instance.GetComponent<Brighten>().Colour = new Color32(255, 255, 255, 255);
            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };

        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Kikoku", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Kikoku is the name of Trafalgar Law's sword. It is a cursed sword, though is not a ranked blade.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Kikokuthumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Kikoku.png", 4.5f);
                                        Instance.FixColliders();
                                        Instance.gameObject.AddComponent<Busoshoku>();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Gryphon", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "The Sword of Shanks, one of the Four Emperors,Gryphon is a durable and powerful sword.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Gryphonthumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Gryphon.png", 3.8f);
            Instance.gameObject.AddComponent<Busoshoku>();
            Instance.gameObject.AddComponent<Haoshoku>();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Image/Gryphonhakiskin.png", 3.8f);
            Instance.GetComponent<Brighten>().Colour = new Color32(255, 255, 255, 255);
            Instance.FixColliders();
            Instance.GetComponent<PhysicalBehaviour>().Charge = 0f;
            Instance.FixColliders();
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
            {
            Instance.GetComponent<PhysicalBehaviour>().Charge = 2000f;
            });

            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Murakumogiri E", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Murakumogiri is a naginata and one of the 12 Supreme Grade swords,It is a weapon used by the world's best man Edward Newgate.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Murakumogirithumbnail E.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Murakumogiri E.png", 1.8f);
            Instance.gameObject.AddComponent<Haoshoku>();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Image/Murakumogirihakiskin.png", 1.8f);
            Instance.GetComponent<Brighten>().Colour = new Color32(255, 255, 255, 255);
            Instance.FixColliders();
            Instance.GetComponent<PhysicalBehaviour>().Charge = 0f;
            Instance.FixColliders();
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
            {
            Instance.GetComponent<PhysicalBehaviour>().Charge = 2000f;
            });

            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };

        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Kaidos kanabo", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Kaido's great weapon.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Kaido’s kanabothumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Kaido’s kanabo.png", 1.1f);
            Instance.FixColliders();
            Instance.gameObject.AddComponent<Haoshoku>();
            Instance.GetOrAddComponent<Brighten>().PaintSprite = ModAPI.LoadSprite("Image/Kaido’s kanabohakiskin.png", 1.1f);
            Instance.GetComponent<Brighten>().Colour = new Color32(255, 255, 255, 255);
            Instance.GetComponent<PhysicalBehaviour>().Charge = 0f;
            Instance.FixColliders();
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
          {
            Instance.GetComponent<PhysicalBehaviour>().Charge = 1000f;
          });

            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
       {
            ModAPI.LoadSound("Thunder Bagua.mp3"),
       };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };

        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Yamato's kanabo", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Yamato's kanabo, Yamato wields a giant kanabo club much like Kaidou, though hers is studded and more slender, while Kaidou's is spiked and a bit thicker.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Yamato’s kanabothumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Yamato’s kanabo.png", 3.4f);
            Instance.gameObject.AddComponent<Haoshoku>();
            Instance.FixColliders();
            Instance.GetComponent<PhysicalBehaviour>().Charge = 0f;
            Instance.FixColliders();
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
            {
            Instance.GetComponent<PhysicalBehaviour>().Charge = 2000f;
            });

            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/Thunder Bagua2.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };


        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Mogura", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Mogura is a trident, with its three prongs tightly together. The middle prong is a full spear-shape, while the two on the sides are half-blades.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Mogurathumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Mogu.png", 2.5f);
                                        Instance.FixColliders();
                                        Instance.gameObject.AddComponent<Busoshoku>();

        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Napoleon P", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Napoleon the Bicorne is a homie taking the form of a bicorne hat that is worn by Big Mom. It can also become a sword that Big Mom uses in combat.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Napoleon Pthumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Napoleon P.png", 5f);
                                        Instance.FixColliders();
                                        Instance.gameObject.AddComponent<Busoshoku>();
            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
       {
            ModAPI.LoadSound("napoleon bgm.mp3"),
      };


            Instance.FixColliders();

            Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
               };

        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Napoleon B", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Kaido's great weapon.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Napoleon Bthumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Napoleon B.png", 1.3f);
            Instance.FixColliders();
            Instance.gameObject.AddComponent<Haoshoku>();
            Instance.gameObject.AddComponent<Busoshoku>();
            Instance.GetComponent<PhysicalBehaviour>().Charge = 0f;
            Instance.FixColliders();
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
          {
            Instance.GetComponent<PhysicalBehaviour>().Charge = 1000f;
          });

            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
       {
            ModAPI.LoadSound("napoleon bgm.mp3"),
       };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };

        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Oto", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Cherry Ten,Oto and Kogarashi are a pair of double-edged swords wielded by Golden Lion Shiki.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Otothumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Oto.png", 2.8f);
            Instance.gameObject.AddComponent<Busoshoku>();
            Instance.FixColliders();
            Instance.GetComponent<PhysicalBehaviour>().Charge = 0f;
            Instance.FixColliders();
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
            {
            Instance.GetComponent<PhysicalBehaviour>().Charge = 2000f;
            });

            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Kogarashi", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Winter Wind,Oto and Kogarashi are a pair of double-edged swords wielded by Golden Lion Shiki.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Kogarashithumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Kogarashi.png", 2.8f);
            Instance.gameObject.AddComponent<Busoshoku>();
            Instance.FixColliders();
            Instance.GetComponent<PhysicalBehaviour>().Charge = 0f;
            Instance.FixColliders();
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
            {
            Instance.GetComponent<PhysicalBehaviour>().Charge = 2000f;
            });

            AudioSource AS = Instance.AddComponent<AudioSource>();
                                                    AS.minDistance = 1;
                                                    AS.maxDistance = 5;




            int index = 0;
            AudioClip[] AudioData = new AudioClip[]
            {
            ModAPI.LoadSound("Sound/haki sound.mp3"),
            };


            Instance.FixColliders();

              Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    AS.clip = AudioData[index];
                    AS.Play();
                    };

                    Instance.AddComponent<UseEventTrigger>().Action = () => {
                      //spawn an effect by the name of "Spark" at the transform position
                      ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                    };
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Spear"), //item to derive from
        NameOverride = "Yubashiri", //new item name with a suffix to assure it is globally unique
        NameToOrderByOverride = "Z1",
        DescriptionOverride = "Yubashiri was one of the 50 Skillful Grade swords. Roronoa Zoro obtained this sword for free from Ipponmatsu.", //new item description
        CategoryOverride = ModAPI.FindCategory("One Piece pack"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Image/Yubashirithumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Image/Yubashiri.png", 4.5f);
                                        Instance.FixColliders();
                                        Instance.gameObject.AddComponent<Busoshoku>();
        }
    }
);

       }


       public static void OnLoad()
       {
          powersprites.pellet = ModAPI.LoadSprite("image/meteoric volcano.png", 5f);

          powersprites.py = ModAPI.LoadSprite("image/python.png");

          powersprites.PadCannon = ModAPI.LoadSprite("image/ThrustPadCannon.png");

       }

       public class Brighten : MonoBehaviour
       {
           public bool Activated = false;
           public GameObject Paint = new GameObject("Lighter");
           public Color32 Colour;
           public float TargetCharge = 0f;
           public Sprite PaintSprite;
           public LightSprite Light;

           public void UpdateGlow()
           {
               if(Activated == true)
               {
                   Paint.GetComponent<SpriteRenderer>().color = Colour;
               }
               else if(Activated == false)
               {

                   Paint.GetComponent<SpriteRenderer>().color = new Color32(0, 0, 0, 0);
               }
           }

           void Start()
           {
               Paint.transform.parent = gameObject.transform;
               Paint.transform.rotation = gameObject.transform.rotation;
               Paint.transform.localPosition = new Vector3(0f, 0f);
               Paint.transform.localScale = new Vector3(1f, 1f);

               var Sprite = Paint.GetOrAddComponent<SpriteRenderer>();
               Sprite.sprite = PaintSprite;
               Sprite.material = ModAPI.FindMaterial("Sprites-Default");
               Sprite.GetComponent<SpriteRenderer>().sortingLayerName = "thickness";
               Sprite.color = new Color32(1, 1, 1, 1);

               Sprite.sortingOrder = gameObject.GetComponent<SpriteRenderer>().sortingOrder = +50;

               Light = ModAPI.CreateLight(gameObject.transform, new Color32(Colour.r, Colour.g, Colour.b, 255), 3f, 0f);
               UpdateGlow();
           }

           void Use()
           {
               Activated = !Activated;
               UpdateGlow();
           }

           void Update()
           {
               if(Activated == true)
               {
               }
               else
               {
               }
           }


       }




    }
 }
